/**
 * Ory APIs
 * Documentation for all public and administrative Ory APIs. Administrative APIs can only be accessed with a valid Personal Access Token. Public APIs are mostly used in browsers.
 *
 * The version of the OpenAPI document: v0.0.1-alpha.189
 * Contact: support@ory.sh
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { Configuration } from './configuration';
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { RequestArgs, BaseAPI } from './base';
/**
 * The Active Project ID
 * @export
 * @interface ActiveProject
 */
export interface ActiveProject {
    /**
     * The Active Project ID  format: uuid
     * @type {string}
     * @memberof ActiveProject
     */
    'project_id'?: string;
}
/**
 *
 * @export
 * @interface AdminCreateIdentityBody
 */
export interface AdminCreateIdentityBody {
    /**
     *
     * @type {AdminIdentityImportCredentials}
     * @memberof AdminCreateIdentityBody
     */
    'credentials'?: AdminIdentityImportCredentials;
    /**
     * Store metadata about the user which is only accessible through admin APIs such as `GET /admin/identities/<id>`.
     * @type {any}
     * @memberof AdminCreateIdentityBody
     */
    'metadata_admin'?: any;
    /**
     * Store metadata about the identity which the identity itself can see when calling for example the session endpoint. Do not store sensitive information (e.g. credit score) about the identity in this field.
     * @type {any}
     * @memberof AdminCreateIdentityBody
     */
    'metadata_public'?: any;
    /**
     * RecoveryAddresses contains all the addresses that can be used to recover an identity.  Use this structure to import recovery addresses for an identity. Please keep in mind that the address needs to be represented in the Identity Schema or this field will be overwritten on the next identity update.
     * @type {Array<RecoveryAddress>}
     * @memberof AdminCreateIdentityBody
     */
    'recovery_addresses'?: Array<RecoveryAddress>;
    /**
     * SchemaID is the ID of the JSON Schema to be used for validating the identity\'s traits.
     * @type {string}
     * @memberof AdminCreateIdentityBody
     */
    'schema_id': string;
    /**
     *
     * @type {IdentityState}
     * @memberof AdminCreateIdentityBody
     */
    'state'?: IdentityState;
    /**
     * Traits represent an identity\'s traits. The identity is able to create, modify, and delete traits in a self-service manner. The input will always be validated against the JSON Schema defined in `schema_url`.
     * @type {object}
     * @memberof AdminCreateIdentityBody
     */
    'traits': object;
    /**
     * VerifiableAddresses contains all the addresses that can be verified by the user.  Use this structure to import verified addresses for an identity. Please keep in mind that the address needs to be represented in the Identity Schema or this field will be overwritten on the next identity update.
     * @type {Array<VerifiableIdentityAddress>}
     * @memberof AdminCreateIdentityBody
     */
    'verifiable_addresses'?: Array<VerifiableIdentityAddress>;
}
/**
 *
 * @export
 * @interface AdminCreateIdentityImportCredentialsOidc
 */
export interface AdminCreateIdentityImportCredentialsOidc {
    /**
     *
     * @type {AdminCreateIdentityImportCredentialsOidcConfig}
     * @memberof AdminCreateIdentityImportCredentialsOidc
     */
    'config'?: AdminCreateIdentityImportCredentialsOidcConfig;
}
/**
 *
 * @export
 * @interface AdminCreateIdentityImportCredentialsOidcConfig
 */
export interface AdminCreateIdentityImportCredentialsOidcConfig {
    /**
     *
     * @type {AdminCreateIdentityImportCredentialsPasswordConfig}
     * @memberof AdminCreateIdentityImportCredentialsOidcConfig
     */
    'config'?: AdminCreateIdentityImportCredentialsPasswordConfig;
    /**
     * A list of OpenID Connect Providers
     * @type {Array<AdminCreateIdentityImportCredentialsOidcProvider>}
     * @memberof AdminCreateIdentityImportCredentialsOidcConfig
     */
    'providers'?: Array<AdminCreateIdentityImportCredentialsOidcProvider>;
}
/**
 *
 * @export
 * @interface AdminCreateIdentityImportCredentialsOidcProvider
 */
export interface AdminCreateIdentityImportCredentialsOidcProvider {
    /**
     * The OpenID Connect provider to link the subject to. Usually something like `google` or `github`.
     * @type {string}
     * @memberof AdminCreateIdentityImportCredentialsOidcProvider
     */
    'provider': string;
    /**
     * The subject (`sub`) of the OpenID Connect connection. Usually the `sub` field of the ID Token.
     * @type {string}
     * @memberof AdminCreateIdentityImportCredentialsOidcProvider
     */
    'subject': string;
}
/**
 *
 * @export
 * @interface AdminCreateIdentityImportCredentialsPassword
 */
export interface AdminCreateIdentityImportCredentialsPassword {
    /**
     *
     * @type {AdminCreateIdentityImportCredentialsPasswordConfig}
     * @memberof AdminCreateIdentityImportCredentialsPassword
     */
    'config'?: AdminCreateIdentityImportCredentialsPasswordConfig;
}
/**
 *
 * @export
 * @interface AdminCreateIdentityImportCredentialsPasswordConfig
 */
export interface AdminCreateIdentityImportCredentialsPasswordConfig {
    /**
     * The hashed password in [PHC format]( https://www.ory.sh/docs/kratos/concepts/credentials/username-email-password#hashed-password-format)
     * @type {string}
     * @memberof AdminCreateIdentityImportCredentialsPasswordConfig
     */
    'hashed_password'?: string;
    /**
     * The password in plain text if no hash is available.
     * @type {string}
     * @memberof AdminCreateIdentityImportCredentialsPasswordConfig
     */
    'password'?: string;
}
/**
 *
 * @export
 * @interface AdminCreateSelfServiceRecoveryLinkBody
 */
export interface AdminCreateSelfServiceRecoveryLinkBody {
    /**
     * Link Expires In  The recovery link will expire at that point in time. Defaults to the configuration value of `selfservice.flows.recovery.request_lifespan`.
     * @type {string}
     * @memberof AdminCreateSelfServiceRecoveryLinkBody
     */
    'expires_in'?: string;
    /**
     *
     * @type {string}
     * @memberof AdminCreateSelfServiceRecoveryLinkBody
     */
    'identity_id': string;
}
/**
 *
 * @export
 * @interface AdminIdentityImportCredentials
 */
export interface AdminIdentityImportCredentials {
    /**
     *
     * @type {AdminCreateIdentityImportCredentialsOidc}
     * @memberof AdminIdentityImportCredentials
     */
    'oidc'?: AdminCreateIdentityImportCredentialsOidc;
    /**
     *
     * @type {AdminCreateIdentityImportCredentialsPassword}
     * @memberof AdminIdentityImportCredentials
     */
    'password'?: AdminCreateIdentityImportCredentialsPassword;
}
/**
 *
 * @export
 * @interface AdminUpdateIdentityBody
 */
export interface AdminUpdateIdentityBody {
    /**
     * Store metadata about the user which is only accessible through admin APIs such as `GET /admin/identities/<id>`.
     * @type {any}
     * @memberof AdminUpdateIdentityBody
     */
    'metadata_admin'?: any;
    /**
     * Store metadata about the identity which the identity itself can see when calling for example the session endpoint. Do not store sensitive information (e.g. credit score) about the identity in this field.
     * @type {any}
     * @memberof AdminUpdateIdentityBody
     */
    'metadata_public'?: any;
    /**
     * SchemaID is the ID of the JSON Schema to be used for validating the identity\'s traits. If set will update the Identity\'s SchemaID.
     * @type {string}
     * @memberof AdminUpdateIdentityBody
     */
    'schema_id': string;
    /**
     *
     * @type {IdentityState}
     * @memberof AdminUpdateIdentityBody
     */
    'state': IdentityState;
    /**
     * Traits represent an identity\'s traits. The identity is able to create, modify, and delete traits in a self-service manner. The input will always be validated against the JSON Schema defined in `schema_id`.
     * @type {object}
     * @memberof AdminUpdateIdentityBody
     */
    'traits': object;
}
/**
 *
 * @export
 * @interface ApiToken
 */
export interface ApiToken {
    /**
     *
     * @type {string}
     * @memberof ApiToken
     */
    'id': string;
    /**
     * The Token\'s Name  Set this to help you remember, for example, where you use the token.
     * @type {string}
     * @memberof ApiToken
     */
    'name': string;
    /**
     *
     * @type {string}
     * @memberof ApiToken
     */
    'owner_id': string;
    /**
     *
     * @type {string}
     * @memberof ApiToken
     */
    'project_id'?: string;
    /**
     * The token\'s value
     * @type {string}
     * @memberof ApiToken
     */
    'value'?: string;
}
/**
 * The authenticator assurance level can be one of \"aal1\", \"aal2\", or \"aal3\". A higher number means that it is harder for an attacker to compromise the account.  Generally, \"aal1\" implies that one authentication factor was used while AAL2 implies that two factors (e.g. password + TOTP) have been used.  To learn more about these levels please head over to: https://www.ory.sh/kratos/docs/concepts/credentials
 * @export
 * @enum {string}
 */
export declare const AuthenticatorAssuranceLevel: {
    readonly Aal0: "aal0";
    readonly Aal1: "aal1";
    readonly Aal2: "aal2";
    readonly Aal3: "aal3";
};
export declare type AuthenticatorAssuranceLevel = typeof AuthenticatorAssuranceLevel[keyof typeof AuthenticatorAssuranceLevel];
/**
 *
 * @export
 * @interface CloudAccount
 */
export interface CloudAccount {
    /**
     *
     * @type {string}
     * @memberof CloudAccount
     */
    'email'?: string;
    /**
     *
     * @type {string}
     * @memberof CloudAccount
     */
    'id'?: string;
    /**
     *
     * @type {string}
     * @memberof CloudAccount
     */
    'name'?: string;
}
/**
 *
 * @export
 * @interface CnameSettings
 */
export interface CnameSettings {
    /**
     *
     * @type {string}
     * @memberof CnameSettings
     */
    'cookie_domain'?: string;
    /**
     *
     * @type {Array<string>}
     * @memberof CnameSettings
     */
    'cors_allowed_origins'?: Array<string>;
    /**
     *
     * @type {boolean}
     * @memberof CnameSettings
     */
    'cors_enabled'?: boolean;
    /**
     *
     * @type {string}
     * @memberof CnameSettings
     */
    'created_at'?: string;
    /**
     *
     * @type {string}
     * @memberof CnameSettings
     */
    'hostname'?: string;
    /**
     *
     * @type {string}
     * @memberof CnameSettings
     */
    'id'?: string;
    /**
     *
     * @type {string}
     * @memberof CnameSettings
     */
    'updated_at'?: string;
    /**
     *
     * @type {Array<string>}
     * @memberof CnameSettings
     */
    'verification_errors'?: Array<string>;
    /**
     * CustomHostnameStatus is the enumeration of valid state values in the CustomHostnameSSL
     * @type {string}
     * @memberof CnameSettings
     */
    'verification_status'?: string;
}
/**
 *
 * @export
 * @interface CreateCustomHostnameBody
 */
export interface CreateCustomHostnameBody {
    /**
     * The domain where cookies will be set. Has to be a parent domain of the custom hostname to work.
     * @type {string}
     * @memberof CreateCustomHostnameBody
     */
    'cookie_domain'?: string;
    /**
     * CORS Allowed origins for the custom hostname.
     * @type {Array<string>}
     * @memberof CreateCustomHostnameBody
     */
    'cors_allowed_origins'?: Array<string>;
    /**
     * CORS Enabled for the custom hostname.
     * @type {boolean}
     * @memberof CreateCustomHostnameBody
     */
    'cors_enabled'?: boolean;
    /**
     * The custom hostname where the API will be exposed.
     * @type {string}
     * @memberof CreateCustomHostnameBody
     */
    'hostname'?: string;
}
/**
 *
 * @export
 * @interface CreateProjectBody
 */
export interface CreateProjectBody {
    /**
     * The name of the project to be created
     * @type {string}
     * @memberof CreateProjectBody
     */
    'name': string;
}
/**
 *
 * @export
 * @interface CreateSubscriptionPayload
 */
export interface CreateSubscriptionPayload {
    /**
     *
     * @type {string}
     * @memberof CreateSubscriptionPayload
     */
    'plan_or_price': string;
    /**
     *
     * @type {string}
     * @memberof CreateSubscriptionPayload
     */
    'provision_first_project': string;
    /**
     *
     * @type {string}
     * @memberof CreateSubscriptionPayload
     */
    'return_to'?: string;
}
/**
 *
 * @export
 * @interface ErrorAuthenticatorAssuranceLevelNotSatisfied
 */
export interface ErrorAuthenticatorAssuranceLevelNotSatisfied {
    /**
     * The status code
     * @type {number}
     * @memberof ErrorAuthenticatorAssuranceLevelNotSatisfied
     */
    'code'?: number;
    /**
     * Debug information  This field is often not exposed to protect against leaking sensitive information.
     * @type {string}
     * @memberof ErrorAuthenticatorAssuranceLevelNotSatisfied
     */
    'debug'?: string;
    /**
     * Further error details
     * @type {{ [key: string]: object; }}
     * @memberof ErrorAuthenticatorAssuranceLevelNotSatisfied
     */
    'details'?: {
        [key: string]: object;
    };
    /**
     * The error ID  Useful when trying to identify various errors in application logic.
     * @type {string}
     * @memberof ErrorAuthenticatorAssuranceLevelNotSatisfied
     */
    'id'?: string;
    /**
     * Error message  The error\'s message.
     * @type {string}
     * @memberof ErrorAuthenticatorAssuranceLevelNotSatisfied
     */
    'message': string;
    /**
     * A human-readable reason for the error
     * @type {string}
     * @memberof ErrorAuthenticatorAssuranceLevelNotSatisfied
     */
    'reason'?: string;
    /**
     *
     * @type {string}
     * @memberof ErrorAuthenticatorAssuranceLevelNotSatisfied
     */
    'redirect_browser_to'?: string;
    /**
     * The request ID  The request ID is often exposed internally in order to trace errors across service architectures. This is often a UUID.
     * @type {string}
     * @memberof ErrorAuthenticatorAssuranceLevelNotSatisfied
     */
    'request'?: string;
    /**
     * The status description
     * @type {string}
     * @memberof ErrorAuthenticatorAssuranceLevelNotSatisfied
     */
    'status'?: string;
}
/**
 *
 * @export
 * @interface ExpandTree
 */
export interface ExpandTree {
    /**
     *
     * @type {Array<ExpandTree>}
     * @memberof ExpandTree
     */
    'children'?: Array<ExpandTree>;
    /**
     *
     * @type {string}
     * @memberof ExpandTree
     */
    'subject_id'?: string;
    /**
     *
     * @type {SubjectSet}
     * @memberof ExpandTree
     */
    'subject_set'?: SubjectSet;
    /**
     *
     * @type {string}
     * @memberof ExpandTree
     */
    'type': ExpandTreeTypeEnum;
}
export declare const ExpandTreeTypeEnum: {
    readonly Union: "union";
    readonly Exclusion: "exclusion";
    readonly Intersection: "intersection";
    readonly Leaf: "leaf";
};
export declare type ExpandTreeTypeEnum = typeof ExpandTreeTypeEnum[keyof typeof ExpandTreeTypeEnum];
/**
 * Error responses are sent when an error (e.g. unauthorized, bad request, ...) occurred.
 * @export
 * @interface GenericError
 */
export interface GenericError {
    /**
     * The status code
     * @type {number}
     * @memberof GenericError
     */
    'code'?: number;
    /**
     * Debug information  This field is often not exposed to protect against leaking sensitive information.
     * @type {string}
     * @memberof GenericError
     */
    'debug'?: string;
    /**
     * Further error details
     * @type {Array<{ [key: string]: object; }>}
     * @memberof GenericError
     */
    'details'?: Array<{
        [key: string]: object;
    }>;
    /**
     *
     * @type {GenericErrorContent}
     * @memberof GenericError
     */
    'error'?: GenericErrorContent;
    /**
     * The error ID  Useful when trying to identify various errors in application logic.
     * @type {string}
     * @memberof GenericError
     */
    'id'?: string;
    /**
     * Error message  The error\'s message.
     * @type {string}
     * @memberof GenericError
     */
    'message': string;
    /**
     * A human-readable reason for the error
     * @type {string}
     * @memberof GenericError
     */
    'reason'?: string;
    /**
     * The request ID  The request ID is often exposed internally in order to trace errors across service architectures. This is often a UUID.
     * @type {string}
     * @memberof GenericError
     */
    'request'?: string;
    /**
     * The status description
     * @type {string}
     * @memberof GenericError
     */
    'status'?: string;
}
/**
 * Error response
 * @export
 * @interface GenericErrorContent
 */
export interface GenericErrorContent {
    /**
     * Debug contains debug information. This is usually not available and has to be enabled.
     * @type {string}
     * @memberof GenericErrorContent
     */
    'debug'?: string;
    /**
     * Name is the error name.
     * @type {string}
     * @memberof GenericErrorContent
     */
    'error'?: string;
    /**
     * Description contains further information on the nature of the error.
     * @type {string}
     * @memberof GenericErrorContent
     */
    'error_description'?: string;
    /**
     * Message contains the error message.
     * @type {string}
     * @memberof GenericErrorContent
     */
    'message'?: string;
    /**
     * Code represents the error status code (404, 403, 401, ...).
     * @type {number}
     * @memberof GenericErrorContent
     */
    'status_code'?: number;
}
/**
 * The content of the allowed field is mirrored in the HTTP status code.
 * @export
 * @interface GetCheckResponse
 */
export interface GetCheckResponse {
    /**
     * whether the relation tuple is allowed
     * @type {boolean}
     * @memberof GetCheckResponse
     */
    'allowed': boolean;
}
/**
 *
 * @export
 * @interface GetRelationTuplesResponse
 */
export interface GetRelationTuplesResponse {
    /**
     * The opaque token to provide in a subsequent request to get the next page. It is the empty string iff this is the last page.
     * @type {string}
     * @memberof GetRelationTuplesResponse
     */
    'next_page_token'?: string;
    /**
     *
     * @type {Array<InternalRelationTuple>}
     * @memberof GetRelationTuplesResponse
     */
    'relation_tuples'?: Array<InternalRelationTuple>;
}
/**
 *
 * @export
 * @interface HealthNotReadyStatus
 */
export interface HealthNotReadyStatus {
    /**
     * Errors contains a list of errors that caused the not ready status.
     * @type {{ [key: string]: string; }}
     * @memberof HealthNotReadyStatus
     */
    'errors'?: {
        [key: string]: string;
    };
}
/**
 *
 * @export
 * @interface HealthStatus
 */
export interface HealthStatus {
    /**
     * Status always contains \"ok\".
     * @type {string}
     * @memberof HealthStatus
     */
    'status'?: string;
}
/**
 * An identity can be a real human, a service, an IoT device - everything that can be described as an \"actor\" in a system.
 * @export
 * @interface Identity
 */
export interface Identity {
    /**
     * CreatedAt is a helper struct field for gobuffalo.pop.
     * @type {string}
     * @memberof Identity
     */
    'created_at'?: string;
    /**
     * Credentials represents all credentials that can be used for authenticating this identity.
     * @type {{ [key: string]: IdentityCredentials; }}
     * @memberof Identity
     */
    'credentials'?: {
        [key: string]: IdentityCredentials;
    };
    /**
     *
     * @type {string}
     * @memberof Identity
     */
    'id': string;
    /**
     * NullJSONRawMessage represents a json.RawMessage that works well with JSON, SQL, and Swagger and is NULLable-
     * @type {object}
     * @memberof Identity
     */
    'metadata_admin'?: object;
    /**
     * NullJSONRawMessage represents a json.RawMessage that works well with JSON, SQL, and Swagger and is NULLable-
     * @type {object}
     * @memberof Identity
     */
    'metadata_public'?: object;
    /**
     * RecoveryAddresses contains all the addresses that can be used to recover an identity.
     * @type {Array<RecoveryAddress>}
     * @memberof Identity
     */
    'recovery_addresses'?: Array<RecoveryAddress>;
    /**
     * SchemaID is the ID of the JSON Schema to be used for validating the identity\'s traits.
     * @type {string}
     * @memberof Identity
     */
    'schema_id': string;
    /**
     * SchemaURL is the URL of the endpoint where the identity\'s traits schema can be fetched from.  format: url
     * @type {string}
     * @memberof Identity
     */
    'schema_url': string;
    /**
     *
     * @type {IdentityState}
     * @memberof Identity
     */
    'state'?: IdentityState;
    /**
     *
     * @type {string}
     * @memberof Identity
     */
    'state_changed_at'?: string;
    /**
     * Traits represent an identity\'s traits. The identity is able to create, modify, and delete traits in a self-service manner. The input will always be validated against the JSON Schema defined in `schema_url`.
     * @type {any}
     * @memberof Identity
     */
    'traits': any;
    /**
     * UpdatedAt is a helper struct field for gobuffalo.pop.
     * @type {string}
     * @memberof Identity
     */
    'updated_at'?: string;
    /**
     * VerifiableAddresses contains all the addresses that can be verified by the user.
     * @type {Array<VerifiableIdentityAddress>}
     * @memberof Identity
     */
    'verifiable_addresses'?: Array<VerifiableIdentityAddress>;
}
/**
 * Credentials represents a specific credential type
 * @export
 * @interface IdentityCredentials
 */
export interface IdentityCredentials {
    /**
     *
     * @type {object}
     * @memberof IdentityCredentials
     */
    'config'?: object;
    /**
     * CreatedAt is a helper struct field for gobuffalo.pop.
     * @type {string}
     * @memberof IdentityCredentials
     */
    'created_at'?: string;
    /**
     * Identifiers represents a list of unique identifiers this credential type matches.
     * @type {Array<string>}
     * @memberof IdentityCredentials
     */
    'identifiers'?: Array<string>;
    /**
     *
     * @type {IdentityCredentialsType}
     * @memberof IdentityCredentials
     */
    'type'?: IdentityCredentialsType;
    /**
     * UpdatedAt is a helper struct field for gobuffalo.pop.
     * @type {string}
     * @memberof IdentityCredentials
     */
    'updated_at'?: string;
    /**
     * Version refers to the version of the credential. Useful when changing the config schema.
     * @type {number}
     * @memberof IdentityCredentials
     */
    'version'?: number;
}
/**
 *
 * @export
 * @interface IdentityCredentialsOidc
 */
export interface IdentityCredentialsOidc {
    /**
     *
     * @type {Array<IdentityCredentialsOidcProvider>}
     * @memberof IdentityCredentialsOidc
     */
    'providers'?: Array<IdentityCredentialsOidcProvider>;
}
/**
 *
 * @export
 * @interface IdentityCredentialsOidcProvider
 */
export interface IdentityCredentialsOidcProvider {
    /**
     *
     * @type {string}
     * @memberof IdentityCredentialsOidcProvider
     */
    'initial_access_token'?: string;
    /**
     *
     * @type {string}
     * @memberof IdentityCredentialsOidcProvider
     */
    'initial_id_token'?: string;
    /**
     *
     * @type {string}
     * @memberof IdentityCredentialsOidcProvider
     */
    'initial_refresh_token'?: string;
    /**
     *
     * @type {string}
     * @memberof IdentityCredentialsOidcProvider
     */
    'provider'?: string;
    /**
     *
     * @type {string}
     * @memberof IdentityCredentialsOidcProvider
     */
    'subject'?: string;
}
/**
 *
 * @export
 * @interface IdentityCredentialsPassword
 */
export interface IdentityCredentialsPassword {
    /**
     * HashedPassword is a hash-representation of the password.
     * @type {string}
     * @memberof IdentityCredentialsPassword
     */
    'hashed_password'?: string;
}
/**
 * and so on.
 * @export
 * @enum {string}
 */
export declare const IdentityCredentialsType: {
    readonly Password: "password";
    readonly Totp: "totp";
    readonly Oidc: "oidc";
    readonly Webauthn: "webauthn";
    readonly LookupSecret: "lookup_secret";
};
export declare type IdentityCredentialsType = typeof IdentityCredentialsType[keyof typeof IdentityCredentialsType];
/**
 * Together the name and identity uuid are a unique index constraint. This prevents a user from having schemas with the same name. This also allows schemas to have the same name across the system.
 * @export
 * @interface IdentitySchema
 */
export interface IdentitySchema {
    /**
     * The gcs file name  This is a randomly generated name which is used to uniquely identify the file on the blob storage
     * @type {string}
     * @memberof IdentitySchema
     */
    'blob_name': string;
    /**
     * The publicly accessible url of the schema
     * @type {string}
     * @memberof IdentitySchema
     */
    'blob_url': string;
    /**
     * The Content Hash  Contains a hash of the schema\'s content.
     * @type {string}
     * @memberof IdentitySchema
     */
    'content_hash'?: string;
    /**
     * The Schema\'s Creation Date
     * @type {string}
     * @memberof IdentitySchema
     */
    'created_at': string;
    /**
     *
     * @type {string}
     * @memberof IdentitySchema
     */
    'id': string;
    /**
     * The schema name  This is set by the user and is for them to easily recognise their schema
     * @type {string}
     * @memberof IdentitySchema
     */
    'name': string;
    /**
     * The actual Identity JSON Schema
     * @type {object}
     * @memberof IdentitySchema
     */
    'schema'?: object;
    /**
     * Last Time Schema was Updated
     * @type {string}
     * @memberof IdentitySchema
     */
    'updated_at': string;
}
/**
 *
 * @export
 * @interface IdentitySchemaLocation
 */
export interface IdentitySchemaLocation {
    /**
     *
     * @type {string}
     * @memberof IdentitySchemaLocation
     */
    'location'?: string;
}
/**
 *
 * @export
 * @interface IdentitySchemaPreset
 */
export interface IdentitySchemaPreset {
    /**
     * Schema is the Identity JSON Schema
     * @type {object}
     * @memberof IdentitySchemaPreset
     */
    'schema': object;
    /**
     * URL is the preset identifier
     * @type {string}
     * @memberof IdentitySchemaPreset
     */
    'url': string;
}
/**
 *
 * @export
 * @interface IdentitySchemaValidationResult
 */
export interface IdentitySchemaValidationResult {
    /**
     *
     * @type {string}
     * @memberof IdentitySchemaValidationResult
     */
    'message'?: string;
    /**
     *
     * @type {boolean}
     * @memberof IdentitySchemaValidationResult
     */
    'valid'?: boolean;
}
/**
 * The state can either be `active` or `inactive`.
 * @export
 * @enum {string}
 */
export declare const IdentityState: {
    readonly Active: "active";
    readonly Inactive: "inactive";
};
export declare type IdentityState = typeof IdentityState[keyof typeof IdentityState];
/**
 *
 * @export
 * @interface InlineResponse200
 */
export interface InlineResponse200 {
    /**
     * Always \"ok\".
     * @type {string}
     * @memberof InlineResponse200
     */
    'status': string;
}
/**
 *
 * @export
 * @interface InlineResponse2001
 */
export interface InlineResponse2001 {
    /**
     * The version of Ory Kratos.
     * @type {string}
     * @memberof InlineResponse2001
     */
    'version': string;
}
/**
 *
 * @export
 * @interface InlineResponse503
 */
export interface InlineResponse503 {
    /**
     * Errors contains a list of errors that caused the not ready status.
     * @type {{ [key: string]: string; }}
     * @memberof InlineResponse503
     */
    'errors': {
        [key: string]: string;
    };
}
/**
 *
 * @export
 * @interface InternalRelationTuple
 */
export interface InternalRelationTuple {
    /**
     * Namespace of the Relation Tuple
     * @type {string}
     * @memberof InternalRelationTuple
     */
    'namespace': string;
    /**
     * Object of the Relation Tuple
     * @type {string}
     * @memberof InternalRelationTuple
     */
    'object': string;
    /**
     * Relation of the Relation Tuple
     * @type {string}
     * @memberof InternalRelationTuple
     */
    'relation': string;
    /**
     * SubjectID of the Relation Tuple  Either SubjectSet or SubjectID are required.
     * @type {string}
     * @memberof InternalRelationTuple
     */
    'subject_id'?: string;
    /**
     *
     * @type {SubjectSet}
     * @memberof InternalRelationTuple
     */
    'subject_set'?: SubjectSet;
}
/**
 *
 * @export
 * @interface InvitePayload
 */
export interface InvitePayload {
    /**
     *
     * @type {string}
     * @memberof InvitePayload
     */
    'invitee_email'?: string;
}
/**
 *
 * @export
 * @interface IsOwnerForProjectBySlug
 */
export interface IsOwnerForProjectBySlug {
    /**
     * ProjectSlug is the project\'s slug.
     * @type {string}
     * @memberof IsOwnerForProjectBySlug
     */
    'ProjectSlug': string;
    /**
     * Subject is the subject from the API Token.
     * @type {string}
     * @memberof IsOwnerForProjectBySlug
     */
    'Subject': string;
}
/**
 *
 * @export
 * @interface IsOwnerForProjectBySlugPayload
 */
export interface IsOwnerForProjectBySlugPayload {
    /**
     * ProjectScope is the project_id resolved from the API Token.
     * @type {string}
     * @memberof IsOwnerForProjectBySlugPayload
     */
    'project_scope'?: string;
    /**
     * ProjectSlug is the project\'s slug.
     * @type {string}
     * @memberof IsOwnerForProjectBySlugPayload
     */
    'project_slug': string;
    /**
     * Subject is the subject from the API Token.
     * @type {string}
     * @memberof IsOwnerForProjectBySlugPayload
     */
    'subject': string;
}
/**
 * The standard Ory JSON API error format.
 * @export
 * @interface JsonError
 */
export interface JsonError {
    /**
     *
     * @type {GenericError}
     * @memberof JsonError
     */
    'error': GenericError;
}
/**
 * JSON Patch allows you to target individual keys in a JSON document for updates.  For more examples see: https://jsonpatch.com
 * @export
 * @interface JsonPatch
 */
export interface JsonPatch {
    /**
     * The JSON Patch operation
     * @type {string}
     * @memberof JsonPatch
     */
    'op': JsonPatchOpEnum;
    /**
     * The JSON Pointer to the target key
     * @type {string}
     * @memberof JsonPatch
     */
    'path': string;
    /**
     * The value to be used. Only available for `add` and `replace` operations.
     * @type {any}
     * @memberof JsonPatch
     */
    'value'?: any;
}
export declare const JsonPatchOpEnum: {
    readonly Add: "add";
    readonly Remove: "remove";
    readonly Replace: "replace";
    readonly Move: "move";
    readonly Copy: "copy";
    readonly Test: "test";
};
export declare type JsonPatchOpEnum = typeof JsonPatchOpEnum[keyof typeof JsonPatchOpEnum];
/**
 *
 * @export
 * @interface KetoNamespace
 */
export interface KetoNamespace {
    /**
     *
     * @type {number}
     * @memberof KetoNamespace
     */
    'id'?: number;
    /**
     *
     * @type {string}
     * @memberof KetoNamespace
     */
    'name'?: string;
}
/**
 *
 * @export
 * @interface NeedsPrivilegedSessionError
 */
export interface NeedsPrivilegedSessionError {
    /**
     * The status code
     * @type {number}
     * @memberof NeedsPrivilegedSessionError
     */
    'code'?: number;
    /**
     * Debug information  This field is often not exposed to protect against leaking sensitive information.
     * @type {string}
     * @memberof NeedsPrivilegedSessionError
     */
    'debug'?: string;
    /**
     * Further error details
     * @type {{ [key: string]: object; }}
     * @memberof NeedsPrivilegedSessionError
     */
    'details'?: {
        [key: string]: object;
    };
    /**
     * The error ID  Useful when trying to identify various errors in application logic.
     * @type {string}
     * @memberof NeedsPrivilegedSessionError
     */
    'id'?: string;
    /**
     * Error message  The error\'s message.
     * @type {string}
     * @memberof NeedsPrivilegedSessionError
     */
    'message': string;
    /**
     * A human-readable reason for the error
     * @type {string}
     * @memberof NeedsPrivilegedSessionError
     */
    'reason'?: string;
    /**
     * Points to where to redirect the user to next.
     * @type {string}
     * @memberof NeedsPrivilegedSessionError
     */
    'redirect_browser_to': string;
    /**
     * The request ID  The request ID is often exposed internally in order to trace errors across service architectures. This is often a UUID.
     * @type {string}
     * @memberof NeedsPrivilegedSessionError
     */
    'request'?: string;
    /**
     * The status description
     * @type {string}
     * @memberof NeedsPrivilegedSessionError
     */
    'status'?: string;
}
/**
 *
 * @export
 * @interface NormalizedProject
 */
export interface NormalizedProject {
    /**
     * The Project\'s Creation Date
     * @type {string}
     * @memberof NormalizedProject
     */
    'created_at': string;
    /**
     *
     * @type {NormalizedProjectRevision}
     * @memberof NormalizedProject
     */
    'current_revision': NormalizedProjectRevision;
    /**
     *
     * @type {Array<string>}
     * @memberof NormalizedProject
     */
    'hosts': Array<string>;
    /**
     *
     * @type {string}
     * @memberof NormalizedProject
     */
    'id': string;
    /**
     *
     * @type {Array<NormalizedProjectRevision>}
     * @memberof NormalizedProject
     */
    'revisions': Array<NormalizedProjectRevision>;
    /**
     * The project\'s slug
     * @type {string}
     * @memberof NormalizedProject
     */
    'slug': string;
    /**
     * The state of the project. running Running halted Halted
     * @type {string}
     * @memberof NormalizedProject
     */
    'state': NormalizedProjectStateEnum;
    /**
     *
     * @type {string}
     * @memberof NormalizedProject
     */
    'subscription_id'?: string | null;
    /**
     * Last Time Project was Updated
     * @type {string}
     * @memberof NormalizedProject
     */
    'updated_at': string;
}
export declare const NormalizedProjectStateEnum: {
    readonly Running: "running";
    readonly Halted: "halted";
};
export declare type NormalizedProjectStateEnum = typeof NormalizedProjectStateEnum[keyof typeof NormalizedProjectStateEnum];
/**
 *
 * @export
 * @interface NormalizedProjectRevision
 */
export interface NormalizedProjectRevision {
    /**
     * The Project\'s Revision Creation Date
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'created_at'?: string;
    /**
     *
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'id'?: string;
    /**
     *
     * @type {Array<KetoNamespace>}
     * @memberof NormalizedProjectRevision
     */
    'keto_namespaces'?: Array<KetoNamespace>;
    /**
     *
     * @type {number}
     * @memberof NormalizedProjectRevision
     */
    'keto_read_max_depth'?: number | null;
    /**
     * Configures the Ory Kratos Cookie SameSite Attribute  This governs the \"cookies.same_site\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_cookies_same_site'?: string;
    /**
     * Configures the Ory Kratos SMTP Connection URI  This governs the \"courier.smtp.connection_uri\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_courier_smtp_connection_uri'?: string;
    /**
     * Configures the Ory Kratos SMTP From Address  This governs the \"courier.smtp.from_address\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_courier_smtp_from_address'?: string;
    /**
     * Configures the Ory Kratos SMTP From Name  This governs the \"courier.smtp.from_name\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_courier_smtp_from_name'?: string;
    /**
     * NullJSONRawMessage represents a json.RawMessage that works well with JSON, SQL, and Swagger and is NULLable-
     * @type {object}
     * @memberof NormalizedProjectRevision
     */
    'kratos_courier_smtp_headers'?: object;
    /**
     * Configures the Ory Kratos Invalid Recovery Email Body HTML Template  This governs the \"courier.smtp.templates.recovery.invalid.email.body.html\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_courier_templates_recovery_invalid_email_body_html'?: string;
    /**
     * Configures the Ory Kratos Invalid Recovery Email Body Plaintext Template  This governs the \"courier.smtp.templates.recovery.invalid.email.body.plaintext\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_courier_templates_recovery_invalid_email_body_plaintext'?: string;
    /**
     * Configures the Ory Kratos Invalid Recovery Email Subject Template  This governs the \"courier.smtp.templates.recovery.invalid.email.body.html\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_courier_templates_recovery_invalid_email_subject'?: string;
    /**
     * Configures the Ory Kratos Valid Recovery Email Body HTML Template  This governs the \"courier.smtp.templates.recovery.valid.email.body.html\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_courier_templates_recovery_valid_email_body_html'?: string;
    /**
     * Configures the Ory Kratos Valid Recovery Email Body Plaintext Template  This governs the \"courier.smtp.templates.recovery.valid.email.body.plaintext\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_courier_templates_recovery_valid_email_body_plaintext'?: string;
    /**
     * Configures the Ory Kratos Valid Recovery Email Subject Template  This governs the \"courier.smtp.templates.recovery.valid.email.subject\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_courier_templates_recovery_valid_email_subject'?: string;
    /**
     * Configures the Ory Kratos Invalid Verification Email Body HTML Template  This governs the \"courier.smtp.templates.verification.invalid.email.body.html\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_courier_templates_verification_invalid_email_body_html'?: string;
    /**
     * Configures the Ory Kratos Invalid Verification Email Body Plaintext Template  This governs the \"courier.smtp.templates.recovery.invalid.email.body.plaintext\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_courier_templates_verification_invalid_email_body_plaintext'?: string;
    /**
     * Configures the Ory Kratos Invalid Verification Email Subject Template  This governs the \"courier.smtp.templates.verification.invalid.email.subject\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_courier_templates_verification_invalid_email_subject'?: string;
    /**
     * Configures the Ory Kratos Valid Verification Email Body HTML Template  This governs the \"courier.smtp.templates.verification.valid.email.body.html\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_courier_templates_verification_valid_email_body_html'?: string;
    /**
     * Configures the Ory Kratos Valid Verification Email Body Plaintext Template  This governs the \"courier.smtp.templates.recovery.valid.email.body.plaintext\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_courier_templates_verification_valid_email_body_plaintext'?: string;
    /**
     * Configures the Ory Kratos Valid Verification Email Subject Template  This governs the \"courier.smtp.templates.verification.valid.email.subject\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_courier_templates_verification_valid_email_subject'?: string;
    /**
     *
     * @type {Array<NormalizedProjectRevisionIdentitySchema>}
     * @memberof NormalizedProjectRevision
     */
    'kratos_identity_schemas'?: Array<NormalizedProjectRevisionIdentitySchema>;
    /**
     *
     * @type {Array<string>}
     * @memberof NormalizedProjectRevision
     */
    'kratos_secrets_cipher'?: Array<string>;
    /**
     *
     * @type {Array<string>}
     * @memberof NormalizedProjectRevision
     */
    'kratos_secrets_cookie'?: Array<string>;
    /**
     *
     * @type {Array<string>}
     * @memberof NormalizedProjectRevision
     */
    'kratos_secrets_default'?: Array<string>;
    /**
     *
     * @type {Array<string>}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_allowed_return_urls'?: Array<string>;
    /**
     * Configures the Ory Kratos Default Return URL  This governs the \"selfservice.allowed_return_urls\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_default_browser_return_url'?: string;
    /**
     * Configures the Ory Kratos Error UI URL  This governs the \"selfservice.flows.error.ui_url\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_error_ui_url'?: string;
    /**
     *
     * @type {Array<NormalizedProjectRevisionHook>}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_hooks'?: Array<NormalizedProjectRevisionHook>;
    /**
     * Configures the Ory Kratos Login Default Return URL  This governs the \"selfservice.flows.login.after.default_browser_return_url\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_login_after_default_browser_return_url'?: string;
    /**
     * Configures the Ory Kratos Login After OIDC Default Return URL  This governs the \"selfservice.flows.login.after.oidc.default_browser_return_url\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_login_after_oidc_default_browser_return_url'?: string;
    /**
     * Configures the Ory Kratos Login After Password Default Return URL  This governs the \"selfservice.flows.login.after.password.default_browser_return_url\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_login_after_password_default_browser_return_url'?: string;
    /**
     * Configures the Ory Kratos Login After WebAuthn Default Return URL  This governs the \"selfservice.flows.login.after.webauthn.default_browser_return_url\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_login_after_webauthn_default_browser_return_url'?: string;
    /**
     * Configures the Ory Kratos Login Lifespan  This governs the \"selfservice.flows.login.lifespan\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_login_lifespan'?: string;
    /**
     * Configures the Ory Kratos Login UI URL  This governs the \"selfservice.flows.login.ui_url\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_login_ui_url'?: string;
    /**
     * Configures the Ory Kratos Logout Default Return URL  This governs the \"selfservice.flows.logout.after.default_browser_return_url\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_logout_after_default_browser_return_url'?: string;
    /**
     * Configures the Ory Kratos Recovery Default Return URL  This governs the \"selfservice.flows.recovery.after.default_browser_return_url\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_recovery_after_default_browser_return_url'?: string;
    /**
     * Configures the Ory Kratos Recovery Enabled Setting  This governs the \"selfservice.flows.recovery.enabled\" setting.
     * @type {boolean}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_recovery_enabled'?: boolean;
    /**
     * Configures the Ory Kratos Recovery Lifespan  This governs the \"selfservice.flows.recovery.lifespan\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_recovery_lifespan'?: string;
    /**
     * Configures the Ory Kratos Recovery UI URL  This governs the \"selfservice.flows.recovery.ui_url\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_recovery_ui_url'?: string;
    /**
     * Configures the Ory Kratos Registration Default Return URL  This governs the \"selfservice.flows.registration.after.default_browser_return_url\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_registration_after_default_browser_return_url'?: string;
    /**
     * Configures the Ory Kratos Registration After OIDC Default Return URL  This governs the \"selfservice.flows.registration.after.oidc.default_browser_return_url\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_registration_after_oidc_default_browser_return_url'?: string;
    /**
     * Configures the Ory Kratos Registration After Password Default Return URL  This governs the \"selfservice.flows.registration.after.password.default_browser_return_url\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_registration_after_password_default_browser_return_url'?: string;
    /**
     * Configures the Ory Kratos Registration After Password Default Return URL  This governs the \"selfservice.flows.registration.after.password.default_browser_return_url\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_registration_after_webauthn_default_browser_return_url'?: string;
    /**
     *
     * @type {boolean}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_registration_enabled'?: boolean | null;
    /**
     * Configures the Ory Kratos Registration Lifespan  This governs the \"selfservice.flows.registration.lifespan\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_registration_lifespan'?: string;
    /**
     * Configures the Ory Kratos Registration UI URL  This governs the \"selfservice.flows.registration.ui_url\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_registration_ui_url'?: string;
    /**
     * Configures the Ory Kratos Settings Default Return URL  This governs the \"selfservice.flows.settings.after.default_browser_return_url\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_settings_after_default_browser_return_url'?: string;
    /**
     * Configures the Ory Kratos Settings Default Return URL After Updating Passwords  This governs the \"selfservice.flows.settings.after.password.default_browser_return_url\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_settings_after_password_default_browser_return_url'?: string;
    /**
     * Configures the Ory Kratos Settings Default Return URL After Updating Profiles  This governs the \"selfservice.flows.settings.after.profile.default_browser_return_url\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_settings_after_profile_default_browser_return_url'?: string;
    /**
     * Configures the Ory Kratos Settings Lifespan  This governs the \"selfservice.flows.settings.lifespan\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_settings_lifespan'?: string;
    /**
     * Configures the Ory Kratos Settings Privileged Session Max Age  This governs the \"selfservice.flows.settings.privileged_session_max_age\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_settings_privileged_session_max_age'?: string;
    /**
     * Configures the Ory Kratos Settings Required AAL  This governs the \"selfservice.flows.settings.required_aal\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_settings_required_aal'?: string;
    /**
     * Configures the Ory Kratos Settings UI URL  This governs the \"selfservice.flows.settings.ui_url\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_settings_ui_url'?: string;
    /**
     * Configures the Ory Kratos Verification Default Return URL  This governs the \"selfservice.flows.verification.after.default_browser_return_url\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_verification_after_default_browser_return_url'?: string;
    /**
     * Configures the Ory Kratos Verification Enabled Setting  This governs the \"selfservice.flows.verification.enabled\" setting.
     * @type {boolean}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_verification_enabled'?: boolean;
    /**
     * Configures the Ory Kratos Verification Lifespan  This governs the \"selfservice.flows.verification.lifespan\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_verification_lifespan'?: string;
    /**
     * Configures the Ory Kratos Verification UI URL  This governs the \"selfservice.flows.verification.ui_url\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_flows_verification_ui_url'?: string;
    /**
     * Configures the Base URL which Recovery, Verification, and Login Links Point to  It is recommended to leave this value empty. It will be appropriately configured to the best matching domain (e.g. when using custom domains) automatically.  This governs the \"selfservice.methods.link.config.base_url\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_methods_link_config_base_url'?: string;
    /**
     * Configures whether Ory Kratos Link Method is enabled  This governs the \"selfservice.methods.link.config.lifespan\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_methods_link_config_lifespan'?: string;
    /**
     *
     * @type {boolean}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_methods_link_enabled'?: boolean | null;
    /**
     *
     * @type {boolean}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_methods_lookup_secret_enabled'?: boolean | null;
    /**
     * Configures the Ory Kratos Third Party / OpenID Connect base redirect URI  This governs the \"selfservice.methods.oidc.config.base_redirect_uri\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_methods_oidc_config_base_redirect_uri'?: string;
    /**
     *
     * @type {Array<NormalizedProjectRevisionThirdPartyProvider>}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_methods_oidc_config_providers'?: Array<NormalizedProjectRevisionThirdPartyProvider>;
    /**
     * Configures whether Ory Kratos Third Party / OpenID Connect Login is enabled  This governs the \"selfservice.methods.oidc.enabled\" setting.
     * @type {boolean}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_methods_oidc_enabled'?: boolean;
    /**
     *
     * @type {boolean}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_methods_password_config_haveibeenpwned_enabled'?: boolean | null;
    /**
     *
     * @type {boolean}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_methods_password_config_identifier_similarity_check_enabled'?: boolean | null;
    /**
     *
     * @type {boolean}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_methods_password_config_ignore_network_errors'?: boolean | null;
    /**
     * Configures Ory Kratos Password Max Breaches Detection  This governs the \"selfservice.methods.password.config.max_breaches\" setting.
     * @type {number}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_methods_password_config_max_breaches'?: number;
    /**
     * Configures the minimum length of passwords.  This governs the \"selfservice.methods.password.config.min_password_length\" setting.
     * @type {number}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_methods_password_config_min_password_length'?: number;
    /**
     *
     * @type {boolean}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_methods_password_enabled'?: boolean | null;
    /**
     *
     * @type {boolean}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_methods_profile_enabled'?: boolean | null;
    /**
     * Configures Ory Kratos TOTP Issuer  This governs the \"selfservice.methods.totp.config.issuer\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_methods_totp_config_issuer'?: string;
    /**
     *
     * @type {boolean}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_methods_totp_enabled'?: boolean | null;
    /**
     * Configures whether Ory Kratos Webauthn is used for passwordless flows  This governs the \"selfservice.methods.webauthn.config.passwordless\" setting.
     * @type {boolean}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_methods_webauthn_config_passwordless'?: boolean;
    /**
     * Configures the Ory Kratos Webauthn RP Display Name  This governs the \"selfservice.methods.webauthn.config.rp.display_name\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_methods_webauthn_config_rp_display_name'?: string;
    /**
     * Configures the Ory Kratos Webauthn RP Icon  This governs the \"selfservice.methods.webauthn.config.rp.icon\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_methods_webauthn_config_rp_icon'?: string;
    /**
     * Configures the Ory Kratos Webauthn RP ID  This governs the \"selfservice.methods.webauthn.config.rp.id\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_methods_webauthn_config_rp_id'?: string;
    /**
     * Configures the Ory Kratos Webauthn RP Origin  This governs the \"selfservice.methods.webauthn.config.rp.origin\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_methods_webauthn_config_rp_origin'?: string;
    /**
     *
     * @type {boolean}
     * @memberof NormalizedProjectRevision
     */
    'kratos_selfservice_methods_webauthn_enabled'?: boolean | null;
    /**
     *
     * @type {boolean}
     * @memberof NormalizedProjectRevision
     */
    'kratos_session_cookie_persistent'?: boolean | null;
    /**
     * Configures the Ory Kratos Session Cookie SameSite Attribute  This governs the \"session.cookie.same_site\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_session_cookie_same_site'?: string;
    /**
     * Configures the Ory Kratos Session Lifespan  This governs the \"session.lifespan\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_session_lifespan'?: string;
    /**
     * Configures the Ory Kratos Session Whoami AAL requirement  This governs the \"session.whoami.required_aal\" setting.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'kratos_session_whoami_required_aal'?: string;
    /**
     * The project\'s name.
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'name': string;
    /**
     *
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'project_id'?: string;
    /**
     * Last Time Project\'s Revision was Updated
     * @type {string}
     * @memberof NormalizedProjectRevision
     */
    'updated_at'?: string;
}
/**
 *
 * @export
 * @interface NormalizedProjectRevisionHook
 */
export interface NormalizedProjectRevisionHook {
    /**
     * The Hooks Config Key
     * @type {string}
     * @memberof NormalizedProjectRevisionHook
     */
    'config_key': string;
    /**
     * The Project\'s Revision Creation Date
     * @type {string}
     * @memberof NormalizedProjectRevisionHook
     */
    'created_at'?: string;
    /**
     * The Hook Type
     * @type {string}
     * @memberof NormalizedProjectRevisionHook
     */
    'hook': string;
    /**
     *
     * @type {string}
     * @memberof NormalizedProjectRevisionHook
     */
    'id'?: string;
    /**
     *
     * @type {string}
     * @memberof NormalizedProjectRevisionHook
     */
    'project_revision_id'?: string;
    /**
     * Last Time Project\'s Revision was Updated
     * @type {string}
     * @memberof NormalizedProjectRevisionHook
     */
    'updated_at'?: string;
    /**
     * Whether to send the API Key in the HTTP Header or as a HTTP Cookie
     * @type {string}
     * @memberof NormalizedProjectRevisionHook
     */
    'web_hook_config_auth_api_key_in'?: string;
    /**
     * The name of the api key
     * @type {string}
     * @memberof NormalizedProjectRevisionHook
     */
    'web_hook_config_auth_api_key_name'?: string;
    /**
     * The value of the api key
     * @type {string}
     * @memberof NormalizedProjectRevisionHook
     */
    'web_hook_config_auth_api_key_value'?: string;
    /**
     * The password to be sent in the HTTP Basic Auth Header
     * @type {string}
     * @memberof NormalizedProjectRevisionHook
     */
    'web_hook_config_auth_basic_auth_password'?: string;
    /**
     * The username to be sent in the HTTP Basic Auth Header
     * @type {string}
     * @memberof NormalizedProjectRevisionHook
     */
    'web_hook_config_auth_basic_auth_user'?: string;
    /**
     * HTTP Auth Method to use for the Web-Hook
     * @type {string}
     * @memberof NormalizedProjectRevisionHook
     */
    'web_hook_config_auth_type'?: string;
    /**
     * URI pointing to the JsonNet template used for Web-Hook payload generation. Only used for those HTTP methods, which support HTTP body payloads.
     * @type {string}
     * @memberof NormalizedProjectRevisionHook
     */
    'web_hook_config_body'?: string;
    /**
     * The HTTP method to use (GET, POST, etc) for the Web-Hook
     * @type {string}
     * @memberof NormalizedProjectRevisionHook
     */
    'web_hook_config_method'?: string;
    /**
     * Whether to ignore the Web Hook response
     * @type {boolean}
     * @memberof NormalizedProjectRevisionHook
     */
    'web_hook_config_response_ignore'?: boolean;
    /**
     * The URL the Web-Hook should call
     * @type {string}
     * @memberof NormalizedProjectRevisionHook
     */
    'web_hook_config_url'?: string;
}
/**
 *
 * @export
 * @interface NormalizedProjectRevisionIdentitySchema
 */
export interface NormalizedProjectRevisionIdentitySchema {
    /**
     * The Project\'s Revision Creation Date
     * @type {string}
     * @memberof NormalizedProjectRevisionIdentitySchema
     */
    'created_at'?: string;
    /**
     *
     * @type {string}
     * @memberof NormalizedProjectRevisionIdentitySchema
     */
    'id'?: string;
    /**
     *
     * @type {IdentitySchema}
     * @memberof NormalizedProjectRevisionIdentitySchema
     */
    'identity_schema'?: IdentitySchema;
    /**
     *
     * @type {string}
     * @memberof NormalizedProjectRevisionIdentitySchema
     */
    'identity_schema_id'?: string | null;
    /**
     * The imported (named) ID of the Identity Schema referenced in the Ory Kratos config.
     * @type {string}
     * @memberof NormalizedProjectRevisionIdentitySchema
     */
    'import_id'?: string;
    /**
     * The ImportURL can be used to import an Identity Schema from a bse64 encoded string. In the future, this key also support HTTPS and other sources!  If you import an Ory Kratos configuration, this would be akin to the `identity.schemas.#.url` key.  The configuration will always return the import URL when you fetch it from the API.
     * @type {string}
     * @memberof NormalizedProjectRevisionIdentitySchema
     */
    'import_url'?: string;
    /**
     * If true sets the default schema for identities  Only one schema can ever be the default schema. If you try to add two schemas with default to true, the request will fail.
     * @type {boolean}
     * @memberof NormalizedProjectRevisionIdentitySchema
     */
    'is_default'?: boolean;
    /**
     * Use a preset instead of a custom identity schema.
     * @type {string}
     * @memberof NormalizedProjectRevisionIdentitySchema
     */
    'preset'?: string;
    /**
     *
     * @type {string}
     * @memberof NormalizedProjectRevisionIdentitySchema
     */
    'project_revision_id'?: string;
    /**
     * Last Time Project\'s Revision was Updated
     * @type {string}
     * @memberof NormalizedProjectRevisionIdentitySchema
     */
    'updated_at'?: string;
}
/**
 *
 * @export
 * @interface NormalizedProjectRevisionThirdPartyProvider
 */
export interface NormalizedProjectRevisionThirdPartyProvider {
    /**
     *
     * @type {string}
     * @memberof NormalizedProjectRevisionThirdPartyProvider
     */
    'apple_private_key'?: string | null;
    /**
     * Apple Private Key Identifier  Sign In with Apple Private Key Identifier needed for generating a JWT token for client secret
     * @type {string}
     * @memberof NormalizedProjectRevisionThirdPartyProvider
     */
    'apple_private_key_id'?: string;
    /**
     * Apple Developer Team ID  Apple Developer Team ID needed for generating a JWT token for client secret
     * @type {string}
     * @memberof NormalizedProjectRevisionThirdPartyProvider
     */
    'apple_team_id'?: string;
    /**
     * AuthURL is the authorize url, typically something like: https://example.org/oauth2/auth Should only be used when the OAuth2 / OpenID Connect server is not supporting OpenID Connect Discovery and when `provider` is set to `generic`.
     * @type {string}
     * @memberof NormalizedProjectRevisionThirdPartyProvider
     */
    'auth_url'?: string;
    /**
     * Tenant is the Azure AD Tenant to use for authentication, and must be set when `provider` is set to `microsoft`.  Can be either `common`, `organizations`, `consumers` for a multitenant application or a specific tenant like `8eaef023-2b34-4da1-9baa-8bc8c9d6a490` or `contoso.onmicrosoft.com`.
     * @type {string}
     * @memberof NormalizedProjectRevisionThirdPartyProvider
     */
    'azure_tenant'?: string;
    /**
     * ClientID is the application\'s Client ID.
     * @type {string}
     * @memberof NormalizedProjectRevisionThirdPartyProvider
     */
    'client_id'?: string;
    /**
     *
     * @type {string}
     * @memberof NormalizedProjectRevisionThirdPartyProvider
     */
    'client_secret'?: string | null;
    /**
     * The Project\'s Revision Creation Date
     * @type {string}
     * @memberof NormalizedProjectRevisionThirdPartyProvider
     */
    'created_at'?: string;
    /**
     *
     * @type {string}
     * @memberof NormalizedProjectRevisionThirdPartyProvider
     */
    'id'?: string;
    /**
     * IssuerURL is the OpenID Connect Server URL. You can leave this empty if `provider` is not set to `generic`. If set, neither `auth_url` nor `token_url` are required.
     * @type {string}
     * @memberof NormalizedProjectRevisionThirdPartyProvider
     */
    'issuer_url'?: string;
    /**
     * Label represents an optional label which can be used in the UI generation.
     * @type {string}
     * @memberof NormalizedProjectRevisionThirdPartyProvider
     */
    'label'?: string;
    /**
     * Mapper specifies the JSONNet code snippet which uses the OpenID Connect Provider\'s data (e.g. GitHub or Google profile information) to hydrate the identity\'s data.  It can be either a URL (file://, http(s)://, base64://) or an inline JSONNet code snippet.
     * @type {string}
     * @memberof NormalizedProjectRevisionThirdPartyProvider
     */
    'mapper_url'?: string;
    /**
     *
     * @type {string}
     * @memberof NormalizedProjectRevisionThirdPartyProvider
     */
    'project_revision_id'?: string;
    /**
     * Provider is either \"generic\" for a generic OAuth 2.0 / OpenID Connect Provider or one of: generic google github gitlab microsoft discord slack facebook vk yandex apple
     * @type {string}
     * @memberof NormalizedProjectRevisionThirdPartyProvider
     */
    'provider'?: string;
    /**
     * ID is the provider\'s ID
     * @type {string}
     * @memberof NormalizedProjectRevisionThirdPartyProvider
     */
    'provider_id'?: string;
    /**
     *
     * @type {object}
     * @memberof NormalizedProjectRevisionThirdPartyProvider
     */
    'requested_claims'?: object;
    /**
     *
     * @type {Array<string>}
     * @memberof NormalizedProjectRevisionThirdPartyProvider
     */
    'scope'?: Array<string>;
    /**
     * TokenURL is the token url, typically something like: https://example.org/oauth2/token  Should only be used when the OAuth2 / OpenID Connect server is not supporting OpenID Connect Discovery and when `provider` is set to `generic`.
     * @type {string}
     * @memberof NormalizedProjectRevisionThirdPartyProvider
     */
    'token_url'?: string;
    /**
     * Last Time Project\'s Revision was Updated
     * @type {string}
     * @memberof NormalizedProjectRevisionThirdPartyProvider
     */
    'updated_at'?: string;
}
/**
 *  unknown Unknown free Free start_up_monthly StartUpMonthly start_up_yearly StartUpYearly custom Custom
 * @export
 * @enum {string}
 */
export declare const NullPlan: {
    readonly Unknown: "unknown";
    readonly Free: "free";
    readonly StartUpMonthly: "start_up_monthly";
    readonly StartUpYearly: "start_up_yearly";
    readonly Custom: "custom";
};
export declare type NullPlan = typeof NullPlan[keyof typeof NullPlan];
/**
 *
 * @export
 * @interface Pagination
 */
export interface Pagination {
    /**
     * Pagination Page
     * @type {number}
     * @memberof Pagination
     */
    'page'?: number;
    /**
     * Items per Page  This is the number of items per page.
     * @type {number}
     * @memberof Pagination
     */
    'per_page'?: number;
}
/**
 *
 * @export
 * @interface PatchDelta
 */
export interface PatchDelta {
    /**
     *
     * @type {string}
     * @memberof PatchDelta
     */
    'action'?: PatchDeltaActionEnum;
    /**
     *
     * @type {InternalRelationTuple}
     * @memberof PatchDelta
     */
    'relation_tuple'?: InternalRelationTuple;
}
export declare const PatchDeltaActionEnum: {
    readonly Insert: "insert";
    readonly Delete: "delete";
};
export declare type PatchDeltaActionEnum = typeof PatchDeltaActionEnum[keyof typeof PatchDeltaActionEnum];
/**
 *
 * @export
 * @interface Project
 */
export interface Project {
    /**
     *
     * @type {string}
     * @memberof Project
     */
    'id': string;
    /**
     * The name of the project.
     * @type {string}
     * @memberof Project
     */
    'name': string;
    /**
     *
     * @type {string}
     * @memberof Project
     */
    'revision_id': string;
    /**
     *
     * @type {ProjectServices}
     * @memberof Project
     */
    'services': ProjectServices;
    /**
     * The project\'s slug
     * @type {string}
     * @memberof Project
     */
    'slug': string;
    /**
     * The state of the project. running Running halted Halted
     * @type {string}
     * @memberof Project
     */
    'state': ProjectStateEnum;
}
export declare const ProjectStateEnum: {
    readonly Running: "running";
    readonly Halted: "halted";
};
export declare type ProjectStateEnum = typeof ProjectStateEnum[keyof typeof ProjectStateEnum];
/**
 *
 * @export
 * @interface ProjectHost
 */
export interface ProjectHost {
    /**
     * The project\'s host.
     * @type {string}
     * @memberof ProjectHost
     */
    'host': string;
    /**
     *
     * @type {string}
     * @memberof ProjectHost
     */
    'id': string;
    /**
     *
     * @type {string}
     * @memberof ProjectHost
     */
    'project_id': string;
}
/**
 *
 * @export
 * @interface ProjectInvite
 */
export interface ProjectInvite {
    /**
     * The Project\'s Revision Creation Date
     * @type {string}
     * @memberof ProjectInvite
     */
    'created_at': string;
    /**
     *
     * @type {string}
     * @memberof ProjectInvite
     */
    'id': string;
    /**
     * The invitee\'s email
     * @type {string}
     * @memberof ProjectInvite
     */
    'invitee_email': string;
    /**
     *
     * @type {string}
     * @memberof ProjectInvite
     */
    'invitee_id'?: string | null;
    /**
     * The invite owner\'s email Usually the project\'s owner email
     * @type {string}
     * @memberof ProjectInvite
     */
    'owner_email': string;
    /**
     *
     * @type {string}
     * @memberof ProjectInvite
     */
    'owner_id': string;
    /**
     *
     * @type {string}
     * @memberof ProjectInvite
     */
    'project_id': string;
    /**
     * The invite\'s status Keeps track of the invites status such as pending, accepted, declined, expired
     * @type {string}
     * @memberof ProjectInvite
     */
    'status': string;
    /**
     * Last Time Project\'s Revision was Updated
     * @type {string}
     * @memberof ProjectInvite
     */
    'updated_at': string;
}
/**
 *
 * @export
 * @interface ProjectMetadata
 */
export interface ProjectMetadata {
    /**
     * The Project\'s Creation Date
     * @type {string}
     * @memberof ProjectMetadata
     */
    'created_at': string;
    /**
     *
     * @type {Array<string>}
     * @memberof ProjectMetadata
     */
    'hosts': Array<string>;
    /**
     *
     * @type {string}
     * @memberof ProjectMetadata
     */
    'id': string;
    /**
     * The project\'s name if set
     * @type {string}
     * @memberof ProjectMetadata
     */
    'name': string;
    /**
     * The project\'s slug
     * @type {string}
     * @memberof ProjectMetadata
     */
    'slug'?: string;
    /**
     * The state of the project. running Running halted Halted
     * @type {string}
     * @memberof ProjectMetadata
     */
    'state': ProjectMetadataStateEnum;
    /**
     *
     * @type {string}
     * @memberof ProjectMetadata
     */
    'subscription_id'?: string | null;
    /**
     * Last Time Project was Updated
     * @type {string}
     * @memberof ProjectMetadata
     */
    'updated_at': string;
}
export declare const ProjectMetadataStateEnum: {
    readonly Running: "running";
    readonly Halted: "halted";
};
export declare type ProjectMetadataStateEnum = typeof ProjectMetadataStateEnum[keyof typeof ProjectMetadataStateEnum];
/**
 *
 * @export
 * @interface ProjectServiceIdentity
 */
export interface ProjectServiceIdentity {
    /**
     *
     * @type {object}
     * @memberof ProjectServiceIdentity
     */
    'config': object;
}
/**
 *
 * @export
 * @interface ProjectServicePermission
 */
export interface ProjectServicePermission {
    /**
     *
     * @type {object}
     * @memberof ProjectServicePermission
     */
    'config': object;
}
/**
 *
 * @export
 * @interface ProjectServices
 */
export interface ProjectServices {
    /**
     *
     * @type {ProjectServiceIdentity}
     * @memberof ProjectServices
     */
    'identity'?: ProjectServiceIdentity;
    /**
     *
     * @type {ProjectServicePermission}
     * @memberof ProjectServices
     */
    'permission'?: ProjectServicePermission;
}
/**
 *
 * @export
 * @interface ProvisionMockSubscriptionPayload
 */
export interface ProvisionMockSubscriptionPayload {
    /**
     *
     * @type {string}
     * @memberof ProvisionMockSubscriptionPayload
     */
    'identity_id': string;
    /**
     *
     * @type {string}
     * @memberof ProvisionMockSubscriptionPayload
     */
    'plan_or_price': string;
}
/**
 *
 * @export
 * @interface QuotaProjectMemberSeats
 */
export interface QuotaProjectMemberSeats {
    /**
     *
     * @type {string}
     * @memberof QuotaProjectMemberSeats
     */
    'project_id'?: string;
    /**
     *
     * @type {number}
     * @memberof QuotaProjectMemberSeats
     */
    'remaining_seats'?: number;
    /**
     *
     * @type {number}
     * @memberof QuotaProjectMemberSeats
     */
    'total_seats'?: number;
}
/**
 *
 * @export
 * @interface RecoveryAddress
 */
export interface RecoveryAddress {
    /**
     * CreatedAt is a helper struct field for gobuffalo.pop.
     * @type {string}
     * @memberof RecoveryAddress
     */
    'created_at'?: string;
    /**
     *
     * @type {string}
     * @memberof RecoveryAddress
     */
    'id': string;
    /**
     * UpdatedAt is a helper struct field for gobuffalo.pop.
     * @type {string}
     * @memberof RecoveryAddress
     */
    'updated_at'?: string;
    /**
     *
     * @type {string}
     * @memberof RecoveryAddress
     */
    'value': string;
    /**
     *
     * @type {string}
     * @memberof RecoveryAddress
     */
    'via': string;
}
/**
 *
 * @export
 * @interface RelationQuery
 */
export interface RelationQuery {
    /**
     * Namespace of the Relation Tuple
     * @type {string}
     * @memberof RelationQuery
     */
    'namespace'?: string;
    /**
     * Object of the Relation Tuple
     * @type {string}
     * @memberof RelationQuery
     */
    'object'?: string;
    /**
     * Relation of the Relation Tuple
     * @type {string}
     * @memberof RelationQuery
     */
    'relation'?: string;
    /**
     * SubjectID of the Relation Tuple  Either SubjectSet or SubjectID can be provided.
     * @type {string}
     * @memberof RelationQuery
     */
    'subject_id'?: string;
    /**
     *
     * @type {SubjectSet}
     * @memberof RelationQuery
     */
    'subject_set'?: SubjectSet;
}
/**
 *
 * @export
 * @interface RevokedSessions
 */
export interface RevokedSessions {
    /**
     * The number of sessions that were revoked.
     * @type {number}
     * @memberof RevokedSessions
     */
    'count'?: number;
}
/**
 *
 * @export
 * @interface SchemaPatch
 */
export interface SchemaPatch {
    /**
     * The json schema
     * @type {object}
     * @memberof SchemaPatch
     */
    'data': object;
    /**
     * The user defined schema name
     * @type {string}
     * @memberof SchemaPatch
     */
    'name': string;
}
/**
 *
 * @export
 * @interface SelfServiceBrowserLocationChangeRequiredError
 */
export interface SelfServiceBrowserLocationChangeRequiredError {
    /**
     * The status code
     * @type {number}
     * @memberof SelfServiceBrowserLocationChangeRequiredError
     */
    'code'?: number;
    /**
     * Debug information  This field is often not exposed to protect against leaking sensitive information.
     * @type {string}
     * @memberof SelfServiceBrowserLocationChangeRequiredError
     */
    'debug'?: string;
    /**
     * Further error details
     * @type {{ [key: string]: object; }}
     * @memberof SelfServiceBrowserLocationChangeRequiredError
     */
    'details'?: {
        [key: string]: object;
    };
    /**
     * The error ID  Useful when trying to identify various errors in application logic.
     * @type {string}
     * @memberof SelfServiceBrowserLocationChangeRequiredError
     */
    'id'?: string;
    /**
     * Error message  The error\'s message.
     * @type {string}
     * @memberof SelfServiceBrowserLocationChangeRequiredError
     */
    'message': string;
    /**
     * A human-readable reason for the error
     * @type {string}
     * @memberof SelfServiceBrowserLocationChangeRequiredError
     */
    'reason'?: string;
    /**
     * Since when the flow has expired
     * @type {string}
     * @memberof SelfServiceBrowserLocationChangeRequiredError
     */
    'redirect_browser_to'?: string;
    /**
     * The request ID  The request ID is often exposed internally in order to trace errors across service architectures. This is often a UUID.
     * @type {string}
     * @memberof SelfServiceBrowserLocationChangeRequiredError
     */
    'request'?: string;
    /**
     * The status description
     * @type {string}
     * @memberof SelfServiceBrowserLocationChangeRequiredError
     */
    'status'?: string;
}
/**
 *
 * @export
 * @interface SelfServiceError
 */
export interface SelfServiceError {
    /**
     * CreatedAt is a helper struct field for gobuffalo.pop.
     * @type {string}
     * @memberof SelfServiceError
     */
    'created_at'?: string;
    /**
     *
     * @type {object}
     * @memberof SelfServiceError
     */
    'error'?: object;
    /**
     *
     * @type {string}
     * @memberof SelfServiceError
     */
    'id': string;
    /**
     * UpdatedAt is a helper struct field for gobuffalo.pop.
     * @type {string}
     * @memberof SelfServiceError
     */
    'updated_at'?: string;
}
/**
 * Is sent when a flow is expired
 * @export
 * @interface SelfServiceFlowExpiredError
 */
export interface SelfServiceFlowExpiredError {
    /**
     * The status code
     * @type {number}
     * @memberof SelfServiceFlowExpiredError
     */
    'code'?: number;
    /**
     * Debug information  This field is often not exposed to protect against leaking sensitive information.
     * @type {string}
     * @memberof SelfServiceFlowExpiredError
     */
    'debug'?: string;
    /**
     * Further error details
     * @type {{ [key: string]: object; }}
     * @memberof SelfServiceFlowExpiredError
     */
    'details'?: {
        [key: string]: object;
    };
    /**
     * The error ID  Useful when trying to identify various errors in application logic.
     * @type {string}
     * @memberof SelfServiceFlowExpiredError
     */
    'id'?: string;
    /**
     * Error message  The error\'s message.
     * @type {string}
     * @memberof SelfServiceFlowExpiredError
     */
    'message': string;
    /**
     * A human-readable reason for the error
     * @type {string}
     * @memberof SelfServiceFlowExpiredError
     */
    'reason'?: string;
    /**
     * The request ID  The request ID is often exposed internally in order to trace errors across service architectures. This is often a UUID.
     * @type {string}
     * @memberof SelfServiceFlowExpiredError
     */
    'request'?: string;
    /**
     * A Duration represents the elapsed time between two instants as an int64 nanosecond count. The representation limits the largest representable duration to approximately 290 years.
     * @type {number}
     * @memberof SelfServiceFlowExpiredError
     */
    'since'?: number;
    /**
     * The status description
     * @type {string}
     * @memberof SelfServiceFlowExpiredError
     */
    'status'?: string;
    /**
     *
     * @type {string}
     * @memberof SelfServiceFlowExpiredError
     */
    'use_flow_id'?: string;
}
/**
 * This object represents a login flow. A login flow is initiated at the \"Initiate Login API / Browser Flow\" endpoint by a client.  Once a login flow is completed successfully, a session cookie or session token will be issued.
 * @export
 * @interface SelfServiceLoginFlow
 */
export interface SelfServiceLoginFlow {
    /**
     *
     * @type {IdentityCredentialsType}
     * @memberof SelfServiceLoginFlow
     */
    'active'?: IdentityCredentialsType;
    /**
     * CreatedAt is a helper struct field for gobuffalo.pop.
     * @type {string}
     * @memberof SelfServiceLoginFlow
     */
    'created_at'?: string;
    /**
     * ExpiresAt is the time (UTC) when the flow expires. If the user still wishes to log in, a new flow has to be initiated.
     * @type {string}
     * @memberof SelfServiceLoginFlow
     */
    'expires_at': string;
    /**
     *
     * @type {string}
     * @memberof SelfServiceLoginFlow
     */
    'id': string;
    /**
     * IssuedAt is the time (UTC) when the flow started.
     * @type {string}
     * @memberof SelfServiceLoginFlow
     */
    'issued_at': string;
    /**
     * Refresh stores whether this login flow should enforce re-authentication.
     * @type {boolean}
     * @memberof SelfServiceLoginFlow
     */
    'refresh'?: boolean;
    /**
     * RequestURL is the initial URL that was requested from Ory Kratos. It can be used to forward information contained in the URL\'s path or query for example.
     * @type {string}
     * @memberof SelfServiceLoginFlow
     */
    'request_url': string;
    /**
     *
     * @type {AuthenticatorAssuranceLevel}
     * @memberof SelfServiceLoginFlow
     */
    'requested_aal'?: AuthenticatorAssuranceLevel;
    /**
     * ReturnTo contains the requested return_to URL.
     * @type {string}
     * @memberof SelfServiceLoginFlow
     */
    'return_to'?: string;
    /**
     * The flow type can either be `api` or `browser`.
     * @type {string}
     * @memberof SelfServiceLoginFlow
     */
    'type': string;
    /**
     *
     * @type {UiContainer}
     * @memberof SelfServiceLoginFlow
     */
    'ui': UiContainer;
    /**
     * UpdatedAt is a helper struct field for gobuffalo.pop.
     * @type {string}
     * @memberof SelfServiceLoginFlow
     */
    'updated_at'?: string;
}
/**
 *
 * @export
 * @interface SelfServiceLogoutUrl
 */
export interface SelfServiceLogoutUrl {
    /**
     * LogoutToken can be used to perform logout using AJAX.
     * @type {string}
     * @memberof SelfServiceLogoutUrl
     */
    'logout_token': string;
    /**
     * LogoutURL can be opened in a browser to sign the user out.  format: uri
     * @type {string}
     * @memberof SelfServiceLogoutUrl
     */
    'logout_url': string;
}
/**
 * This request is used when an identity wants to recover their account.  We recommend reading the [Account Recovery Documentation](../self-service/flows/password-reset-account-recovery)
 * @export
 * @interface SelfServiceRecoveryFlow
 */
export interface SelfServiceRecoveryFlow {
    /**
     * Active, if set, contains the registration method that is being used. It is initially not set.
     * @type {string}
     * @memberof SelfServiceRecoveryFlow
     */
    'active'?: string;
    /**
     * ExpiresAt is the time (UTC) when the request expires. If the user still wishes to update the setting, a new request has to be initiated.
     * @type {string}
     * @memberof SelfServiceRecoveryFlow
     */
    'expires_at': string;
    /**
     *
     * @type {string}
     * @memberof SelfServiceRecoveryFlow
     */
    'id': string;
    /**
     * IssuedAt is the time (UTC) when the request occurred.
     * @type {string}
     * @memberof SelfServiceRecoveryFlow
     */
    'issued_at': string;
    /**
     * RequestURL is the initial URL that was requested from Ory Kratos. It can be used to forward information contained in the URL\'s path or query for example.
     * @type {string}
     * @memberof SelfServiceRecoveryFlow
     */
    'request_url': string;
    /**
     * ReturnTo contains the requested return_to URL.
     * @type {string}
     * @memberof SelfServiceRecoveryFlow
     */
    'return_to'?: string;
    /**
     *
     * @type {SelfServiceRecoveryFlowState}
     * @memberof SelfServiceRecoveryFlow
     */
    'state': SelfServiceRecoveryFlowState;
    /**
     * The flow type can either be `api` or `browser`.
     * @type {string}
     * @memberof SelfServiceRecoveryFlow
     */
    'type': string;
    /**
     *
     * @type {UiContainer}
     * @memberof SelfServiceRecoveryFlow
     */
    'ui': UiContainer;
}
/**
 * The state represents the state of the recovery flow.  choose_method: ask the user to choose a method (e.g. recover account via email) sent_email: the email has been sent to the user passed_challenge: the request was successful and the recovery challenge was passed.
 * @export
 * @enum {string}
 */
export declare const SelfServiceRecoveryFlowState: {
    readonly ChooseMethod: "choose_method";
    readonly SentEmail: "sent_email";
    readonly PassedChallenge: "passed_challenge";
};
export declare type SelfServiceRecoveryFlowState = typeof SelfServiceRecoveryFlowState[keyof typeof SelfServiceRecoveryFlowState];
/**
 *
 * @export
 * @interface SelfServiceRecoveryLink
 */
export interface SelfServiceRecoveryLink {
    /**
     * Recovery Link Expires At  The timestamp when the recovery link expires.
     * @type {string}
     * @memberof SelfServiceRecoveryLink
     */
    'expires_at'?: string;
    /**
     * Recovery Link  This link can be used to recover the account.
     * @type {string}
     * @memberof SelfServiceRecoveryLink
     */
    'recovery_link': string;
}
/**
 *
 * @export
 * @interface SelfServiceRegistrationFlow
 */
export interface SelfServiceRegistrationFlow {
    /**
     *
     * @type {IdentityCredentialsType}
     * @memberof SelfServiceRegistrationFlow
     */
    'active'?: IdentityCredentialsType;
    /**
     * ExpiresAt is the time (UTC) when the flow expires. If the user still wishes to log in, a new flow has to be initiated.
     * @type {string}
     * @memberof SelfServiceRegistrationFlow
     */
    'expires_at': string;
    /**
     *
     * @type {string}
     * @memberof SelfServiceRegistrationFlow
     */
    'id': string;
    /**
     * IssuedAt is the time (UTC) when the flow occurred.
     * @type {string}
     * @memberof SelfServiceRegistrationFlow
     */
    'issued_at': string;
    /**
     * RequestURL is the initial URL that was requested from Ory Kratos. It can be used to forward information contained in the URL\'s path or query for example.
     * @type {string}
     * @memberof SelfServiceRegistrationFlow
     */
    'request_url': string;
    /**
     * ReturnTo contains the requested return_to URL.
     * @type {string}
     * @memberof SelfServiceRegistrationFlow
     */
    'return_to'?: string;
    /**
     * The flow type can either be `api` or `browser`.
     * @type {string}
     * @memberof SelfServiceRegistrationFlow
     */
    'type': string;
    /**
     *
     * @type {UiContainer}
     * @memberof SelfServiceRegistrationFlow
     */
    'ui': UiContainer;
}
/**
 * This flow is used when an identity wants to update settings (e.g. profile data, passwords, ...) in a selfservice manner.  We recommend reading the [User Settings Documentation](../self-service/flows/user-settings)
 * @export
 * @interface SelfServiceSettingsFlow
 */
export interface SelfServiceSettingsFlow {
    /**
     * Active, if set, contains the registration method that is being used. It is initially not set.
     * @type {string}
     * @memberof SelfServiceSettingsFlow
     */
    'active'?: string;
    /**
     * ExpiresAt is the time (UTC) when the flow expires. If the user still wishes to update the setting, a new flow has to be initiated.
     * @type {string}
     * @memberof SelfServiceSettingsFlow
     */
    'expires_at': string;
    /**
     *
     * @type {string}
     * @memberof SelfServiceSettingsFlow
     */
    'id': string;
    /**
     *
     * @type {Identity}
     * @memberof SelfServiceSettingsFlow
     */
    'identity': Identity;
    /**
     * IssuedAt is the time (UTC) when the flow occurred.
     * @type {string}
     * @memberof SelfServiceSettingsFlow
     */
    'issued_at': string;
    /**
     * RequestURL is the initial URL that was requested from Ory Kratos. It can be used to forward information contained in the URL\'s path or query for example.
     * @type {string}
     * @memberof SelfServiceSettingsFlow
     */
    'request_url': string;
    /**
     * ReturnTo contains the requested return_to URL.
     * @type {string}
     * @memberof SelfServiceSettingsFlow
     */
    'return_to'?: string;
    /**
     *
     * @type {SelfServiceSettingsFlowState}
     * @memberof SelfServiceSettingsFlow
     */
    'state': SelfServiceSettingsFlowState;
    /**
     * The flow type can either be `api` or `browser`.
     * @type {string}
     * @memberof SelfServiceSettingsFlow
     */
    'type': string;
    /**
     *
     * @type {UiContainer}
     * @memberof SelfServiceSettingsFlow
     */
    'ui': UiContainer;
}
/**
 * show_form: No user data has been collected, or it is invalid, and thus the form should be shown. success: Indicates that the settings flow has been updated successfully with the provided data. Done will stay true when repeatedly checking. If set to true, done will revert back to false only when a flow with invalid (e.g. \"please use a valid phone number\") data was sent.
 * @export
 * @enum {string}
 */
export declare const SelfServiceSettingsFlowState: {
    readonly ShowForm: "show_form";
    readonly Success: "success";
};
export declare type SelfServiceSettingsFlowState = typeof SelfServiceSettingsFlowState[keyof typeof SelfServiceSettingsFlowState];
/**
 * Used to verify an out-of-band communication channel such as an email address or a phone number.  For more information head over to: https://www.ory.sh/docs/kratos/selfservice/flows/verify-email-account-activation
 * @export
 * @interface SelfServiceVerificationFlow
 */
export interface SelfServiceVerificationFlow {
    /**
     * Active, if set, contains the registration method that is being used. It is initially not set.
     * @type {string}
     * @memberof SelfServiceVerificationFlow
     */
    'active'?: string;
    /**
     * ExpiresAt is the time (UTC) when the request expires. If the user still wishes to verify the address, a new request has to be initiated.
     * @type {string}
     * @memberof SelfServiceVerificationFlow
     */
    'expires_at'?: string;
    /**
     *
     * @type {string}
     * @memberof SelfServiceVerificationFlow
     */
    'id': string;
    /**
     * IssuedAt is the time (UTC) when the request occurred.
     * @type {string}
     * @memberof SelfServiceVerificationFlow
     */
    'issued_at'?: string;
    /**
     * RequestURL is the initial URL that was requested from Ory Kratos. It can be used to forward information contained in the URL\'s path or query for example.
     * @type {string}
     * @memberof SelfServiceVerificationFlow
     */
    'request_url'?: string;
    /**
     * ReturnTo contains the requested return_to URL.
     * @type {string}
     * @memberof SelfServiceVerificationFlow
     */
    'return_to'?: string;
    /**
     *
     * @type {SelfServiceVerificationFlowState}
     * @memberof SelfServiceVerificationFlow
     */
    'state': SelfServiceVerificationFlowState;
    /**
     * The flow type can either be `api` or `browser`.
     * @type {string}
     * @memberof SelfServiceVerificationFlow
     */
    'type': string;
    /**
     *
     * @type {UiContainer}
     * @memberof SelfServiceVerificationFlow
     */
    'ui': UiContainer;
}
/**
 * The state represents the state of the verification flow.  choose_method: ask the user to choose a method (e.g. recover account via email) sent_email: the email has been sent to the user passed_challenge: the request was successful and the recovery challenge was passed.
 * @export
 * @enum {string}
 */
export declare const SelfServiceVerificationFlowState: {
    readonly ChooseMethod: "choose_method";
    readonly SentEmail: "sent_email";
    readonly PassedChallenge: "passed_challenge";
};
export declare type SelfServiceVerificationFlowState = typeof SelfServiceVerificationFlowState[keyof typeof SelfServiceVerificationFlowState];
/**
 * A Session
 * @export
 * @interface Session
 */
export interface Session {
    /**
     * Active state. If false the session is no longer active.
     * @type {boolean}
     * @memberof Session
     */
    'active'?: boolean;
    /**
     * The Session Authentication Timestamp  When this session was authenticated at. If multi-factor authentication was used this is the time when the last factor was authenticated (e.g. the TOTP code challenge was completed).
     * @type {string}
     * @memberof Session
     */
    'authenticated_at'?: string;
    /**
     * A list of authenticators which were used to authenticate the session.
     * @type {Array<SessionAuthenticationMethod>}
     * @memberof Session
     */
    'authentication_methods'?: Array<SessionAuthenticationMethod>;
    /**
     *
     * @type {AuthenticatorAssuranceLevel}
     * @memberof Session
     */
    'authenticator_assurance_level'?: AuthenticatorAssuranceLevel;
    /**
     * The Session Expiry  When this session expires at.
     * @type {string}
     * @memberof Session
     */
    'expires_at'?: string;
    /**
     *
     * @type {string}
     * @memberof Session
     */
    'id': string;
    /**
     *
     * @type {Identity}
     * @memberof Session
     */
    'identity': Identity;
    /**
     * The Session Issuance Timestamp  When this session was issued at. Usually equal or close to `authenticated_at`.
     * @type {string}
     * @memberof Session
     */
    'issued_at'?: string;
}
/**
 * A singular authenticator used during authentication / login.
 * @export
 * @interface SessionAuthenticationMethod
 */
export interface SessionAuthenticationMethod {
    /**
     *
     * @type {AuthenticatorAssuranceLevel}
     * @memberof SessionAuthenticationMethod
     */
    'aal'?: AuthenticatorAssuranceLevel;
    /**
     * When the authentication challenge was completed.
     * @type {string}
     * @memberof SessionAuthenticationMethod
     */
    'completed_at'?: string;
    /**
     *
     * @type {string}
     * @memberof SessionAuthenticationMethod
     */
    'method'?: SessionAuthenticationMethodMethodEnum;
}
export declare const SessionAuthenticationMethodMethodEnum: {
    readonly LinkRecovery: "link_recovery";
    readonly Password: "password";
    readonly Totp: "totp";
    readonly Oidc: "oidc";
    readonly Webauthn: "webauthn";
    readonly LookupSecret: "lookup_secret";
    readonly V06LegacySession: "v0.6_legacy_session";
};
export declare type SessionAuthenticationMethodMethodEnum = typeof SessionAuthenticationMethodMethodEnum[keyof typeof SessionAuthenticationMethodMethodEnum];
/**
 *
 * @export
 * @interface SessionDevice
 */
export interface SessionDevice {
    /**
     * UserAgent of this device
     * @type {string}
     * @memberof SessionDevice
     */
    'user_agent'?: string;
}
/**
 *
 * @export
 * @interface SettingsProfileFormConfig
 */
export interface SettingsProfileFormConfig {
    /**
     * Action should be used as the form action URL `<form action=\"{{ .Action }}\" method=\"post\">`.
     * @type {string}
     * @memberof SettingsProfileFormConfig
     */
    'action': string;
    /**
     *
     * @type {Array<UiText>}
     * @memberof SettingsProfileFormConfig
     */
    'messages'?: Array<UiText>;
    /**
     * Method is the form method (e.g. POST)
     * @type {string}
     * @memberof SettingsProfileFormConfig
     */
    'method': string;
    /**
     *
     * @type {Array<UiNode>}
     * @memberof SettingsProfileFormConfig
     */
    'nodes': Array<UiNode>;
}
/**
 *
 * @export
 * @interface StripeCustomerResponse
 */
export interface StripeCustomerResponse {
    /**
     *
     * @type {string}
     * @memberof StripeCustomerResponse
     */
    'id'?: string;
}
/**
 *
 * @export
 * @interface SubjectSet
 */
export interface SubjectSet {
    /**
     * Namespace of the Subject Set
     * @type {string}
     * @memberof SubjectSet
     */
    'namespace': string;
    /**
     * Object of the Subject Set
     * @type {string}
     * @memberof SubjectSet
     */
    'object': string;
    /**
     * Relation of the Subject Set
     * @type {string}
     * @memberof SubjectSet
     */
    'relation': string;
}
/**
 *
 * @export
 * @interface SubmitSelfServiceFlowWithWebAuthnRegistrationMethod
 */
export interface SubmitSelfServiceFlowWithWebAuthnRegistrationMethod {
    /**
     * Register a WebAuthn Security Key  It is expected that the JSON returned by the WebAuthn registration process is included here.
     * @type {string}
     * @memberof SubmitSelfServiceFlowWithWebAuthnRegistrationMethod
     */
    'webauthn_register'?: string;
    /**
     * Name of the WebAuthn Security Key to be Added  A human-readable name for the security key which will be added.
     * @type {string}
     * @memberof SubmitSelfServiceFlowWithWebAuthnRegistrationMethod
     */
    'webauthn_register_displayname'?: string;
}
/**
 * @type SubmitSelfServiceLoginFlowBody
 * @export
 */
export declare type SubmitSelfServiceLoginFlowBody = SubmitSelfServiceLoginFlowWithLookupSecretMethodBody | SubmitSelfServiceLoginFlowWithOidcMethodBody | SubmitSelfServiceLoginFlowWithPasswordMethodBody | SubmitSelfServiceLoginFlowWithTotpMethodBody | SubmitSelfServiceLoginFlowWithWebAuthnMethodBody;
/**
 *
 * @export
 * @interface SubmitSelfServiceLoginFlowWithLookupSecretMethodBody
 */
export interface SubmitSelfServiceLoginFlowWithLookupSecretMethodBody {
    /**
     * Sending the anti-csrf token is only required for browser login flows.
     * @type {string}
     * @memberof SubmitSelfServiceLoginFlowWithLookupSecretMethodBody
     */
    'csrf_token'?: string;
    /**
     * The lookup secret.
     * @type {string}
     * @memberof SubmitSelfServiceLoginFlowWithLookupSecretMethodBody
     */
    'lookup_secret': string;
    /**
     * Method should be set to \"lookup_secret\" when logging in using the lookup_secret strategy.
     * @type {string}
     * @memberof SubmitSelfServiceLoginFlowWithLookupSecretMethodBody
     */
    'method': string;
}
/**
 * SubmitSelfServiceLoginFlowWithOidcMethodBody is used to decode the login form payload when using the oidc method.
 * @export
 * @interface SubmitSelfServiceLoginFlowWithOidcMethodBody
 */
export interface SubmitSelfServiceLoginFlowWithOidcMethodBody {
    /**
     * The CSRF Token
     * @type {string}
     * @memberof SubmitSelfServiceLoginFlowWithOidcMethodBody
     */
    'csrf_token'?: string;
    /**
     * Method to use  This field must be set to `oidc` when using the oidc method.
     * @type {string}
     * @memberof SubmitSelfServiceLoginFlowWithOidcMethodBody
     */
    'method': string;
    /**
     * The provider to register with
     * @type {string}
     * @memberof SubmitSelfServiceLoginFlowWithOidcMethodBody
     */
    'provider': string;
    /**
     * The identity traits. This is a placeholder for the registration flow.
     * @type {object}
     * @memberof SubmitSelfServiceLoginFlowWithOidcMethodBody
     */
    'traits'?: object;
}
/**
 *
 * @export
 * @interface SubmitSelfServiceLoginFlowWithPasswordMethodBody
 */
export interface SubmitSelfServiceLoginFlowWithPasswordMethodBody {
    /**
     * Sending the anti-csrf token is only required for browser login flows.
     * @type {string}
     * @memberof SubmitSelfServiceLoginFlowWithPasswordMethodBody
     */
    'csrf_token'?: string;
    /**
     * Identifier is the email or username of the user trying to log in.
     * @type {string}
     * @memberof SubmitSelfServiceLoginFlowWithPasswordMethodBody
     */
    'identifier': string;
    /**
     * Method should be set to \"password\" when logging in using the identifier and password strategy.
     * @type {string}
     * @memberof SubmitSelfServiceLoginFlowWithPasswordMethodBody
     */
    'method': string;
    /**
     * The user\'s password.
     * @type {string}
     * @memberof SubmitSelfServiceLoginFlowWithPasswordMethodBody
     */
    'password': string;
    /**
     * Identifier is the email or username of the user trying to log in. This field is deprecated!
     * @type {string}
     * @memberof SubmitSelfServiceLoginFlowWithPasswordMethodBody
     */
    'password_identifier'?: string;
}
/**
 *
 * @export
 * @interface SubmitSelfServiceLoginFlowWithTotpMethodBody
 */
export interface SubmitSelfServiceLoginFlowWithTotpMethodBody {
    /**
     * Sending the anti-csrf token is only required for browser login flows.
     * @type {string}
     * @memberof SubmitSelfServiceLoginFlowWithTotpMethodBody
     */
    'csrf_token'?: string;
    /**
     * Method should be set to \"totp\" when logging in using the TOTP strategy.
     * @type {string}
     * @memberof SubmitSelfServiceLoginFlowWithTotpMethodBody
     */
    'method': string;
    /**
     * The TOTP code.
     * @type {string}
     * @memberof SubmitSelfServiceLoginFlowWithTotpMethodBody
     */
    'totp_code': string;
}
/**
 *
 * @export
 * @interface SubmitSelfServiceLoginFlowWithWebAuthnMethodBody
 */
export interface SubmitSelfServiceLoginFlowWithWebAuthnMethodBody {
    /**
     * Sending the anti-csrf token is only required for browser login flows.
     * @type {string}
     * @memberof SubmitSelfServiceLoginFlowWithWebAuthnMethodBody
     */
    'csrf_token'?: string;
    /**
     * Identifier is the email or username of the user trying to log in. This field is only required when using WebAuthn for passwordless login. When using WebAuthn for multi-factor authentication, it is not needed.
     * @type {string}
     * @memberof SubmitSelfServiceLoginFlowWithWebAuthnMethodBody
     */
    'identifier'?: string;
    /**
     * Method should be set to \"webAuthn\" when logging in using the WebAuthn strategy.
     * @type {string}
     * @memberof SubmitSelfServiceLoginFlowWithWebAuthnMethodBody
     */
    'method': string;
    /**
     * Login a WebAuthn Security Key  This must contain the ID of the WebAuthN connection.
     * @type {string}
     * @memberof SubmitSelfServiceLoginFlowWithWebAuthnMethodBody
     */
    'webauthn_login'?: string;
}
/**
 * nolint:deadcode,unused
 * @export
 * @interface SubmitSelfServiceLogoutFlowWithoutBrowserBody
 */
export interface SubmitSelfServiceLogoutFlowWithoutBrowserBody {
    /**
     * The Session Token  Invalidate this session token.
     * @type {string}
     * @memberof SubmitSelfServiceLogoutFlowWithoutBrowserBody
     */
    'session_token': string;
}
/**
 * @type SubmitSelfServiceRecoveryFlowBody
 * @export
 */
export declare type SubmitSelfServiceRecoveryFlowBody = SubmitSelfServiceRecoveryFlowWithLinkMethodBody;
/**
 *
 * @export
 * @interface SubmitSelfServiceRecoveryFlowWithLinkMethodBody
 */
export interface SubmitSelfServiceRecoveryFlowWithLinkMethodBody {
    /**
     * Sending the anti-csrf token is only required for browser login flows.
     * @type {string}
     * @memberof SubmitSelfServiceRecoveryFlowWithLinkMethodBody
     */
    'csrf_token'?: string;
    /**
     * Email to Recover  Needs to be set when initiating the flow. If the email is a registered recovery email, a recovery link will be sent. If the email is not known, a email with details on what happened will be sent instead.  format: email
     * @type {string}
     * @memberof SubmitSelfServiceRecoveryFlowWithLinkMethodBody
     */
    'email': string;
    /**
     * Method supports `link` only right now.
     * @type {string}
     * @memberof SubmitSelfServiceRecoveryFlowWithLinkMethodBody
     */
    'method': string;
}
/**
 * @type SubmitSelfServiceRegistrationFlowBody
 * @export
 */
export declare type SubmitSelfServiceRegistrationFlowBody = SubmitSelfServiceRegistrationFlowWithOidcMethodBody | SubmitSelfServiceRegistrationFlowWithPasswordMethodBody | SubmitSelfServiceRegistrationFlowWithWebAuthnMethodBody;
/**
 * SubmitSelfServiceRegistrationFlowWithOidcMethodBody is used to decode the registration form payload when using the oidc method.
 * @export
 * @interface SubmitSelfServiceRegistrationFlowWithOidcMethodBody
 */
export interface SubmitSelfServiceRegistrationFlowWithOidcMethodBody {
    /**
     * The CSRF Token
     * @type {string}
     * @memberof SubmitSelfServiceRegistrationFlowWithOidcMethodBody
     */
    'csrf_token'?: string;
    /**
     * Method to use  This field must be set to `oidc` when using the oidc method.
     * @type {string}
     * @memberof SubmitSelfServiceRegistrationFlowWithOidcMethodBody
     */
    'method': string;
    /**
     * The provider to register with
     * @type {string}
     * @memberof SubmitSelfServiceRegistrationFlowWithOidcMethodBody
     */
    'provider': string;
    /**
     * The identity traits
     * @type {object}
     * @memberof SubmitSelfServiceRegistrationFlowWithOidcMethodBody
     */
    'traits'?: object;
}
/**
 * SubmitSelfServiceRegistrationFlowWithPasswordMethodBody is used to decode the registration form payload when using the password method.
 * @export
 * @interface SubmitSelfServiceRegistrationFlowWithPasswordMethodBody
 */
export interface SubmitSelfServiceRegistrationFlowWithPasswordMethodBody {
    /**
     * The CSRF Token
     * @type {string}
     * @memberof SubmitSelfServiceRegistrationFlowWithPasswordMethodBody
     */
    'csrf_token'?: string;
    /**
     * Method to use  This field must be set to `password` when using the password method.
     * @type {string}
     * @memberof SubmitSelfServiceRegistrationFlowWithPasswordMethodBody
     */
    'method': string;
    /**
     * Password to sign the user up with
     * @type {string}
     * @memberof SubmitSelfServiceRegistrationFlowWithPasswordMethodBody
     */
    'password': string;
    /**
     * The identity\'s traits
     * @type {object}
     * @memberof SubmitSelfServiceRegistrationFlowWithPasswordMethodBody
     */
    'traits': object;
}
/**
 *
 * @export
 * @interface SubmitSelfServiceRegistrationFlowWithWebAuthnMethodBody
 */
export interface SubmitSelfServiceRegistrationFlowWithWebAuthnMethodBody {
    /**
     * CSRFToken is the anti-CSRF token
     * @type {string}
     * @memberof SubmitSelfServiceRegistrationFlowWithWebAuthnMethodBody
     */
    'csrf_token'?: string;
    /**
     * Method  Should be set to \"webauthn\" when trying to add, update, or remove a webAuthn pairing.
     * @type {string}
     * @memberof SubmitSelfServiceRegistrationFlowWithWebAuthnMethodBody
     */
    'method': string;
    /**
     * The identity\'s traits
     * @type {object}
     * @memberof SubmitSelfServiceRegistrationFlowWithWebAuthnMethodBody
     */
    'traits': object;
    /**
     * Register a WebAuthn Security Key  It is expected that the JSON returned by the WebAuthn registration process is included here.
     * @type {string}
     * @memberof SubmitSelfServiceRegistrationFlowWithWebAuthnMethodBody
     */
    'webauthn_register'?: string;
    /**
     * Name of the WebAuthn Security Key to be Added  A human-readable name for the security key which will be added.
     * @type {string}
     * @memberof SubmitSelfServiceRegistrationFlowWithWebAuthnMethodBody
     */
    'webauthn_register_displayname'?: string;
}
/**
 * @type SubmitSelfServiceSettingsFlowBody
 * @export
 */
export declare type SubmitSelfServiceSettingsFlowBody = SubmitSelfServiceSettingsFlowWithLookupMethodBody | SubmitSelfServiceSettingsFlowWithOidcMethodBody | SubmitSelfServiceSettingsFlowWithPasswordMethodBody | SubmitSelfServiceSettingsFlowWithProfileMethodBody | SubmitSelfServiceSettingsFlowWithTotpMethodBody | SubmitSelfServiceSettingsFlowWithWebAuthnMethodBody;
/**
 *
 * @export
 * @interface SubmitSelfServiceSettingsFlowWithLookupMethodBody
 */
export interface SubmitSelfServiceSettingsFlowWithLookupMethodBody {
    /**
     * CSRFToken is the anti-CSRF token
     * @type {string}
     * @memberof SubmitSelfServiceSettingsFlowWithLookupMethodBody
     */
    'csrf_token'?: string;
    /**
     * If set to true will save the regenerated lookup secrets
     * @type {boolean}
     * @memberof SubmitSelfServiceSettingsFlowWithLookupMethodBody
     */
    'lookup_secret_confirm'?: boolean;
    /**
     * Disables this method if true.
     * @type {boolean}
     * @memberof SubmitSelfServiceSettingsFlowWithLookupMethodBody
     */
    'lookup_secret_disable'?: boolean;
    /**
     * If set to true will regenerate the lookup secrets
     * @type {boolean}
     * @memberof SubmitSelfServiceSettingsFlowWithLookupMethodBody
     */
    'lookup_secret_regenerate'?: boolean;
    /**
     * If set to true will reveal the lookup secrets
     * @type {boolean}
     * @memberof SubmitSelfServiceSettingsFlowWithLookupMethodBody
     */
    'lookup_secret_reveal'?: boolean;
    /**
     * Method  Should be set to \"lookup\" when trying to add, update, or remove a lookup pairing.
     * @type {string}
     * @memberof SubmitSelfServiceSettingsFlowWithLookupMethodBody
     */
    'method': string;
}
/**
 * nolint:deadcode,unused
 * @export
 * @interface SubmitSelfServiceSettingsFlowWithOidcMethodBody
 */
export interface SubmitSelfServiceSettingsFlowWithOidcMethodBody {
    /**
     * Flow ID is the flow\'s ID.  in: query
     * @type {string}
     * @memberof SubmitSelfServiceSettingsFlowWithOidcMethodBody
     */
    'flow'?: string;
    /**
     * Link this provider  Either this or `unlink` must be set.  type: string in: body
     * @type {string}
     * @memberof SubmitSelfServiceSettingsFlowWithOidcMethodBody
     */
    'link'?: string;
    /**
     * Method  Should be set to profile when trying to update a profile.
     * @type {string}
     * @memberof SubmitSelfServiceSettingsFlowWithOidcMethodBody
     */
    'method': string;
    /**
     * The identity\'s traits  in: body
     * @type {object}
     * @memberof SubmitSelfServiceSettingsFlowWithOidcMethodBody
     */
    'traits'?: object;
    /**
     * Unlink this provider  Either this or `link` must be set.  type: string in: body
     * @type {string}
     * @memberof SubmitSelfServiceSettingsFlowWithOidcMethodBody
     */
    'unlink'?: string;
}
/**
 *
 * @export
 * @interface SubmitSelfServiceSettingsFlowWithPasswordMethodBody
 */
export interface SubmitSelfServiceSettingsFlowWithPasswordMethodBody {
    /**
     * CSRFToken is the anti-CSRF token
     * @type {string}
     * @memberof SubmitSelfServiceSettingsFlowWithPasswordMethodBody
     */
    'csrf_token'?: string;
    /**
     * Method  Should be set to password when trying to update a password.
     * @type {string}
     * @memberof SubmitSelfServiceSettingsFlowWithPasswordMethodBody
     */
    'method': string;
    /**
     * Password is the updated password
     * @type {string}
     * @memberof SubmitSelfServiceSettingsFlowWithPasswordMethodBody
     */
    'password': string;
}
/**
 * nolint:deadcode,unused
 * @export
 * @interface SubmitSelfServiceSettingsFlowWithProfileMethodBody
 */
export interface SubmitSelfServiceSettingsFlowWithProfileMethodBody {
    /**
     * The Anti-CSRF Token  This token is only required when performing browser flows.
     * @type {string}
     * @memberof SubmitSelfServiceSettingsFlowWithProfileMethodBody
     */
    'csrf_token'?: string;
    /**
     * Method  Should be set to profile when trying to update a profile.
     * @type {string}
     * @memberof SubmitSelfServiceSettingsFlowWithProfileMethodBody
     */
    'method': string;
    /**
     * Traits contains all of the identity\'s traits.
     * @type {object}
     * @memberof SubmitSelfServiceSettingsFlowWithProfileMethodBody
     */
    'traits': object;
}
/**
 *
 * @export
 * @interface SubmitSelfServiceSettingsFlowWithTotpMethodBody
 */
export interface SubmitSelfServiceSettingsFlowWithTotpMethodBody {
    /**
     * CSRFToken is the anti-CSRF token
     * @type {string}
     * @memberof SubmitSelfServiceSettingsFlowWithTotpMethodBody
     */
    'csrf_token'?: string;
    /**
     * Method  Should be set to \"totp\" when trying to add, update, or remove a totp pairing.
     * @type {string}
     * @memberof SubmitSelfServiceSettingsFlowWithTotpMethodBody
     */
    'method': string;
    /**
     * ValidationTOTP must contain a valid TOTP based on the
     * @type {string}
     * @memberof SubmitSelfServiceSettingsFlowWithTotpMethodBody
     */
    'totp_code'?: string;
    /**
     * UnlinkTOTP if true will remove the TOTP pairing, effectively removing the credential. This can be used to set up a new TOTP device.
     * @type {boolean}
     * @memberof SubmitSelfServiceSettingsFlowWithTotpMethodBody
     */
    'totp_unlink'?: boolean;
}
/**
 *
 * @export
 * @interface SubmitSelfServiceSettingsFlowWithWebAuthnMethodBody
 */
export interface SubmitSelfServiceSettingsFlowWithWebAuthnMethodBody {
    /**
     * CSRFToken is the anti-CSRF token
     * @type {string}
     * @memberof SubmitSelfServiceSettingsFlowWithWebAuthnMethodBody
     */
    'csrf_token'?: string;
    /**
     * Method  Should be set to \"webauthn\" when trying to add, update, or remove a webAuthn pairing.
     * @type {string}
     * @memberof SubmitSelfServiceSettingsFlowWithWebAuthnMethodBody
     */
    'method': string;
    /**
     * Register a WebAuthn Security Key  It is expected that the JSON returned by the WebAuthn registration process is included here.
     * @type {string}
     * @memberof SubmitSelfServiceSettingsFlowWithWebAuthnMethodBody
     */
    'webauthn_register'?: string;
    /**
     * Name of the WebAuthn Security Key to be Added  A human-readable name for the security key which will be added.
     * @type {string}
     * @memberof SubmitSelfServiceSettingsFlowWithWebAuthnMethodBody
     */
    'webauthn_register_displayname'?: string;
    /**
     * Remove a WebAuthn Security Key  This must contain the ID of the WebAuthN connection.
     * @type {string}
     * @memberof SubmitSelfServiceSettingsFlowWithWebAuthnMethodBody
     */
    'webauthn_remove'?: string;
}
/**
 * @type SubmitSelfServiceVerificationFlowBody
 * nolint:deadcode,unused
 * @export
 */
export declare type SubmitSelfServiceVerificationFlowBody = SubmitSelfServiceVerificationFlowWithLinkMethodBody;
/**
 *
 * @export
 * @interface SubmitSelfServiceVerificationFlowWithLinkMethodBody
 */
export interface SubmitSelfServiceVerificationFlowWithLinkMethodBody {
    /**
     * Sending the anti-csrf token is only required for browser login flows.
     * @type {string}
     * @memberof SubmitSelfServiceVerificationFlowWithLinkMethodBody
     */
    'csrf_token'?: string;
    /**
     * Email to Verify  Needs to be set when initiating the flow. If the email is a registered verification email, a verification link will be sent. If the email is not known, a email with details on what happened will be sent instead.  format: email
     * @type {string}
     * @memberof SubmitSelfServiceVerificationFlowWithLinkMethodBody
     */
    'email': string;
    /**
     * Method supports `link` only right now.
     * @type {string}
     * @memberof SubmitSelfServiceVerificationFlowWithLinkMethodBody
     */
    'method': string;
}
/**
 *
 * @export
 * @interface Subscription
 */
export interface Subscription {
    /**
     *
     * @type {string}
     * @memberof Subscription
     */
    'created_at': string;
    /**
     * The currently active plan of the subscription unknown Unknown free Free start_up_monthly StartUpMonthly start_up_yearly StartUpYearly custom Custom
     * @type {string}
     * @memberof Subscription
     */
    'current_plan': SubscriptionCurrentPlanEnum;
    /**
     * The ID of the stripe customer
     * @type {string}
     * @memberof Subscription
     */
    'customer_id': string;
    /**
     *
     * @type {string}
     * @memberof Subscription
     */
    'id': string;
    /**
     *
     * @type {string}
     * @memberof Subscription
     */
    'ongoing_stripe_checkout_id'?: string | null;
    /**
     * Until when the subscription is payed
     * @type {string}
     * @memberof Subscription
     */
    'payed_until': string;
    /**
     *
     * @type {string}
     * @memberof Subscription
     */
    'plan_changes_at'?: string;
    /**
     *
     * @type {NullPlan}
     * @memberof Subscription
     */
    'plan_changes_to': NullPlan;
    /**
     *
     * @type {string}
     * @memberof Subscription
     */
    'status': string;
    /**
     *
     * @type {string}
     * @memberof Subscription
     */
    'updated_at': string;
}
export declare const SubscriptionCurrentPlanEnum: {
    readonly Unknown: "unknown";
    readonly Free: "free";
    readonly StartUpMonthly: "start_up_monthly";
    readonly StartUpYearly: "start_up_yearly";
    readonly Custom: "custom";
};
export declare type SubscriptionCurrentPlanEnum = typeof SubscriptionCurrentPlanEnum[keyof typeof SubscriptionCurrentPlanEnum];
/**
 *
 * @export
 * @interface SuccessfulProjectUpdate
 */
export interface SuccessfulProjectUpdate {
    /**
     *
     * @type {Project}
     * @memberof SuccessfulProjectUpdate
     */
    'project': Project;
    /**
     * Import Warnings  Not all configuration items can be imported to Ory Cloud. For example, setting the port does not make sense because Ory Cloud provides the runtime and networking.  This field contains warnings where configuration keys were found but can not be imported. These keys will be ignored by Ory Cloud. This field will help you understand why certain configuration keys might not be respected!
     * @type {Array<Warning>}
     * @memberof SuccessfulProjectUpdate
     */
    'warnings': Array<Warning>;
}
/**
 * The Response for Login Flows via API
 * @export
 * @interface SuccessfulSelfServiceLoginWithoutBrowser
 */
export interface SuccessfulSelfServiceLoginWithoutBrowser {
    /**
     *
     * @type {Session}
     * @memberof SuccessfulSelfServiceLoginWithoutBrowser
     */
    'session': Session;
    /**
     * The Session Token  A session token is equivalent to a session cookie, but it can be sent in the HTTP Authorization Header:  Authorization: bearer ${session-token}  The session token is only issued for API flows, not for Browser flows!
     * @type {string}
     * @memberof SuccessfulSelfServiceLoginWithoutBrowser
     */
    'session_token'?: string;
}
/**
 * The Response for Registration Flows via API
 * @export
 * @interface SuccessfulSelfServiceRegistrationWithoutBrowser
 */
export interface SuccessfulSelfServiceRegistrationWithoutBrowser {
    /**
     *
     * @type {Identity}
     * @memberof SuccessfulSelfServiceRegistrationWithoutBrowser
     */
    'identity': Identity;
    /**
     *
     * @type {Session}
     * @memberof SuccessfulSelfServiceRegistrationWithoutBrowser
     */
    'session'?: Session;
    /**
     * The Session Token  This field is only set when the session hook is configured as a post-registration hook.  A session token is equivalent to a session cookie, but it can be sent in the HTTP Authorization Header:  Authorization: bearer ${session-token}  The session token is only issued for API flows, not for Browser flows!
     * @type {string}
     * @memberof SuccessfulSelfServiceRegistrationWithoutBrowser
     */
    'session_token'?: string;
}
/**
 * Container represents a HTML Form. The container can work with both HTTP Form and JSON requests
 * @export
 * @interface UiContainer
 */
export interface UiContainer {
    /**
     * Action should be used as the form action URL `<form action=\"{{ .Action }}\" method=\"post\">`.
     * @type {string}
     * @memberof UiContainer
     */
    'action': string;
    /**
     *
     * @type {Array<UiText>}
     * @memberof UiContainer
     */
    'messages'?: Array<UiText>;
    /**
     * Method is the form method (e.g. POST)
     * @type {string}
     * @memberof UiContainer
     */
    'method': string;
    /**
     *
     * @type {Array<UiNode>}
     * @memberof UiContainer
     */
    'nodes': Array<UiNode>;
}
/**
 * Nodes are represented as HTML elements or their native UI equivalents. For example, a node can be an `<img>` tag, or an `<input element>` but also `some plain text`.
 * @export
 * @interface UiNode
 */
export interface UiNode {
    /**
     *
     * @type {UiNodeAttributes}
     * @memberof UiNode
     */
    'attributes': UiNodeAttributes;
    /**
     * Group specifies which group (e.g. password authenticator) this node belongs to.
     * @type {string}
     * @memberof UiNode
     */
    'group': UiNodeGroupEnum;
    /**
     *
     * @type {Array<UiText>}
     * @memberof UiNode
     */
    'messages': Array<UiText>;
    /**
     *
     * @type {UiNodeMeta}
     * @memberof UiNode
     */
    'meta': UiNodeMeta;
    /**
     * The node\'s type
     * @type {string}
     * @memberof UiNode
     */
    'type': UiNodeTypeEnum;
}
export declare const UiNodeGroupEnum: {
    readonly Default: "default";
    readonly Password: "password";
    readonly Oidc: "oidc";
    readonly Profile: "profile";
    readonly Link: "link";
    readonly Totp: "totp";
    readonly LookupSecret: "lookup_secret";
    readonly Webauthn: "webauthn";
};
export declare type UiNodeGroupEnum = typeof UiNodeGroupEnum[keyof typeof UiNodeGroupEnum];
export declare const UiNodeTypeEnum: {
    readonly Text: "text";
    readonly Input: "input";
    readonly Img: "img";
    readonly A: "a";
    readonly Script: "script";
};
export declare type UiNodeTypeEnum = typeof UiNodeTypeEnum[keyof typeof UiNodeTypeEnum];
/**
 *
 * @export
 * @interface UiNodeAnchorAttributes
 */
export interface UiNodeAnchorAttributes {
    /**
     * The link\'s href (destination) URL.  format: uri
     * @type {string}
     * @memberof UiNodeAnchorAttributes
     */
    'href': string;
    /**
     * A unique identifier
     * @type {string}
     * @memberof UiNodeAnchorAttributes
     */
    'id': string;
    /**
     * NodeType represents this node\'s types. It is a mirror of `node.type` and is primarily used to allow compatibility with OpenAPI 3.0.  In this struct it technically always is \"a\".
     * @type {string}
     * @memberof UiNodeAnchorAttributes
     */
    'node_type': string;
    /**
     *
     * @type {UiText}
     * @memberof UiNodeAnchorAttributes
     */
    'title': UiText;
}
/**
 * @type UiNodeAttributes
 * @export
 */
export declare type UiNodeAttributes = UiNodeAnchorAttributes | UiNodeImageAttributes | UiNodeInputAttributes | UiNodeScriptAttributes | UiNodeTextAttributes;
/**
 *
 * @export
 * @interface UiNodeImageAttributes
 */
export interface UiNodeImageAttributes {
    /**
     * Height of the image
     * @type {number}
     * @memberof UiNodeImageAttributes
     */
    'height': number;
    /**
     * A unique identifier
     * @type {string}
     * @memberof UiNodeImageAttributes
     */
    'id': string;
    /**
     * NodeType represents this node\'s types. It is a mirror of `node.type` and is primarily used to allow compatibility with OpenAPI 3.0.  In this struct it technically always is \"img\".
     * @type {string}
     * @memberof UiNodeImageAttributes
     */
    'node_type': string;
    /**
     * The image\'s source URL.  format: uri
     * @type {string}
     * @memberof UiNodeImageAttributes
     */
    'src': string;
    /**
     * Width of the image
     * @type {number}
     * @memberof UiNodeImageAttributes
     */
    'width': number;
}
/**
 * InputAttributes represents the attributes of an input node
 * @export
 * @interface UiNodeInputAttributes
 */
export interface UiNodeInputAttributes {
    /**
     * Sets the input\'s disabled field to true or false.
     * @type {boolean}
     * @memberof UiNodeInputAttributes
     */
    'disabled': boolean;
    /**
     *
     * @type {UiText}
     * @memberof UiNodeInputAttributes
     */
    'label'?: UiText;
    /**
     * The input\'s element name.
     * @type {string}
     * @memberof UiNodeInputAttributes
     */
    'name': string;
    /**
     * NodeType represents this node\'s types. It is a mirror of `node.type` and is primarily used to allow compatibility with OpenAPI 3.0.  In this struct it technically always is \"input\".
     * @type {string}
     * @memberof UiNodeInputAttributes
     */
    'node_type': string;
    /**
     * OnClick may contain javascript which should be executed on click. This is primarily used for WebAuthn.
     * @type {string}
     * @memberof UiNodeInputAttributes
     */
    'onclick'?: string;
    /**
     * The input\'s pattern.
     * @type {string}
     * @memberof UiNodeInputAttributes
     */
    'pattern'?: string;
    /**
     * Mark this input field as required.
     * @type {boolean}
     * @memberof UiNodeInputAttributes
     */
    'required'?: boolean;
    /**
     *
     * @type {string}
     * @memberof UiNodeInputAttributes
     */
    'type': string;
    /**
     * The input\'s value.
     * @type {any}
     * @memberof UiNodeInputAttributes
     */
    'value'?: any | null;
}
/**
 * This might include a label and other information that can optionally be used to render UIs.
 * @export
 * @interface UiNodeMeta
 */
export interface UiNodeMeta {
    /**
     *
     * @type {UiText}
     * @memberof UiNodeMeta
     */
    'label'?: UiText;
}
/**
 *
 * @export
 * @interface UiNodeScriptAttributes
 */
export interface UiNodeScriptAttributes {
    /**
     * The script async type
     * @type {boolean}
     * @memberof UiNodeScriptAttributes
     */
    'async': boolean;
    /**
     * The script cross origin policy
     * @type {string}
     * @memberof UiNodeScriptAttributes
     */
    'crossorigin': string;
    /**
     * A unique identifier
     * @type {string}
     * @memberof UiNodeScriptAttributes
     */
    'id': string;
    /**
     * The script\'s integrity hash
     * @type {string}
     * @memberof UiNodeScriptAttributes
     */
    'integrity': string;
    /**
     * NodeType represents this node\'s types. It is a mirror of `node.type` and is primarily used to allow compatibility with OpenAPI 3.0. In this struct it technically always is \"script\".
     * @type {string}
     * @memberof UiNodeScriptAttributes
     */
    'node_type': string;
    /**
     * Nonce for CSP  A nonce you may want to use to improve your Content Security Policy. You do not have to use this value but if you want to improve your CSP policies you may use it. You can also choose to use your own nonce value!
     * @type {string}
     * @memberof UiNodeScriptAttributes
     */
    'nonce': string;
    /**
     * The script referrer policy
     * @type {string}
     * @memberof UiNodeScriptAttributes
     */
    'referrerpolicy': string;
    /**
     * The script source
     * @type {string}
     * @memberof UiNodeScriptAttributes
     */
    'src': string;
    /**
     * The script MIME type
     * @type {string}
     * @memberof UiNodeScriptAttributes
     */
    'type': string;
}
/**
 *
 * @export
 * @interface UiNodeTextAttributes
 */
export interface UiNodeTextAttributes {
    /**
     * A unique identifier
     * @type {string}
     * @memberof UiNodeTextAttributes
     */
    'id': string;
    /**
     * NodeType represents this node\'s types. It is a mirror of `node.type` and is primarily used to allow compatibility with OpenAPI 3.0.  In this struct it technically always is \"text\".
     * @type {string}
     * @memberof UiNodeTextAttributes
     */
    'node_type': string;
    /**
     *
     * @type {UiText}
     * @memberof UiNodeTextAttributes
     */
    'text': UiText;
}
/**
 *
 * @export
 * @interface UiText
 */
export interface UiText {
    /**
     * The message\'s context. Useful when customizing messages.
     * @type {object}
     * @memberof UiText
     */
    'context'?: object;
    /**
     *
     * @type {number}
     * @memberof UiText
     */
    'id': number;
    /**
     * The message text. Written in american english.
     * @type {string}
     * @memberof UiText
     */
    'text': string;
    /**
     *
     * @type {string}
     * @memberof UiText
     */
    'type': string;
}
/**
 *
 * @export
 * @interface UpdateCustomHostnameBody
 */
export interface UpdateCustomHostnameBody {
    /**
     * The domain where cookies will be set. Has to be a parent domain of the custom hostname to work.
     * @type {string}
     * @memberof UpdateCustomHostnameBody
     */
    'cookie_domain'?: string;
    /**
     * CORS Allowed origins for the custom hostname.
     * @type {Array<string>}
     * @memberof UpdateCustomHostnameBody
     */
    'cors_allowed_origins'?: Array<string>;
    /**
     * CORS Enabled for the custom hostname.
     * @type {boolean}
     * @memberof UpdateCustomHostnameBody
     */
    'cors_enabled'?: boolean;
    /**
     * The custom hostname where the API will be exposed.
     * @type {string}
     * @memberof UpdateCustomHostnameBody
     */
    'hostname'?: string;
}
/**
 *
 * @export
 * @interface UpdateProject
 */
export interface UpdateProject {
    /**
     * The name of the project.
     * @type {string}
     * @memberof UpdateProject
     */
    'name': string;
    /**
     *
     * @type {ProjectServices}
     * @memberof UpdateProject
     */
    'services': ProjectServices;
}
/**
 *
 * @export
 * @interface UpdateSubscriptionPayload
 */
export interface UpdateSubscriptionPayload {
    /**
     *
     * @type {string}
     * @memberof UpdateSubscriptionPayload
     */
    'plan_or_price': string;
    /**
     *
     * @type {string}
     * @memberof UpdateSubscriptionPayload
     */
    'return_to'?: string;
}
/**
 * VerifiableAddress is an identity\'s verifiable address
 * @export
 * @interface VerifiableIdentityAddress
 */
export interface VerifiableIdentityAddress {
    /**
     * When this entry was created
     * @type {string}
     * @memberof VerifiableIdentityAddress
     */
    'created_at'?: string;
    /**
     *
     * @type {string}
     * @memberof VerifiableIdentityAddress
     */
    'id': string;
    /**
     * VerifiableAddressStatus must not exceed 16 characters as that is the limitation in the SQL Schema
     * @type {string}
     * @memberof VerifiableIdentityAddress
     */
    'status': string;
    /**
     * When this entry was last updated
     * @type {string}
     * @memberof VerifiableIdentityAddress
     */
    'updated_at'?: string;
    /**
     * The address value  example foo@user.com
     * @type {string}
     * @memberof VerifiableIdentityAddress
     */
    'value': string;
    /**
     * Indicates if the address has already been verified
     * @type {boolean}
     * @memberof VerifiableIdentityAddress
     */
    'verified': boolean;
    /**
     *
     * @type {string}
     * @memberof VerifiableIdentityAddress
     */
    'verified_at'?: string;
    /**
     * VerifiableAddressType must not exceed 16 characters as that is the limitation in the SQL Schema
     * @type {string}
     * @memberof VerifiableIdentityAddress
     */
    'via': string;
}
/**
 *
 * @export
 * @interface Version
 */
export interface Version {
    /**
     * Version is the service\'s version.
     * @type {string}
     * @memberof Version
     */
    'version'?: string;
}
/**
 *
 * @export
 * @interface Warning
 */
export interface Warning {
    /**
     *
     * @type {number}
     * @memberof Warning
     */
    'code'?: number;
    /**
     *
     * @type {string}
     * @memberof Warning
     */
    'message'?: string;
}
/**
 * MetadataApi - axios parameter creator
 * @export
 */
export declare const MetadataApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     * This endpoint returns the version of Ory Kratos.  If the service supports TLS Edge Termination, this endpoint does not require the `X-Forwarded-Proto` header to be set.  Be aware that if you are running multiple nodes of this service, the version will never refer to the cluster state, only to a single instance.
     * @summary Return Running Software Version.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getVersion: (options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoint returns a HTTP 200 status code when Ory Kratos is accepting incoming HTTP requests. This status does currently not include checks whether the database connection is working.  If the service supports TLS Edge Termination, this endpoint does not require the `X-Forwarded-Proto` header to be set.  Be aware that if you are running multiple nodes of this service, the health status will never refer to the cluster state, only to a single instance.
     * @summary Check HTTP Server Status
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    isAlive: (options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoint returns a HTTP 200 status code when Ory Kratos is up running and the environment dependencies (e.g. the database) are responsive as well.  If the service supports TLS Edge Termination, this endpoint does not require the `X-Forwarded-Proto` header to be set.  Be aware that if you are running multiple nodes of Ory Kratos, the health status will never refer to the cluster state, only to a single instance.
     * @summary Check HTTP Server and Database Status
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    isReady: (options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * MetadataApi - functional programming interface
 * @export
 */
export declare const MetadataApiFp: (configuration?: Configuration) => {
    /**
     * This endpoint returns the version of Ory Kratos.  If the service supports TLS Edge Termination, this endpoint does not require the `X-Forwarded-Proto` header to be set.  Be aware that if you are running multiple nodes of this service, the version will never refer to the cluster state, only to a single instance.
     * @summary Return Running Software Version.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getVersion(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<InlineResponse2001>>;
    /**
     * This endpoint returns a HTTP 200 status code when Ory Kratos is accepting incoming HTTP requests. This status does currently not include checks whether the database connection is working.  If the service supports TLS Edge Termination, this endpoint does not require the `X-Forwarded-Proto` header to be set.  Be aware that if you are running multiple nodes of this service, the health status will never refer to the cluster state, only to a single instance.
     * @summary Check HTTP Server Status
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    isAlive(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<InlineResponse200>>;
    /**
     * This endpoint returns a HTTP 200 status code when Ory Kratos is up running and the environment dependencies (e.g. the database) are responsive as well.  If the service supports TLS Edge Termination, this endpoint does not require the `X-Forwarded-Proto` header to be set.  Be aware that if you are running multiple nodes of Ory Kratos, the health status will never refer to the cluster state, only to a single instance.
     * @summary Check HTTP Server and Database Status
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    isReady(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<InlineResponse200>>;
};
/**
 * MetadataApi - factory interface
 * @export
 */
export declare const MetadataApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     * This endpoint returns the version of Ory Kratos.  If the service supports TLS Edge Termination, this endpoint does not require the `X-Forwarded-Proto` header to be set.  Be aware that if you are running multiple nodes of this service, the version will never refer to the cluster state, only to a single instance.
     * @summary Return Running Software Version.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getVersion(options?: any): AxiosPromise<InlineResponse2001>;
    /**
     * This endpoint returns a HTTP 200 status code when Ory Kratos is accepting incoming HTTP requests. This status does currently not include checks whether the database connection is working.  If the service supports TLS Edge Termination, this endpoint does not require the `X-Forwarded-Proto` header to be set.  Be aware that if you are running multiple nodes of this service, the health status will never refer to the cluster state, only to a single instance.
     * @summary Check HTTP Server Status
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    isAlive(options?: any): AxiosPromise<InlineResponse200>;
    /**
     * This endpoint returns a HTTP 200 status code when Ory Kratos is up running and the environment dependencies (e.g. the database) are responsive as well.  If the service supports TLS Edge Termination, this endpoint does not require the `X-Forwarded-Proto` header to be set.  Be aware that if you are running multiple nodes of Ory Kratos, the health status will never refer to the cluster state, only to a single instance.
     * @summary Check HTTP Server and Database Status
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    isReady(options?: any): AxiosPromise<InlineResponse200>;
};
/**
 * MetadataApi - interface
 * @export
 * @interface MetadataApi
 */
export interface MetadataApiInterface {
    /**
     * This endpoint returns the version of Ory Kratos.  If the service supports TLS Edge Termination, this endpoint does not require the `X-Forwarded-Proto` header to be set.  Be aware that if you are running multiple nodes of this service, the version will never refer to the cluster state, only to a single instance.
     * @summary Return Running Software Version.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MetadataApiInterface
     */
    getVersion(options?: AxiosRequestConfig): AxiosPromise<InlineResponse2001>;
    /**
     * This endpoint returns a HTTP 200 status code when Ory Kratos is accepting incoming HTTP requests. This status does currently not include checks whether the database connection is working.  If the service supports TLS Edge Termination, this endpoint does not require the `X-Forwarded-Proto` header to be set.  Be aware that if you are running multiple nodes of this service, the health status will never refer to the cluster state, only to a single instance.
     * @summary Check HTTP Server Status
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MetadataApiInterface
     */
    isAlive(options?: AxiosRequestConfig): AxiosPromise<InlineResponse200>;
    /**
     * This endpoint returns a HTTP 200 status code when Ory Kratos is up running and the environment dependencies (e.g. the database) are responsive as well.  If the service supports TLS Edge Termination, this endpoint does not require the `X-Forwarded-Proto` header to be set.  Be aware that if you are running multiple nodes of Ory Kratos, the health status will never refer to the cluster state, only to a single instance.
     * @summary Check HTTP Server and Database Status
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MetadataApiInterface
     */
    isReady(options?: AxiosRequestConfig): AxiosPromise<InlineResponse200>;
}
/**
 * MetadataApi - object-oriented interface
 * @export
 * @class MetadataApi
 * @extends {BaseAPI}
 */
export declare class MetadataApi extends BaseAPI implements MetadataApiInterface {
    /**
     * This endpoint returns the version of Ory Kratos.  If the service supports TLS Edge Termination, this endpoint does not require the `X-Forwarded-Proto` header to be set.  Be aware that if you are running multiple nodes of this service, the version will never refer to the cluster state, only to a single instance.
     * @summary Return Running Software Version.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MetadataApi
     */
    getVersion(options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<InlineResponse2001>>;
    /**
     * This endpoint returns a HTTP 200 status code when Ory Kratos is accepting incoming HTTP requests. This status does currently not include checks whether the database connection is working.  If the service supports TLS Edge Termination, this endpoint does not require the `X-Forwarded-Proto` header to be set.  Be aware that if you are running multiple nodes of this service, the health status will never refer to the cluster state, only to a single instance.
     * @summary Check HTTP Server Status
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MetadataApi
     */
    isAlive(options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<InlineResponse200>>;
    /**
     * This endpoint returns a HTTP 200 status code when Ory Kratos is up running and the environment dependencies (e.g. the database) are responsive as well.  If the service supports TLS Edge Termination, this endpoint does not require the `X-Forwarded-Proto` header to be set.  Be aware that if you are running multiple nodes of Ory Kratos, the health status will never refer to the cluster state, only to a single instance.
     * @summary Check HTTP Server and Database Status
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MetadataApi
     */
    isReady(options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<InlineResponse200>>;
}
/**
 * ReadApi - axios parameter creator
 * @export
 */
export declare const ReadApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     * To learn how relation tuples and the check works, head over to [the documentation](../concepts/relation-tuples.mdx).
     * @summary Check a relation tuple
     * @param {string} [namespace] Namespace of the Relation Tuple
     * @param {string} [object] Object of the Relation Tuple
     * @param {string} [relation] Relation of the Relation Tuple
     * @param {string} [subjectId] SubjectID of the Relation Tuple
     * @param {string} [subjectSetNamespace] Namespace of the Subject Set
     * @param {string} [subjectSetObject] Object of the Subject Set
     * @param {string} [subjectSetRelation] Relation of the Subject Set
     * @param {number} [maxDepth]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getCheck: (namespace?: string, object?: string, relation?: string, subjectId?: string, subjectSetNamespace?: string, subjectSetObject?: string, subjectSetRelation?: string, maxDepth?: number, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * Use this endpoint to expand a relation tuple.
     * @summary Expand a Relation Tuple
     * @param {string} namespace Namespace of the Subject Set
     * @param {string} object Object of the Subject Set
     * @param {string} relation Relation of the Subject Set
     * @param {number} [maxDepth]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getExpand: (namespace: string, object: string, relation: string, maxDepth?: number, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * Get all relation tuples that match the query. Only the namespace field is required.
     * @summary Query relation tuples
     * @param {string} [pageToken]
     * @param {number} [pageSize]
     * @param {string} [namespace] Namespace of the Relation Tuple
     * @param {string} [object] Object of the Relation Tuple
     * @param {string} [relation] Relation of the Relation Tuple
     * @param {string} [subjectId] SubjectID of the Relation Tuple
     * @param {string} [subjectSetNamespace] Namespace of the Subject Set
     * @param {string} [subjectSetObject] Object of the Subject Set
     * @param {string} [subjectSetRelation] Relation of the Subject Set
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getRelationTuples: (pageToken?: string, pageSize?: number, namespace?: string, object?: string, relation?: string, subjectId?: string, subjectSetNamespace?: string, subjectSetObject?: string, subjectSetRelation?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * To learn how relation tuples and the check works, head over to [the documentation](../concepts/relation-tuples.mdx).
     * @summary Check a relation tuple
     * @param {number} [maxDepth]
     * @param {RelationQuery} [relationQuery]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    postCheck: (maxDepth?: number, relationQuery?: RelationQuery, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * ReadApi - functional programming interface
 * @export
 */
export declare const ReadApiFp: (configuration?: Configuration) => {
    /**
     * To learn how relation tuples and the check works, head over to [the documentation](../concepts/relation-tuples.mdx).
     * @summary Check a relation tuple
     * @param {string} [namespace] Namespace of the Relation Tuple
     * @param {string} [object] Object of the Relation Tuple
     * @param {string} [relation] Relation of the Relation Tuple
     * @param {string} [subjectId] SubjectID of the Relation Tuple
     * @param {string} [subjectSetNamespace] Namespace of the Subject Set
     * @param {string} [subjectSetObject] Object of the Subject Set
     * @param {string} [subjectSetRelation] Relation of the Subject Set
     * @param {number} [maxDepth]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getCheck(namespace?: string, object?: string, relation?: string, subjectId?: string, subjectSetNamespace?: string, subjectSetObject?: string, subjectSetRelation?: string, maxDepth?: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GetCheckResponse>>;
    /**
     * Use this endpoint to expand a relation tuple.
     * @summary Expand a Relation Tuple
     * @param {string} namespace Namespace of the Subject Set
     * @param {string} object Object of the Subject Set
     * @param {string} relation Relation of the Subject Set
     * @param {number} [maxDepth]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getExpand(namespace: string, object: string, relation: string, maxDepth?: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ExpandTree>>;
    /**
     * Get all relation tuples that match the query. Only the namespace field is required.
     * @summary Query relation tuples
     * @param {string} [pageToken]
     * @param {number} [pageSize]
     * @param {string} [namespace] Namespace of the Relation Tuple
     * @param {string} [object] Object of the Relation Tuple
     * @param {string} [relation] Relation of the Relation Tuple
     * @param {string} [subjectId] SubjectID of the Relation Tuple
     * @param {string} [subjectSetNamespace] Namespace of the Subject Set
     * @param {string} [subjectSetObject] Object of the Subject Set
     * @param {string} [subjectSetRelation] Relation of the Subject Set
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getRelationTuples(pageToken?: string, pageSize?: number, namespace?: string, object?: string, relation?: string, subjectId?: string, subjectSetNamespace?: string, subjectSetObject?: string, subjectSetRelation?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GetRelationTuplesResponse>>;
    /**
     * To learn how relation tuples and the check works, head over to [the documentation](../concepts/relation-tuples.mdx).
     * @summary Check a relation tuple
     * @param {number} [maxDepth]
     * @param {RelationQuery} [relationQuery]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    postCheck(maxDepth?: number, relationQuery?: RelationQuery, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GetCheckResponse>>;
};
/**
 * ReadApi - factory interface
 * @export
 */
export declare const ReadApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     * To learn how relation tuples and the check works, head over to [the documentation](../concepts/relation-tuples.mdx).
     * @summary Check a relation tuple
     * @param {string} [namespace] Namespace of the Relation Tuple
     * @param {string} [object] Object of the Relation Tuple
     * @param {string} [relation] Relation of the Relation Tuple
     * @param {string} [subjectId] SubjectID of the Relation Tuple
     * @param {string} [subjectSetNamespace] Namespace of the Subject Set
     * @param {string} [subjectSetObject] Object of the Subject Set
     * @param {string} [subjectSetRelation] Relation of the Subject Set
     * @param {number} [maxDepth]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getCheck(namespace?: string, object?: string, relation?: string, subjectId?: string, subjectSetNamespace?: string, subjectSetObject?: string, subjectSetRelation?: string, maxDepth?: number, options?: any): AxiosPromise<GetCheckResponse>;
    /**
     * Use this endpoint to expand a relation tuple.
     * @summary Expand a Relation Tuple
     * @param {string} namespace Namespace of the Subject Set
     * @param {string} object Object of the Subject Set
     * @param {string} relation Relation of the Subject Set
     * @param {number} [maxDepth]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getExpand(namespace: string, object: string, relation: string, maxDepth?: number, options?: any): AxiosPromise<ExpandTree>;
    /**
     * Get all relation tuples that match the query. Only the namespace field is required.
     * @summary Query relation tuples
     * @param {string} [pageToken]
     * @param {number} [pageSize]
     * @param {string} [namespace] Namespace of the Relation Tuple
     * @param {string} [object] Object of the Relation Tuple
     * @param {string} [relation] Relation of the Relation Tuple
     * @param {string} [subjectId] SubjectID of the Relation Tuple
     * @param {string} [subjectSetNamespace] Namespace of the Subject Set
     * @param {string} [subjectSetObject] Object of the Subject Set
     * @param {string} [subjectSetRelation] Relation of the Subject Set
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getRelationTuples(pageToken?: string, pageSize?: number, namespace?: string, object?: string, relation?: string, subjectId?: string, subjectSetNamespace?: string, subjectSetObject?: string, subjectSetRelation?: string, options?: any): AxiosPromise<GetRelationTuplesResponse>;
    /**
     * To learn how relation tuples and the check works, head over to [the documentation](../concepts/relation-tuples.mdx).
     * @summary Check a relation tuple
     * @param {number} [maxDepth]
     * @param {RelationQuery} [relationQuery]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    postCheck(maxDepth?: number, relationQuery?: RelationQuery, options?: any): AxiosPromise<GetCheckResponse>;
};
/**
 * ReadApi - interface
 * @export
 * @interface ReadApi
 */
export interface ReadApiInterface {
    /**
     * To learn how relation tuples and the check works, head over to [the documentation](../concepts/relation-tuples.mdx).
     * @summary Check a relation tuple
     * @param {string} [namespace] Namespace of the Relation Tuple
     * @param {string} [object] Object of the Relation Tuple
     * @param {string} [relation] Relation of the Relation Tuple
     * @param {string} [subjectId] SubjectID of the Relation Tuple
     * @param {string} [subjectSetNamespace] Namespace of the Subject Set
     * @param {string} [subjectSetObject] Object of the Subject Set
     * @param {string} [subjectSetRelation] Relation of the Subject Set
     * @param {number} [maxDepth]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ReadApiInterface
     */
    getCheck(namespace?: string, object?: string, relation?: string, subjectId?: string, subjectSetNamespace?: string, subjectSetObject?: string, subjectSetRelation?: string, maxDepth?: number, options?: AxiosRequestConfig): AxiosPromise<GetCheckResponse>;
    /**
     * Use this endpoint to expand a relation tuple.
     * @summary Expand a Relation Tuple
     * @param {string} namespace Namespace of the Subject Set
     * @param {string} object Object of the Subject Set
     * @param {string} relation Relation of the Subject Set
     * @param {number} [maxDepth]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ReadApiInterface
     */
    getExpand(namespace: string, object: string, relation: string, maxDepth?: number, options?: AxiosRequestConfig): AxiosPromise<ExpandTree>;
    /**
     * Get all relation tuples that match the query. Only the namespace field is required.
     * @summary Query relation tuples
     * @param {string} [pageToken]
     * @param {number} [pageSize]
     * @param {string} [namespace] Namespace of the Relation Tuple
     * @param {string} [object] Object of the Relation Tuple
     * @param {string} [relation] Relation of the Relation Tuple
     * @param {string} [subjectId] SubjectID of the Relation Tuple
     * @param {string} [subjectSetNamespace] Namespace of the Subject Set
     * @param {string} [subjectSetObject] Object of the Subject Set
     * @param {string} [subjectSetRelation] Relation of the Subject Set
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ReadApiInterface
     */
    getRelationTuples(pageToken?: string, pageSize?: number, namespace?: string, object?: string, relation?: string, subjectId?: string, subjectSetNamespace?: string, subjectSetObject?: string, subjectSetRelation?: string, options?: AxiosRequestConfig): AxiosPromise<GetRelationTuplesResponse>;
    /**
     * To learn how relation tuples and the check works, head over to [the documentation](../concepts/relation-tuples.mdx).
     * @summary Check a relation tuple
     * @param {number} [maxDepth]
     * @param {RelationQuery} [relationQuery]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ReadApiInterface
     */
    postCheck(maxDepth?: number, relationQuery?: RelationQuery, options?: AxiosRequestConfig): AxiosPromise<GetCheckResponse>;
}
/**
 * ReadApi - object-oriented interface
 * @export
 * @class ReadApi
 * @extends {BaseAPI}
 */
export declare class ReadApi extends BaseAPI implements ReadApiInterface {
    /**
     * To learn how relation tuples and the check works, head over to [the documentation](../concepts/relation-tuples.mdx).
     * @summary Check a relation tuple
     * @param {string} [namespace] Namespace of the Relation Tuple
     * @param {string} [object] Object of the Relation Tuple
     * @param {string} [relation] Relation of the Relation Tuple
     * @param {string} [subjectId] SubjectID of the Relation Tuple
     * @param {string} [subjectSetNamespace] Namespace of the Subject Set
     * @param {string} [subjectSetObject] Object of the Subject Set
     * @param {string} [subjectSetRelation] Relation of the Subject Set
     * @param {number} [maxDepth]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ReadApi
     */
    getCheck(namespace?: string, object?: string, relation?: string, subjectId?: string, subjectSetNamespace?: string, subjectSetObject?: string, subjectSetRelation?: string, maxDepth?: number, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<GetCheckResponse>>;
    /**
     * Use this endpoint to expand a relation tuple.
     * @summary Expand a Relation Tuple
     * @param {string} namespace Namespace of the Subject Set
     * @param {string} object Object of the Subject Set
     * @param {string} relation Relation of the Subject Set
     * @param {number} [maxDepth]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ReadApi
     */
    getExpand(namespace: string, object: string, relation: string, maxDepth?: number, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<ExpandTree>>;
    /**
     * Get all relation tuples that match the query. Only the namespace field is required.
     * @summary Query relation tuples
     * @param {string} [pageToken]
     * @param {number} [pageSize]
     * @param {string} [namespace] Namespace of the Relation Tuple
     * @param {string} [object] Object of the Relation Tuple
     * @param {string} [relation] Relation of the Relation Tuple
     * @param {string} [subjectId] SubjectID of the Relation Tuple
     * @param {string} [subjectSetNamespace] Namespace of the Subject Set
     * @param {string} [subjectSetObject] Object of the Subject Set
     * @param {string} [subjectSetRelation] Relation of the Subject Set
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ReadApi
     */
    getRelationTuples(pageToken?: string, pageSize?: number, namespace?: string, object?: string, relation?: string, subjectId?: string, subjectSetNamespace?: string, subjectSetObject?: string, subjectSetRelation?: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<GetRelationTuplesResponse>>;
    /**
     * To learn how relation tuples and the check works, head over to [the documentation](../concepts/relation-tuples.mdx).
     * @summary Check a relation tuple
     * @param {number} [maxDepth]
     * @param {RelationQuery} [relationQuery]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ReadApi
     */
    postCheck(maxDepth?: number, relationQuery?: RelationQuery, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<GetCheckResponse>>;
}
/**
 * V0alpha2Api - axios parameter creator
 * @export
 */
export declare const V0alpha2ApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     * This endpoint creates an identity. Learn how identities work in [Ory Kratos\' User And Identity Model Documentation](https://www.ory.sh/docs/next/kratos/concepts/identity-user-model).
     * @summary Create an Identity
     * @param {AdminCreateIdentityBody} [adminCreateIdentityBody]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    adminCreateIdentity: (adminCreateIdentityBody?: AdminCreateIdentityBody, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoint creates a recovery link which should be given to the user in order for them to recover (or activate) their account.
     * @summary Create a Recovery Link
     * @param {AdminCreateSelfServiceRecoveryLinkBody} [adminCreateSelfServiceRecoveryLinkBody]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    adminCreateSelfServiceRecoveryLink: (adminCreateSelfServiceRecoveryLinkBody?: AdminCreateSelfServiceRecoveryLinkBody, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * Calling this endpoint irrecoverably and permanently deletes the identity given its ID. This action can not be undone. This endpoint returns 204 when the identity was deleted or when the identity was not found, in which case it is assumed that is has been deleted already.  Learn how identities work in [Ory Kratos\' User And Identity Model Documentation](https://www.ory.sh/docs/next/kratos/concepts/identity-user-model).
     * @summary Delete an Identity
     * @param {string} id ID is the identity\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    adminDeleteIdentity: (id: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoint is useful for:  To forcefully logout Identity from all devices and sessions
     * @summary Calling this endpoint irrecoverably and permanently deletes and invalidates all sessions that belong to the given Identity.
     * @param {string} id ID is the identity\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    adminDeleteIdentitySessions: (id: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * Retrieve the session ID from the `/sessions/whoami` endpoint / `toSession` SDK method.
     * @summary Calling this endpoint extends the given session ID. If `session.earliest_possible_extend` is set it will only extend the session after the specified time has passed.
     * @param {string} id ID is the session\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    adminExtendSession: (id: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * Learn how identities work in [Ory Kratos\' User And Identity Model Documentation](https://www.ory.sh/docs/next/kratos/concepts/identity-user-model).
     * @summary Get an Identity
     * @param {string} id ID must be set to the ID of identity you want to get
     * @param {Array<string>} [includeCredential] DeclassifyCredentials will declassify one or more identity\&#39;s credentials  Currently, only &#x60;oidc&#x60; is supported. This will return the initial OAuth 2.0 Access, Refresh and (optionally) OpenID Connect ID Token.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    adminGetIdentity: (id: string, includeCredential?: Array<string>, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * Lists all identities. Does not support search at the moment.  Learn how identities work in [Ory Kratos\' User And Identity Model Documentation](https://www.ory.sh/docs/next/kratos/concepts/identity-user-model).
     * @summary List Identities
     * @param {number} [perPage] Items per Page  This is the number of items per page.
     * @param {number} [page] Pagination Page
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    adminListIdentities: (perPage?: number, page?: number, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoint is useful for:  Listing all sessions that belong to an Identity in an administrative context.
     * @summary This endpoint returns all sessions that belong to the given Identity.
     * @param {string} id ID is the identity\&#39;s ID.
     * @param {number} [perPage] Items per Page  This is the number of items per page.
     * @param {number} [page] Pagination Page
     * @param {boolean} [active] Active is a boolean flag that filters out sessions based on the state. If no value is provided, all sessions are returned.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    adminListIdentitySessions: (id: string, perPage?: number, page?: number, active?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoint updates an identity. The full identity payload (except credentials) is expected. This endpoint does not support patching.  Learn how identities work in [Ory Kratos\' User And Identity Model Documentation](https://www.ory.sh/docs/next/kratos/concepts/identity-user-model).
     * @summary Update an Identity
     * @param {string} id ID must be set to the ID of identity you want to update
     * @param {AdminUpdateIdentityBody} [adminUpdateIdentityBody]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    adminUpdateIdentity: (id: string, adminUpdateIdentityBody?: AdminUpdateIdentityBody, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * Creates a new project.
     * @summary Create a Project
     * @param {CreateProjectBody} [createProjectBody]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    createProject: (createProjectBody?: CreateProjectBody, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoint initializes a browser-based user logout flow and a URL which can be used to log out the user.  This endpoint is NOT INTENDED for API clients and only works with browsers (Chrome, Firefox, ...). For API clients you can call the `/self-service/logout/api` URL directly with the Ory Session Token.  The URL is only valid for the currently signed in user. If no user is signed in, this endpoint returns a 401 error.  When calling this endpoint from a backend, please ensure to properly forward the HTTP cookies.
     * @summary Create a Logout URL for Browsers
     * @param {string} [cookie] HTTP Cookies  If you call this endpoint from a backend, please include the original Cookie header in the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    createSelfServiceLogoutFlowUrlForBrowsers: (cookie?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * Get a JSON Schema
     * @param {string} id ID must be set to the ID of schema you want to get
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getJsonSchema: (id: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * Get a projects you have access to by its ID.
     * @summary Get a Project
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getProject: (projectId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoint requires the user to be a member of the project with the role `OWNER` or `DEVELOPER`.
     * @summary Get all members associated with this project.
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getProjectMembers: (projectId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoint returns the error associated with a user-facing self service errors.  This endpoint supports stub values to help you implement the error UI:  `?id=stub:500` - returns a stub 500 (Internal Server Error) error.  More information can be found at [Ory Kratos User User Facing Error Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-facing-errors).
     * @summary Get Self-Service Errors
     * @param {string} id Error is the error\&#39;s ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getSelfServiceError: (id: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoint returns a login flow\'s context with, for example, error details and other information.  Browser flows expect the anti-CSRF cookie to be included in the request\'s HTTP Cookie Header. For AJAX requests you must ensure that cookies are included in the request or requests will fail.  If you use the browser-flow for server-side apps, the services need to run on a common top-level-domain and you need to forward the incoming HTTP Cookie header to this endpoint:  ```js pseudo-code example router.get(\'/login\', async function (req, res) { const flow = await client.getSelfServiceLoginFlow(req.header(\'cookie\'), req.query[\'flow\'])  res.render(\'login\', flow) }) ```  This request may fail due to several reasons. The `error.id` can be one of:  `session_already_available`: The user is already signed in. `self_service_flow_expired`: The flow is expired and you should request a new one.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Get Login Flow
     * @param {string} id The Login Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/login?flow&#x3D;abcde&#x60;).
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getSelfServiceLoginFlow: (id: string, cookie?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoint returns a recovery flow\'s context with, for example, error details and other information.  Browser flows expect the anti-CSRF cookie to be included in the request\'s HTTP Cookie Header. For AJAX requests you must ensure that cookies are included in the request or requests will fail.  If you use the browser-flow for server-side apps, the services need to run on a common top-level-domain and you need to forward the incoming HTTP Cookie header to this endpoint:  ```js pseudo-code example router.get(\'/recovery\', async function (req, res) { const flow = await client.getSelfServiceRecoveryFlow(req.header(\'Cookie\'), req.query[\'flow\'])  res.render(\'recovery\', flow) }) ```  More information can be found at [Ory Kratos Account Recovery Documentation](../self-service/flows/account-recovery).
     * @summary Get Recovery Flow
     * @param {string} id The Flow ID  The value for this parameter comes from &#x60;request&#x60; URL Query parameter sent to your application (e.g. &#x60;/recovery?flow&#x3D;abcde&#x60;).
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getSelfServiceRecoveryFlow: (id: string, cookie?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoint returns a registration flow\'s context with, for example, error details and other information.  Browser flows expect the anti-CSRF cookie to be included in the request\'s HTTP Cookie Header. For AJAX requests you must ensure that cookies are included in the request or requests will fail.  If you use the browser-flow for server-side apps, the services need to run on a common top-level-domain and you need to forward the incoming HTTP Cookie header to this endpoint:  ```js pseudo-code example router.get(\'/registration\', async function (req, res) { const flow = await client.getSelfServiceRegistrationFlow(req.header(\'cookie\'), req.query[\'flow\'])  res.render(\'registration\', flow) }) ```  This request may fail due to several reasons. The `error.id` can be one of:  `session_already_available`: The user is already signed in. `self_service_flow_expired`: The flow is expired and you should request a new one.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Get Registration Flow
     * @param {string} id The Registration Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/registration?flow&#x3D;abcde&#x60;).
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getSelfServiceRegistrationFlow: (id: string, cookie?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * When accessing this endpoint through Ory Kratos\' Public API you must ensure that either the Ory Kratos Session Cookie or the Ory Kratos Session Token are set.  Depending on your configuration this endpoint might return a 403 error if the session has a lower Authenticator Assurance Level (AAL) than is possible for the identity. This can happen if the identity has password + webauthn credentials (which would result in AAL2) but the session has only AAL1. If this error occurs, ask the user to sign in with the second factor or change the configuration.  You can access this endpoint without credentials when using Ory Kratos\' Admin API.  If this endpoint is called via an AJAX request, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `session_inactive`: No Ory Session was found - sign in a user first. `security_identity_mismatch`: The flow was interrupted with `session_refresh_required` but apparently some other identity logged in instead.  More information can be found at [Ory Kratos User Settings & Profile Management Documentation](../self-service/flows/user-settings).
     * @summary Get Settings Flow
     * @param {string} id ID is the Settings Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/settings?flow&#x3D;abcde&#x60;).
     * @param {string} [xSessionToken] The Session Token  When using the SDK in an app without a browser, please include the session token here.
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getSelfServiceSettingsFlow: (id: string, xSessionToken?: string, cookie?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoint returns a verification flow\'s context with, for example, error details and other information.  Browser flows expect the anti-CSRF cookie to be included in the request\'s HTTP Cookie Header. For AJAX requests you must ensure that cookies are included in the request or requests will fail.  If you use the browser-flow for server-side apps, the services need to run on a common top-level-domain and you need to forward the incoming HTTP Cookie header to this endpoint:  ```js pseudo-code example router.get(\'/recovery\', async function (req, res) { const flow = await client.getSelfServiceVerificationFlow(req.header(\'cookie\'), req.query[\'flow\'])  res.render(\'verification\', flow) })  More information can be found at [Ory Kratos Email and Phone Verification Documentation](https://www.ory.sh/docs/kratos/selfservice/flows/verify-email-account-activation).
     * @summary Get Verification Flow
     * @param {string} id The Flow ID  The value for this parameter comes from &#x60;request&#x60; URL Query parameter sent to your application (e.g. &#x60;/verification?flow&#x3D;abcde&#x60;).
     * @param {string} [cookie] HTTP Cookies  When using the SDK on the server side you must include the HTTP Cookie Header originally sent to your HTTP handler here.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getSelfServiceVerificationFlow: (id: string, cookie?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoint provides JavaScript which is needed in order to perform WebAuthn login and registration.  If you are building a JavaScript Browser App (e.g. in ReactJS or AngularJS) you will need to load this file:  ```html <script src=\"https://public-kratos.example.org/.well-known/ory/webauthn.js\" type=\"script\" async /> ```  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Get WebAuthn JavaScript
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getWebAuthnJavaScript: (options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoint initializes a browser-based user login flow. This endpoint will set the appropriate cookies and anti-CSRF measures required for browser-based flows.  If this endpoint is opened as a link in the browser, it will be redirected to `selfservice.flows.login.ui_url` with the flow ID set as the query parameter `?flow=`. If a valid user session exists already, the browser will be redirected to `urls.default_redirect_url` unless the query parameter `?refresh=true` was set.  If this endpoint is called via an AJAX request, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `session_aal1_required`: Multi-factor auth (e.g. 2fa) was requested but the user has no session yet. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration!  This endpoint is NOT INTENDED for clients that do not have a browser (Chrome, Firefox, ...) as cookies are needed.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Initialize Login Flow for Browsers
     * @param {boolean} [refresh] Refresh a login session  If set to true, this will refresh an existing login session by asking the user to sign in again. This will reset the authenticated_at time of the session.
     * @param {string} [aal] Request a Specific AuthenticationMethod Assurance Level  Use this parameter to upgrade an existing session\&#39;s authenticator assurance level (AAL). This allows you to ask for multi-factor authentication. When an identity sign in using e.g. username+password, the AAL is 1. If you wish to \&quot;upgrade\&quot; the session\&#39;s security by asking the user to perform TOTP / WebAuth/ ... you would set this to \&quot;aal2\&quot;.
     * @param {string} [returnTo] The URL to return the browser to after the flow was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceLoginFlowForBrowsers: (refresh?: boolean, aal?: string, returnTo?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoint initiates a login flow for API clients that do not use a browser, such as mobile devices, smart TVs, and so on.  If a valid provided session cookie or session token is provided, a 400 Bad Request error will be returned unless the URL query parameter `?refresh=true` is set.  To fetch an existing login flow call `/self-service/login/flows?flow=<flow_id>`.  You MUST NOT use this endpoint in client-side (Single Page Apps, ReactJS, AngularJS) nor server-side (Java Server Pages, NodeJS, PHP, Golang, ...) browser applications. Using this endpoint in these applications will make you vulnerable to a variety of CSRF attacks, including CSRF login attacks.  In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `session_aal1_required`: Multi-factor auth (e.g. 2fa) was requested but the user has no session yet. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred.  This endpoint MUST ONLY be used in scenarios such as native mobile apps (React Native, Objective C, Swift, Java, ...).  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Initialize Login Flow for APIs, Services, Apps, ...
     * @param {boolean} [refresh] Refresh a login session  If set to true, this will refresh an existing login session by asking the user to sign in again. This will reset the authenticated_at time of the session.
     * @param {string} [aal] Request a Specific AuthenticationMethod Assurance Level  Use this parameter to upgrade an existing session\&#39;s authenticator assurance level (AAL). This allows you to ask for multi-factor authentication. When an identity sign in using e.g. username+password, the AAL is 1. If you wish to \&quot;upgrade\&quot; the session\&#39;s security by asking the user to perform TOTP / WebAuth/ ... you would set this to \&quot;aal2\&quot;.
     * @param {string} [xSessionToken] The Session Token of the Identity performing the settings flow.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceLoginFlowWithoutBrowser: (refresh?: boolean, aal?: string, xSessionToken?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoint initializes a browser-based account recovery flow. Once initialized, the browser will be redirected to `selfservice.flows.recovery.ui_url` with the flow ID set as the query parameter `?flow=`. If a valid user session exists, the browser is returned to the configured return URL.  If this endpoint is called via an AJAX request, the response contains the recovery flow without any redirects or a 400 bad request error if the user is already authenticated.  This endpoint is NOT INTENDED for clients that do not have a browser (Chrome, Firefox, ...) as cookies are needed.  More information can be found at [Ory Kratos Account Recovery Documentation](../self-service/flows/account-recovery).
     * @summary Initialize Recovery Flow for Browsers
     * @param {string} [returnTo] The URL to return the browser to after the flow was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceRecoveryFlowForBrowsers: (returnTo?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoint initiates a recovery flow for API clients such as mobile devices, smart TVs, and so on.  If a valid provided session cookie or session token is provided, a 400 Bad Request error.  To fetch an existing recovery flow call `/self-service/recovery/flows?flow=<flow_id>`.  You MUST NOT use this endpoint in client-side (Single Page Apps, ReactJS, AngularJS) nor server-side (Java Server Pages, NodeJS, PHP, Golang, ...) browser applications. Using this endpoint in these applications will make you vulnerable to a variety of CSRF attacks.  This endpoint MUST ONLY be used in scenarios such as native mobile apps (React Native, Objective C, Swift, Java, ...).   More information can be found at [Ory Kratos Account Recovery Documentation](../self-service/flows/account-recovery).
     * @summary Initialize Recovery Flow for APIs, Services, Apps, ...
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceRecoveryFlowWithoutBrowser: (options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoint initializes a browser-based user registration flow. This endpoint will set the appropriate cookies and anti-CSRF measures required for browser-based flows.  :::info  This endpoint is EXPERIMENTAL and subject to potential breaking changes in the future.  :::  If this endpoint is opened as a link in the browser, it will be redirected to `selfservice.flows.registration.ui_url` with the flow ID set as the query parameter `?flow=`. If a valid user session exists already, the browser will be redirected to `urls.default_redirect_url`.  If this endpoint is called via an AJAX request, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration!  If this endpoint is called via an AJAX request, the response contains the registration flow without a redirect.  This endpoint is NOT INTENDED for clients that do not have a browser (Chrome, Firefox, ...) as cookies are needed.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Initialize Registration Flow for Browsers
     * @param {string} [returnTo] The URL to return the browser to after the flow was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceRegistrationFlowForBrowsers: (returnTo?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoint initiates a registration flow for API clients such as mobile devices, smart TVs, and so on.  If a valid provided session cookie or session token is provided, a 400 Bad Request error will be returned unless the URL query parameter `?refresh=true` is set.  To fetch an existing registration flow call `/self-service/registration/flows?flow=<flow_id>`.  You MUST NOT use this endpoint in client-side (Single Page Apps, ReactJS, AngularJS) nor server-side (Java Server Pages, NodeJS, PHP, Golang, ...) browser applications. Using this endpoint in these applications will make you vulnerable to a variety of CSRF attacks.  In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred.  This endpoint MUST ONLY be used in scenarios such as native mobile apps (React Native, Objective C, Swift, Java, ...).  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Initialize Registration Flow for APIs, Services, Apps, ...
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceRegistrationFlowWithoutBrowser: (options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoint initializes a browser-based user settings flow. Once initialized, the browser will be redirected to `selfservice.flows.settings.ui_url` with the flow ID set as the query parameter `?flow=`. If no valid Ory Kratos Session Cookie is included in the request, a login flow will be initialized.  If this endpoint is opened as a link in the browser, it will be redirected to `selfservice.flows.settings.ui_url` with the flow ID set as the query parameter `?flow=`. If no valid user session was set, the browser will be redirected to the login endpoint.  If this endpoint is called via an AJAX request, the response contains the settings flow without any redirects or a 401 forbidden error if no valid session was set.  Depending on your configuration this endpoint might return a 403 error if the session has a lower Authenticator Assurance Level (AAL) than is possible for the identity. This can happen if the identity has password + webauthn credentials (which would result in AAL2) but the session has only AAL1. If this error occurs, ask the user to sign in with the second factor (happens automatically for server-side browser flows) or change the configuration.  If this endpoint is called via an AJAX request, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `session_inactive`: No Ory Session was found - sign in a user first. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration!  This endpoint is NOT INTENDED for clients that do not have a browser (Chrome, Firefox, ...) as cookies are needed.  More information can be found at [Ory Kratos User Settings & Profile Management Documentation](../self-service/flows/user-settings).
     * @summary Initialize Settings Flow for Browsers
     * @param {string} [returnTo] The URL to return the browser to after the flow was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceSettingsFlowForBrowsers: (returnTo?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoint initiates a settings flow for API clients such as mobile devices, smart TVs, and so on. You must provide a valid Ory Kratos Session Token for this endpoint to respond with HTTP 200 OK.  To fetch an existing settings flow call `/self-service/settings/flows?flow=<flow_id>`.  You MUST NOT use this endpoint in client-side (Single Page Apps, ReactJS, AngularJS) nor server-side (Java Server Pages, NodeJS, PHP, Golang, ...) browser applications. Using this endpoint in these applications will make you vulnerable to a variety of CSRF attacks.  Depending on your configuration this endpoint might return a 403 error if the session has a lower Authenticator Assurance Level (AAL) than is possible for the identity. This can happen if the identity has password + webauthn credentials (which would result in AAL2) but the session has only AAL1. If this error occurs, ask the user to sign in with the second factor or change the configuration.  In the case of an error, the `error.id` of the JSON response body can be one of:  `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `session_inactive`: No Ory Session was found - sign in a user first.  This endpoint MUST ONLY be used in scenarios such as native mobile apps (React Native, Objective C, Swift, Java, ...).  More information can be found at [Ory Kratos User Settings & Profile Management Documentation](../self-service/flows/user-settings).
     * @summary Initialize Settings Flow for APIs, Services, Apps, ...
     * @param {string} [xSessionToken] The Session Token of the Identity performing the settings flow.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceSettingsFlowWithoutBrowser: (xSessionToken?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoint initializes a browser-based account verification flow. Once initialized, the browser will be redirected to `selfservice.flows.verification.ui_url` with the flow ID set as the query parameter `?flow=`.  If this endpoint is called via an AJAX request, the response contains the recovery flow without any redirects.  This endpoint is NOT INTENDED for API clients and only works with browsers (Chrome, Firefox, ...).  More information can be found at [Ory Kratos Email and Phone Verification Documentation](https://www.ory.sh/docs/kratos/selfservice/flows/verify-email-account-activation).
     * @summary Initialize Verification Flow for Browser Clients
     * @param {string} [returnTo] The URL to return the browser to after the flow was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceVerificationFlowForBrowsers: (returnTo?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoint initiates a verification flow for API clients such as mobile devices, smart TVs, and so on.  To fetch an existing verification flow call `/self-service/verification/flows?flow=<flow_id>`.  You MUST NOT use this endpoint in client-side (Single Page Apps, ReactJS, AngularJS) nor server-side (Java Server Pages, NodeJS, PHP, Golang, ...) browser applications. Using this endpoint in these applications will make you vulnerable to a variety of CSRF attacks.  This endpoint MUST ONLY be used in scenarios such as native mobile apps (React Native, Objective C, Swift, Java, ...).  More information can be found at [Ory Kratos Email and Phone Verification Documentation](https://www.ory.sh/docs/kratos/selfservice/flows/verify-email-account-activation).
     * @summary Initialize Verification Flow for APIs, Services, Apps, ...
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceVerificationFlowWithoutBrowser: (options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * Get all Identity Schemas
     * @param {number} [perPage] Items per Page  This is the number of items per page.
     * @param {number} [page] Pagination Page
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    listIdentitySchemas: (perPage?: number, page?: number, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * Lists all projects you have access to.
     * @summary List All Projects
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    listProjects: (options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoint is useful for:  Displaying all other sessions that belong to the logged-in user
     * @summary This endpoints returns all other active sessions that belong to the logged-in user. The current session can be retrieved by calling the `/sessions/whoami` endpoint.
     * @param {string} [xSessionToken] Set the Session Token when calling from non-browser clients. A session token has a format of &#x60;MP2YWEMeM8MxjkGKpH4dqOQ4Q4DlSPaj&#x60;.
     * @param {string} [cookie] Set the Cookie Header. This is especially useful when calling this endpoint from a server-side application. In that scenario you must include the HTTP Cookie Header which originally was included in the request to your server. An example of a session in the HTTP Cookie Header is: &#x60;ory_kratos_session&#x3D;a19iOVAbdzdgl70Rq1QZmrKmcjDtdsviCTZx7m9a9yHIUS8Wa9T7hvqyGTsLHi6Qifn2WUfpAKx9DWp0SJGleIn9vh2YF4A16id93kXFTgIgmwIOvbVAScyrx7yVl6bPZnCx27ec4WQDtaTewC1CpgudeDV2jQQnSaCP6ny3xa8qLH-QUgYqdQuoA_LF1phxgRCUfIrCLQOkolX5nv3ze_f&#x3D;&#x3D;&#x60;.  It is ok if more than one cookie are included here as all other cookies will be ignored.
     * @param {number} [perPage] Items per Page  This is the number of items per page.
     * @param {number} [page] Pagination Page
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    listSessions: (xSessionToken?: string, cookie?: string, perPage?: number, page?: number, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoints allows you to patch individual Ory Cloud Project configuration keys for Ory\'s services (identity, permission, ...). The configuration format is fully compatible with the open source projects for the respective services (e.g. Ory Kratos for Identity, Ory Keto for Permissions).  This endpoint expects the `version` key to be set in the payload. If it is unset, it will try to import the config as if it is from the most recent version.  If you have an older version of a configuration, you should set the version key in the payload!  While this endpoint is able to process all configuration items related to features (e.g. password reset), it does not support operational configuration items (e.g. port, tracing, logging) otherwise available in the open source.  For configuration items that can not be translated to Ory Cloud, this endpoint will return a list of warnings to help you understand which parts of your config could not be processed.
     * @summary Patch an Ory Cloud Project Configuration
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {Array<JsonPatch>} [jsonPatch]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    patchProject: (projectId: string, jsonPatch?: Array<JsonPatch>, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * !! Use with extreme caution !!  Using this API endpoint you can purge (completely delete) a project and its data. This action can not be undone and will delete ALL your data.  !! Use with extreme caution !!
     * @summary Irrecoverably Purge a Project
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    purgeProject: (projectId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoint requires the user to be a member of the project with the role `OWNER`.
     * @summary Remove a member associated with this project. This also sets their invite status to `REMOVED`.
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {string} memberId Member ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    removeProjectMember: (projectId: string, memberId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoint is useful for:  To forcefully logout the current user from another device or session
     * @summary Calling this endpoint invalidates the specified session. The current session cannot be revoked. Session data are not deleted.
     * @param {string} id ID is the session\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    revokeSession: (id: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoint is useful for:  To forcefully logout the current user from all other devices and sessions
     * @summary Calling this endpoint invalidates all except the current session that belong to the logged-in user. Session data are not deleted.
     * @param {string} [xSessionToken] Set the Session Token when calling from non-browser clients. A session token has a format of &#x60;MP2YWEMeM8MxjkGKpH4dqOQ4Q4DlSPaj&#x60;.
     * @param {string} [cookie] Set the Cookie Header. This is especially useful when calling this endpoint from a server-side application. In that scenario you must include the HTTP Cookie Header which originally was included in the request to your server. An example of a session in the HTTP Cookie Header is: &#x60;ory_kratos_session&#x3D;a19iOVAbdzdgl70Rq1QZmrKmcjDtdsviCTZx7m9a9yHIUS8Wa9T7hvqyGTsLHi6Qifn2WUfpAKx9DWp0SJGleIn9vh2YF4A16id93kXFTgIgmwIOvbVAScyrx7yVl6bPZnCx27ec4WQDtaTewC1CpgudeDV2jQQnSaCP6ny3xa8qLH-QUgYqdQuoA_LF1phxgRCUfIrCLQOkolX5nv3ze_f&#x3D;&#x3D;&#x60;.  It is ok if more than one cookie are included here as all other cookies will be ignored.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    revokeSessions: (xSessionToken?: string, cookie?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * :::info  This endpoint is EXPERIMENTAL and subject to potential breaking changes in the future.  :::  Use this endpoint to complete a login flow. This endpoint behaves differently for API and browser flows.  API flows expect `application/json` to be sent in the body and responds with HTTP 200 and a application/json body with the session token on success; HTTP 410 if the original flow expired with the appropriate error messages set and optionally a `use_flow_id` parameter in the body; HTTP 400 on form validation errors.  Browser flows expect a Content-Type of `application/x-www-form-urlencoded` or `application/json` to be sent in the body and respond with a HTTP 303 redirect to the post/after login URL or the `return_to` value if it was set and if the login succeeded; a HTTP 303 redirect to the login UI URL with the flow ID containing the validation errors otherwise.  Browser flows with an accept header of `application/json` will not redirect but instead respond with HTTP 200 and a application/json body with the signed in identity and a `Set-Cookie` header on success; HTTP 303 redirect to a fresh login flow if the original flow expired with the appropriate error messages set; HTTP 400 on form validation errors.  If this endpoint is called with `Accept: application/json` in the header, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration! `browser_location_change_required`: Usually sent when an AJAX request indicates that the browser needs to open a specific URL. Most likely used in Social Sign In flows.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Submit a Login Flow
     * @param {string} flow The Login Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/login?flow&#x3D;abcde&#x60;).
     * @param {SubmitSelfServiceLoginFlowBody} submitSelfServiceLoginFlowBody
     * @param {string} [xSessionToken] The Session Token of the Identity performing the settings flow.
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    submitSelfServiceLoginFlow: (flow: string, submitSelfServiceLoginFlowBody: SubmitSelfServiceLoginFlowBody, xSessionToken?: string, cookie?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoint logs out an identity in a self-service manner.  If the `Accept` HTTP header is not set to `application/json`, the browser will be redirected (HTTP 303 See Other) to the `return_to` parameter of the initial request or fall back to `urls.default_return_to`.  If the `Accept` HTTP header is set to `application/json`, a 204 No Content response will be sent on successful logout instead.  This endpoint is NOT INTENDED for API clients and only works with browsers (Chrome, Firefox, ...). For API clients you can call the `/self-service/logout/api` URL directly with the Ory Session Token.  More information can be found at [Ory Kratos User Logout Documentation](https://www.ory.sh/docs/next/kratos/self-service/flows/user-logout).
     * @summary Complete Self-Service Logout
     * @param {string} [token] A Valid Logout Token  If you do not have a logout token because you only have a session cookie, call &#x60;/self-service/logout/urls&#x60; to generate a URL for this endpoint.
     * @param {string} [returnTo] The URL to return to after the logout was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    submitSelfServiceLogoutFlow: (token?: string, returnTo?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * Use this endpoint to log out an identity using an Ory Session Token. If the Ory Session Token was successfully revoked, the server returns a 204 No Content response. A 204 No Content response is also sent when the Ory Session Token has been revoked already before.  If the Ory Session Token is malformed or does not exist a 403 Forbidden response will be returned.  This endpoint does not remove any HTTP Cookies - use the Browser-Based Self-Service Logout Flow instead.
     * @summary Perform Logout for APIs, Services, Apps, ...
     * @param {SubmitSelfServiceLogoutFlowWithoutBrowserBody} submitSelfServiceLogoutFlowWithoutBrowserBody
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    submitSelfServiceLogoutFlowWithoutBrowser: (submitSelfServiceLogoutFlowWithoutBrowserBody: SubmitSelfServiceLogoutFlowWithoutBrowserBody, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * Use this endpoint to complete a recovery flow. This endpoint behaves differently for API and browser flows and has several states:  `choose_method` expects `flow` (in the URL query) and `email` (in the body) to be sent and works with API- and Browser-initiated flows. For API clients and Browser clients with HTTP Header `Accept: application/json` it either returns a HTTP 200 OK when the form is valid and HTTP 400 OK when the form is invalid. and a HTTP 303 See Other redirect with a fresh recovery flow if the flow was otherwise invalid (e.g. expired). For Browser clients without HTTP Header `Accept` or with `Accept: text/_*` it returns a HTTP 303 See Other redirect to the Recovery UI URL with the Recovery Flow ID appended. `sent_email` is the success state after `choose_method` for the `link` method and allows the user to request another recovery email. It works for both API and Browser-initiated flows and returns the same responses as the flow in `choose_method` state. `passed_challenge` expects a `token` to be sent in the URL query and given the nature of the flow (\"sending a recovery link\") does not have any API capabilities. The server responds with a HTTP 303 See Other redirect either to the Settings UI URL (if the link was valid) and instructs the user to update their password, or a redirect to the Recover UI URL with a new Recovery Flow ID which contains an error message that the recovery link was invalid.  More information can be found at [Ory Kratos Account Recovery Documentation](../self-service/flows/account-recovery).
     * @summary Complete Recovery Flow
     * @param {string} flow The Recovery Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/recovery?flow&#x3D;abcde&#x60;).
     * @param {SubmitSelfServiceRecoveryFlowBody} submitSelfServiceRecoveryFlowBody
     * @param {string} [token] Recovery Token  The recovery token which completes the recovery request. If the token is invalid (e.g. expired) an error will be shown to the end-user.  This parameter is usually set in a link and not used by any direct API call.
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    submitSelfServiceRecoveryFlow: (flow: string, submitSelfServiceRecoveryFlowBody: SubmitSelfServiceRecoveryFlowBody, token?: string, cookie?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * Use this endpoint to complete a registration flow by sending an identity\'s traits and password. This endpoint behaves differently for API and browser flows.  API flows expect `application/json` to be sent in the body and respond with HTTP 200 and a application/json body with the created identity success - if the session hook is configured the `session` and `session_token` will also be included; HTTP 410 if the original flow expired with the appropriate error messages set and optionally a `use_flow_id` parameter in the body; HTTP 400 on form validation errors.  Browser flows expect a Content-Type of `application/x-www-form-urlencoded` or `application/json` to be sent in the body and respond with a HTTP 303 redirect to the post/after registration URL or the `return_to` value if it was set and if the registration succeeded; a HTTP 303 redirect to the registration UI URL with the flow ID containing the validation errors otherwise.  Browser flows with an accept header of `application/json` will not redirect but instead respond with HTTP 200 and a application/json body with the signed in identity and a `Set-Cookie` header on success; HTTP 303 redirect to a fresh login flow if the original flow expired with the appropriate error messages set; HTTP 400 on form validation errors.  If this endpoint is called with `Accept: application/json` in the header, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration! `browser_location_change_required`: Usually sent when an AJAX request indicates that the browser needs to open a specific URL. Most likely used in Social Sign In flows.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Submit a Registration Flow
     * @param {string} flow The Registration Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/registration?flow&#x3D;abcde&#x60;).
     * @param {SubmitSelfServiceRegistrationFlowBody} submitSelfServiceRegistrationFlowBody
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    submitSelfServiceRegistrationFlow: (flow: string, submitSelfServiceRegistrationFlowBody: SubmitSelfServiceRegistrationFlowBody, cookie?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * Use this endpoint to complete a settings flow by sending an identity\'s updated password. This endpoint behaves differently for API and browser flows.  API-initiated flows expect `application/json` to be sent in the body and respond with HTTP 200 and an application/json body with the session token on success; HTTP 303 redirect to a fresh settings flow if the original flow expired with the appropriate error messages set; HTTP 400 on form validation errors. HTTP 401 when the endpoint is called without a valid session token. HTTP 403 when `selfservice.flows.settings.privileged_session_max_age` was reached or the session\'s AAL is too low. Implies that the user needs to re-authenticate.  Browser flows without HTTP Header `Accept` or with `Accept: text/_*` respond with a HTTP 303 redirect to the post/after settings URL or the `return_to` value if it was set and if the flow succeeded; a HTTP 303 redirect to the Settings UI URL with the flow ID containing the validation errors otherwise. a HTTP 303 redirect to the login endpoint when `selfservice.flows.settings.privileged_session_max_age` was reached or the session\'s AAL is too low.  Browser flows with HTTP Header `Accept: application/json` respond with HTTP 200 and a application/json body with the signed in identity and a `Set-Cookie` header on success; HTTP 303 redirect to a fresh login flow if the original flow expired with the appropriate error messages set; HTTP 401 when the endpoint is called without a valid session cookie. HTTP 403 when the page is accessed without a session cookie or the session\'s AAL is too low. HTTP 400 on form validation errors.  Depending on your configuration this endpoint might return a 403 error if the session has a lower Authenticator Assurance Level (AAL) than is possible for the identity. This can happen if the identity has password + webauthn credentials (which would result in AAL2) but the session has only AAL1. If this error occurs, ask the user to sign in with the second factor (happens automatically for server-side browser flows) or change the configuration.  If this endpoint is called with a `Accept: application/json` HTTP header, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `session_refresh_required`: The identity requested to change something that needs a privileged session. Redirect the identity to the login init endpoint with query parameters `?refresh=true&return_to=<the-current-browser-url>`, or initiate a refresh login flow otherwise. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `session_inactive`: No Ory Session was found - sign in a user first. `security_identity_mismatch`: The flow was interrupted with `session_refresh_required` but apparently some other identity logged in instead. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration! `browser_location_change_required`: Usually sent when an AJAX request indicates that the browser needs to open a specific URL. Most likely used in Social Sign In flows.  More information can be found at [Ory Kratos User Settings & Profile Management Documentation](../self-service/flows/user-settings).
     * @summary Complete Settings Flow
     * @param {string} flow The Settings Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/settings?flow&#x3D;abcde&#x60;).
     * @param {SubmitSelfServiceSettingsFlowBody} submitSelfServiceSettingsFlowBody
     * @param {string} [xSessionToken] The Session Token of the Identity performing the settings flow.
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    submitSelfServiceSettingsFlow: (flow: string, submitSelfServiceSettingsFlowBody: SubmitSelfServiceSettingsFlowBody, xSessionToken?: string, cookie?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * Use this endpoint to complete a verification flow. This endpoint behaves differently for API and browser flows and has several states:  `choose_method` expects `flow` (in the URL query) and `email` (in the body) to be sent and works with API- and Browser-initiated flows. For API clients and Browser clients with HTTP Header `Accept: application/json` it either returns a HTTP 200 OK when the form is valid and HTTP 400 OK when the form is invalid and a HTTP 303 See Other redirect with a fresh verification flow if the flow was otherwise invalid (e.g. expired). For Browser clients without HTTP Header `Accept` or with `Accept: text/_*` it returns a HTTP 303 See Other redirect to the Verification UI URL with the Verification Flow ID appended. `sent_email` is the success state after `choose_method` when using the `link` method and allows the user to request another verification email. It works for both API and Browser-initiated flows and returns the same responses as the flow in `choose_method` state. `passed_challenge` expects a `token` to be sent in the URL query and given the nature of the flow (\"sending a verification link\") does not have any API capabilities. The server responds with a HTTP 303 See Other redirect either to the Settings UI URL (if the link was valid) and instructs the user to update their password, or a redirect to the Verification UI URL with a new Verification Flow ID which contains an error message that the verification link was invalid.  More information can be found at [Ory Kratos Email and Phone Verification Documentation](https://www.ory.sh/docs/kratos/selfservice/flows/verify-email-account-activation).
     * @summary Complete Verification Flow
     * @param {string} flow The Verification Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/verification?flow&#x3D;abcde&#x60;).
     * @param {SubmitSelfServiceVerificationFlowBody} submitSelfServiceVerificationFlowBody
     * @param {string} [token] Verification Token  The verification token which completes the verification request. If the token is invalid (e.g. expired) an error will be shown to the end-user.  This parameter is usually set in a link and not used by any direct API call.
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    submitSelfServiceVerificationFlow: (flow: string, submitSelfServiceVerificationFlowBody: SubmitSelfServiceVerificationFlowBody, token?: string, cookie?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * Uses the HTTP Headers in the GET request to determine (e.g. by using checking the cookies) who is authenticated. Returns a session object in the body or 401 if the credentials are invalid or no credentials were sent. Additionally when the request it successful it adds the user ID to the \'X-Kratos-Authenticated-Identity-Id\' header in the response.  If you call this endpoint from a server-side application, you must forward the HTTP Cookie Header to this endpoint:  ```js pseudo-code example router.get(\'/protected-endpoint\', async function (req, res) { const session = await client.toSession(undefined, req.header(\'cookie\'))  console.log(session) }) ```  When calling this endpoint from a non-browser application (e.g. mobile app) you must include the session token:  ```js pseudo-code example ... const session = await client.toSession(\"the-session-token\")  console.log(session) ```  Depending on your configuration this endpoint might return a 403 status code if the session has a lower Authenticator Assurance Level (AAL) than is possible for the identity. This can happen if the identity has password + webauthn credentials (which would result in AAL2) but the session has only AAL1. If this error occurs, ask the user to sign in with the second factor or change the configuration.  This endpoint is useful for:  AJAX calls. Remember to send credentials and set up CORS correctly! Reverse proxies and API Gateways Server-side calls - use the `X-Session-Token` header!  This endpoint authenticates users by checking  if the `Cookie` HTTP header was set containing an Ory Kratos Session Cookie; if the `Authorization: bearer <ory-session-token>` HTTP header was set with a valid Ory Kratos Session Token; if the `X-Session-Token` HTTP header was set with a valid Ory Kratos Session Token.  If none of these headers are set or the cooke or token are invalid, the endpoint returns a HTTP 401 status code.  As explained above, this request may fail due to several reasons. The `error.id` can be one of:  `session_inactive`: No active session was found in the request (e.g. no Ory Session Cookie / Ory Session Token). `session_aal2_required`: An active session was found but it does not fulfil the Authenticator Assurance Level, implying that the session must (e.g.) authenticate the second factor.
     * @summary Check Who the Current HTTP Session Belongs To
     * @param {string} [xSessionToken] Set the Session Token when calling from non-browser clients. A session token has a format of &#x60;MP2YWEMeM8MxjkGKpH4dqOQ4Q4DlSPaj&#x60;.
     * @param {string} [cookie] Set the Cookie Header. This is especially useful when calling this endpoint from a server-side application. In that scenario you must include the HTTP Cookie Header which originally was included in the request to your server. An example of a session in the HTTP Cookie Header is: &#x60;ory_kratos_session&#x3D;a19iOVAbdzdgl70Rq1QZmrKmcjDtdsviCTZx7m9a9yHIUS8Wa9T7hvqyGTsLHi6Qifn2WUfpAKx9DWp0SJGleIn9vh2YF4A16id93kXFTgIgmwIOvbVAScyrx7yVl6bPZnCx27ec4WQDtaTewC1CpgudeDV2jQQnSaCP6ny3xa8qLH-QUgYqdQuoA_LF1phxgRCUfIrCLQOkolX5nv3ze_f&#x3D;&#x3D;&#x60;.  It is ok if more than one cookie are included here as all other cookies will be ignored.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    toSession: (xSessionToken?: string, cookie?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * This endpoints allows you to update the Ory Cloud Project configuration for individual services (identity, permission, ...). The configuration is fully compatible with the open source projects for the respective services (e.g. Ory Kratos for Identity, Ory Keto for Permissions).  This endpoint expects the `version` key to be set in the payload. If it is unset, it will try to import the config as if it is from the most recent version.  If you have an older version of a configuration, you should set the version key in the payload!  While this endpoint is able to process all configuration items related to features (e.g. password reset), it does not support operational configuration items (e.g. port, tracing, logging) otherwise available in the open source.  For configuration items that can not be translated to Ory Cloud, this endpoint will return a list of warnings to help you understand which parts of your config could not be processed.  Be aware that updating any service\'s configuration will completely override your current configuration for that service!
     * @summary Update an Ory Cloud Project Configuration
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {UpdateProject} [updateProject]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    updateProject: (projectId: string, updateProject?: UpdateProject, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * V0alpha2Api - functional programming interface
 * @export
 */
export declare const V0alpha2ApiFp: (configuration?: Configuration) => {
    /**
     * This endpoint creates an identity. Learn how identities work in [Ory Kratos\' User And Identity Model Documentation](https://www.ory.sh/docs/next/kratos/concepts/identity-user-model).
     * @summary Create an Identity
     * @param {AdminCreateIdentityBody} [adminCreateIdentityBody]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    adminCreateIdentity(adminCreateIdentityBody?: AdminCreateIdentityBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Identity>>;
    /**
     * This endpoint creates a recovery link which should be given to the user in order for them to recover (or activate) their account.
     * @summary Create a Recovery Link
     * @param {AdminCreateSelfServiceRecoveryLinkBody} [adminCreateSelfServiceRecoveryLinkBody]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    adminCreateSelfServiceRecoveryLink(adminCreateSelfServiceRecoveryLinkBody?: AdminCreateSelfServiceRecoveryLinkBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SelfServiceRecoveryLink>>;
    /**
     * Calling this endpoint irrecoverably and permanently deletes the identity given its ID. This action can not be undone. This endpoint returns 204 when the identity was deleted or when the identity was not found, in which case it is assumed that is has been deleted already.  Learn how identities work in [Ory Kratos\' User And Identity Model Documentation](https://www.ory.sh/docs/next/kratos/concepts/identity-user-model).
     * @summary Delete an Identity
     * @param {string} id ID is the identity\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    adminDeleteIdentity(id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>>;
    /**
     * This endpoint is useful for:  To forcefully logout Identity from all devices and sessions
     * @summary Calling this endpoint irrecoverably and permanently deletes and invalidates all sessions that belong to the given Identity.
     * @param {string} id ID is the identity\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    adminDeleteIdentitySessions(id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>>;
    /**
     * Retrieve the session ID from the `/sessions/whoami` endpoint / `toSession` SDK method.
     * @summary Calling this endpoint extends the given session ID. If `session.earliest_possible_extend` is set it will only extend the session after the specified time has passed.
     * @param {string} id ID is the session\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    adminExtendSession(id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Session>>;
    /**
     * Learn how identities work in [Ory Kratos\' User And Identity Model Documentation](https://www.ory.sh/docs/next/kratos/concepts/identity-user-model).
     * @summary Get an Identity
     * @param {string} id ID must be set to the ID of identity you want to get
     * @param {Array<string>} [includeCredential] DeclassifyCredentials will declassify one or more identity\&#39;s credentials  Currently, only &#x60;oidc&#x60; is supported. This will return the initial OAuth 2.0 Access, Refresh and (optionally) OpenID Connect ID Token.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    adminGetIdentity(id: string, includeCredential?: Array<string>, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Identity>>;
    /**
     * Lists all identities. Does not support search at the moment.  Learn how identities work in [Ory Kratos\' User And Identity Model Documentation](https://www.ory.sh/docs/next/kratos/concepts/identity-user-model).
     * @summary List Identities
     * @param {number} [perPage] Items per Page  This is the number of items per page.
     * @param {number} [page] Pagination Page
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    adminListIdentities(perPage?: number, page?: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<Identity>>>;
    /**
     * This endpoint is useful for:  Listing all sessions that belong to an Identity in an administrative context.
     * @summary This endpoint returns all sessions that belong to the given Identity.
     * @param {string} id ID is the identity\&#39;s ID.
     * @param {number} [perPage] Items per Page  This is the number of items per page.
     * @param {number} [page] Pagination Page
     * @param {boolean} [active] Active is a boolean flag that filters out sessions based on the state. If no value is provided, all sessions are returned.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    adminListIdentitySessions(id: string, perPage?: number, page?: number, active?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<Session>>>;
    /**
     * This endpoint updates an identity. The full identity payload (except credentials) is expected. This endpoint does not support patching.  Learn how identities work in [Ory Kratos\' User And Identity Model Documentation](https://www.ory.sh/docs/next/kratos/concepts/identity-user-model).
     * @summary Update an Identity
     * @param {string} id ID must be set to the ID of identity you want to update
     * @param {AdminUpdateIdentityBody} [adminUpdateIdentityBody]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    adminUpdateIdentity(id: string, adminUpdateIdentityBody?: AdminUpdateIdentityBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Identity>>;
    /**
     * Creates a new project.
     * @summary Create a Project
     * @param {CreateProjectBody} [createProjectBody]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    createProject(createProjectBody?: CreateProjectBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Project>>;
    /**
     * This endpoint initializes a browser-based user logout flow and a URL which can be used to log out the user.  This endpoint is NOT INTENDED for API clients and only works with browsers (Chrome, Firefox, ...). For API clients you can call the `/self-service/logout/api` URL directly with the Ory Session Token.  The URL is only valid for the currently signed in user. If no user is signed in, this endpoint returns a 401 error.  When calling this endpoint from a backend, please ensure to properly forward the HTTP cookies.
     * @summary Create a Logout URL for Browsers
     * @param {string} [cookie] HTTP Cookies  If you call this endpoint from a backend, please include the original Cookie header in the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    createSelfServiceLogoutFlowUrlForBrowsers(cookie?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SelfServiceLogoutUrl>>;
    /**
     * Get a JSON Schema
     * @param {string} id ID must be set to the ID of schema you want to get
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getJsonSchema(id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<object>>;
    /**
     * Get a projects you have access to by its ID.
     * @summary Get a Project
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getProject(projectId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Project>>;
    /**
     * This endpoint requires the user to be a member of the project with the role `OWNER` or `DEVELOPER`.
     * @summary Get all members associated with this project.
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getProjectMembers(projectId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<CloudAccount>>>;
    /**
     * This endpoint returns the error associated with a user-facing self service errors.  This endpoint supports stub values to help you implement the error UI:  `?id=stub:500` - returns a stub 500 (Internal Server Error) error.  More information can be found at [Ory Kratos User User Facing Error Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-facing-errors).
     * @summary Get Self-Service Errors
     * @param {string} id Error is the error\&#39;s ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getSelfServiceError(id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SelfServiceError>>;
    /**
     * This endpoint returns a login flow\'s context with, for example, error details and other information.  Browser flows expect the anti-CSRF cookie to be included in the request\'s HTTP Cookie Header. For AJAX requests you must ensure that cookies are included in the request or requests will fail.  If you use the browser-flow for server-side apps, the services need to run on a common top-level-domain and you need to forward the incoming HTTP Cookie header to this endpoint:  ```js pseudo-code example router.get(\'/login\', async function (req, res) { const flow = await client.getSelfServiceLoginFlow(req.header(\'cookie\'), req.query[\'flow\'])  res.render(\'login\', flow) }) ```  This request may fail due to several reasons. The `error.id` can be one of:  `session_already_available`: The user is already signed in. `self_service_flow_expired`: The flow is expired and you should request a new one.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Get Login Flow
     * @param {string} id The Login Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/login?flow&#x3D;abcde&#x60;).
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getSelfServiceLoginFlow(id: string, cookie?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SelfServiceLoginFlow>>;
    /**
     * This endpoint returns a recovery flow\'s context with, for example, error details and other information.  Browser flows expect the anti-CSRF cookie to be included in the request\'s HTTP Cookie Header. For AJAX requests you must ensure that cookies are included in the request or requests will fail.  If you use the browser-flow for server-side apps, the services need to run on a common top-level-domain and you need to forward the incoming HTTP Cookie header to this endpoint:  ```js pseudo-code example router.get(\'/recovery\', async function (req, res) { const flow = await client.getSelfServiceRecoveryFlow(req.header(\'Cookie\'), req.query[\'flow\'])  res.render(\'recovery\', flow) }) ```  More information can be found at [Ory Kratos Account Recovery Documentation](../self-service/flows/account-recovery).
     * @summary Get Recovery Flow
     * @param {string} id The Flow ID  The value for this parameter comes from &#x60;request&#x60; URL Query parameter sent to your application (e.g. &#x60;/recovery?flow&#x3D;abcde&#x60;).
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getSelfServiceRecoveryFlow(id: string, cookie?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SelfServiceRecoveryFlow>>;
    /**
     * This endpoint returns a registration flow\'s context with, for example, error details and other information.  Browser flows expect the anti-CSRF cookie to be included in the request\'s HTTP Cookie Header. For AJAX requests you must ensure that cookies are included in the request or requests will fail.  If you use the browser-flow for server-side apps, the services need to run on a common top-level-domain and you need to forward the incoming HTTP Cookie header to this endpoint:  ```js pseudo-code example router.get(\'/registration\', async function (req, res) { const flow = await client.getSelfServiceRegistrationFlow(req.header(\'cookie\'), req.query[\'flow\'])  res.render(\'registration\', flow) }) ```  This request may fail due to several reasons. The `error.id` can be one of:  `session_already_available`: The user is already signed in. `self_service_flow_expired`: The flow is expired and you should request a new one.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Get Registration Flow
     * @param {string} id The Registration Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/registration?flow&#x3D;abcde&#x60;).
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getSelfServiceRegistrationFlow(id: string, cookie?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SelfServiceRegistrationFlow>>;
    /**
     * When accessing this endpoint through Ory Kratos\' Public API you must ensure that either the Ory Kratos Session Cookie or the Ory Kratos Session Token are set.  Depending on your configuration this endpoint might return a 403 error if the session has a lower Authenticator Assurance Level (AAL) than is possible for the identity. This can happen if the identity has password + webauthn credentials (which would result in AAL2) but the session has only AAL1. If this error occurs, ask the user to sign in with the second factor or change the configuration.  You can access this endpoint without credentials when using Ory Kratos\' Admin API.  If this endpoint is called via an AJAX request, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `session_inactive`: No Ory Session was found - sign in a user first. `security_identity_mismatch`: The flow was interrupted with `session_refresh_required` but apparently some other identity logged in instead.  More information can be found at [Ory Kratos User Settings & Profile Management Documentation](../self-service/flows/user-settings).
     * @summary Get Settings Flow
     * @param {string} id ID is the Settings Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/settings?flow&#x3D;abcde&#x60;).
     * @param {string} [xSessionToken] The Session Token  When using the SDK in an app without a browser, please include the session token here.
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getSelfServiceSettingsFlow(id: string, xSessionToken?: string, cookie?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SelfServiceSettingsFlow>>;
    /**
     * This endpoint returns a verification flow\'s context with, for example, error details and other information.  Browser flows expect the anti-CSRF cookie to be included in the request\'s HTTP Cookie Header. For AJAX requests you must ensure that cookies are included in the request or requests will fail.  If you use the browser-flow for server-side apps, the services need to run on a common top-level-domain and you need to forward the incoming HTTP Cookie header to this endpoint:  ```js pseudo-code example router.get(\'/recovery\', async function (req, res) { const flow = await client.getSelfServiceVerificationFlow(req.header(\'cookie\'), req.query[\'flow\'])  res.render(\'verification\', flow) })  More information can be found at [Ory Kratos Email and Phone Verification Documentation](https://www.ory.sh/docs/kratos/selfservice/flows/verify-email-account-activation).
     * @summary Get Verification Flow
     * @param {string} id The Flow ID  The value for this parameter comes from &#x60;request&#x60; URL Query parameter sent to your application (e.g. &#x60;/verification?flow&#x3D;abcde&#x60;).
     * @param {string} [cookie] HTTP Cookies  When using the SDK on the server side you must include the HTTP Cookie Header originally sent to your HTTP handler here.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getSelfServiceVerificationFlow(id: string, cookie?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SelfServiceVerificationFlow>>;
    /**
     * This endpoint provides JavaScript which is needed in order to perform WebAuthn login and registration.  If you are building a JavaScript Browser App (e.g. in ReactJS or AngularJS) you will need to load this file:  ```html <script src=\"https://public-kratos.example.org/.well-known/ory/webauthn.js\" type=\"script\" async /> ```  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Get WebAuthn JavaScript
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getWebAuthnJavaScript(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<string>>;
    /**
     * This endpoint initializes a browser-based user login flow. This endpoint will set the appropriate cookies and anti-CSRF measures required for browser-based flows.  If this endpoint is opened as a link in the browser, it will be redirected to `selfservice.flows.login.ui_url` with the flow ID set as the query parameter `?flow=`. If a valid user session exists already, the browser will be redirected to `urls.default_redirect_url` unless the query parameter `?refresh=true` was set.  If this endpoint is called via an AJAX request, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `session_aal1_required`: Multi-factor auth (e.g. 2fa) was requested but the user has no session yet. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration!  This endpoint is NOT INTENDED for clients that do not have a browser (Chrome, Firefox, ...) as cookies are needed.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Initialize Login Flow for Browsers
     * @param {boolean} [refresh] Refresh a login session  If set to true, this will refresh an existing login session by asking the user to sign in again. This will reset the authenticated_at time of the session.
     * @param {string} [aal] Request a Specific AuthenticationMethod Assurance Level  Use this parameter to upgrade an existing session\&#39;s authenticator assurance level (AAL). This allows you to ask for multi-factor authentication. When an identity sign in using e.g. username+password, the AAL is 1. If you wish to \&quot;upgrade\&quot; the session\&#39;s security by asking the user to perform TOTP / WebAuth/ ... you would set this to \&quot;aal2\&quot;.
     * @param {string} [returnTo] The URL to return the browser to after the flow was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceLoginFlowForBrowsers(refresh?: boolean, aal?: string, returnTo?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SelfServiceLoginFlow>>;
    /**
     * This endpoint initiates a login flow for API clients that do not use a browser, such as mobile devices, smart TVs, and so on.  If a valid provided session cookie or session token is provided, a 400 Bad Request error will be returned unless the URL query parameter `?refresh=true` is set.  To fetch an existing login flow call `/self-service/login/flows?flow=<flow_id>`.  You MUST NOT use this endpoint in client-side (Single Page Apps, ReactJS, AngularJS) nor server-side (Java Server Pages, NodeJS, PHP, Golang, ...) browser applications. Using this endpoint in these applications will make you vulnerable to a variety of CSRF attacks, including CSRF login attacks.  In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `session_aal1_required`: Multi-factor auth (e.g. 2fa) was requested but the user has no session yet. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred.  This endpoint MUST ONLY be used in scenarios such as native mobile apps (React Native, Objective C, Swift, Java, ...).  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Initialize Login Flow for APIs, Services, Apps, ...
     * @param {boolean} [refresh] Refresh a login session  If set to true, this will refresh an existing login session by asking the user to sign in again. This will reset the authenticated_at time of the session.
     * @param {string} [aal] Request a Specific AuthenticationMethod Assurance Level  Use this parameter to upgrade an existing session\&#39;s authenticator assurance level (AAL). This allows you to ask for multi-factor authentication. When an identity sign in using e.g. username+password, the AAL is 1. If you wish to \&quot;upgrade\&quot; the session\&#39;s security by asking the user to perform TOTP / WebAuth/ ... you would set this to \&quot;aal2\&quot;.
     * @param {string} [xSessionToken] The Session Token of the Identity performing the settings flow.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceLoginFlowWithoutBrowser(refresh?: boolean, aal?: string, xSessionToken?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SelfServiceLoginFlow>>;
    /**
     * This endpoint initializes a browser-based account recovery flow. Once initialized, the browser will be redirected to `selfservice.flows.recovery.ui_url` with the flow ID set as the query parameter `?flow=`. If a valid user session exists, the browser is returned to the configured return URL.  If this endpoint is called via an AJAX request, the response contains the recovery flow without any redirects or a 400 bad request error if the user is already authenticated.  This endpoint is NOT INTENDED for clients that do not have a browser (Chrome, Firefox, ...) as cookies are needed.  More information can be found at [Ory Kratos Account Recovery Documentation](../self-service/flows/account-recovery).
     * @summary Initialize Recovery Flow for Browsers
     * @param {string} [returnTo] The URL to return the browser to after the flow was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceRecoveryFlowForBrowsers(returnTo?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SelfServiceRecoveryFlow>>;
    /**
     * This endpoint initiates a recovery flow for API clients such as mobile devices, smart TVs, and so on.  If a valid provided session cookie or session token is provided, a 400 Bad Request error.  To fetch an existing recovery flow call `/self-service/recovery/flows?flow=<flow_id>`.  You MUST NOT use this endpoint in client-side (Single Page Apps, ReactJS, AngularJS) nor server-side (Java Server Pages, NodeJS, PHP, Golang, ...) browser applications. Using this endpoint in these applications will make you vulnerable to a variety of CSRF attacks.  This endpoint MUST ONLY be used in scenarios such as native mobile apps (React Native, Objective C, Swift, Java, ...).   More information can be found at [Ory Kratos Account Recovery Documentation](../self-service/flows/account-recovery).
     * @summary Initialize Recovery Flow for APIs, Services, Apps, ...
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceRecoveryFlowWithoutBrowser(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SelfServiceRecoveryFlow>>;
    /**
     * This endpoint initializes a browser-based user registration flow. This endpoint will set the appropriate cookies and anti-CSRF measures required for browser-based flows.  :::info  This endpoint is EXPERIMENTAL and subject to potential breaking changes in the future.  :::  If this endpoint is opened as a link in the browser, it will be redirected to `selfservice.flows.registration.ui_url` with the flow ID set as the query parameter `?flow=`. If a valid user session exists already, the browser will be redirected to `urls.default_redirect_url`.  If this endpoint is called via an AJAX request, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration!  If this endpoint is called via an AJAX request, the response contains the registration flow without a redirect.  This endpoint is NOT INTENDED for clients that do not have a browser (Chrome, Firefox, ...) as cookies are needed.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Initialize Registration Flow for Browsers
     * @param {string} [returnTo] The URL to return the browser to after the flow was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceRegistrationFlowForBrowsers(returnTo?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SelfServiceRegistrationFlow>>;
    /**
     * This endpoint initiates a registration flow for API clients such as mobile devices, smart TVs, and so on.  If a valid provided session cookie or session token is provided, a 400 Bad Request error will be returned unless the URL query parameter `?refresh=true` is set.  To fetch an existing registration flow call `/self-service/registration/flows?flow=<flow_id>`.  You MUST NOT use this endpoint in client-side (Single Page Apps, ReactJS, AngularJS) nor server-side (Java Server Pages, NodeJS, PHP, Golang, ...) browser applications. Using this endpoint in these applications will make you vulnerable to a variety of CSRF attacks.  In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred.  This endpoint MUST ONLY be used in scenarios such as native mobile apps (React Native, Objective C, Swift, Java, ...).  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Initialize Registration Flow for APIs, Services, Apps, ...
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceRegistrationFlowWithoutBrowser(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SelfServiceRegistrationFlow>>;
    /**
     * This endpoint initializes a browser-based user settings flow. Once initialized, the browser will be redirected to `selfservice.flows.settings.ui_url` with the flow ID set as the query parameter `?flow=`. If no valid Ory Kratos Session Cookie is included in the request, a login flow will be initialized.  If this endpoint is opened as a link in the browser, it will be redirected to `selfservice.flows.settings.ui_url` with the flow ID set as the query parameter `?flow=`. If no valid user session was set, the browser will be redirected to the login endpoint.  If this endpoint is called via an AJAX request, the response contains the settings flow without any redirects or a 401 forbidden error if no valid session was set.  Depending on your configuration this endpoint might return a 403 error if the session has a lower Authenticator Assurance Level (AAL) than is possible for the identity. This can happen if the identity has password + webauthn credentials (which would result in AAL2) but the session has only AAL1. If this error occurs, ask the user to sign in with the second factor (happens automatically for server-side browser flows) or change the configuration.  If this endpoint is called via an AJAX request, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `session_inactive`: No Ory Session was found - sign in a user first. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration!  This endpoint is NOT INTENDED for clients that do not have a browser (Chrome, Firefox, ...) as cookies are needed.  More information can be found at [Ory Kratos User Settings & Profile Management Documentation](../self-service/flows/user-settings).
     * @summary Initialize Settings Flow for Browsers
     * @param {string} [returnTo] The URL to return the browser to after the flow was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceSettingsFlowForBrowsers(returnTo?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SelfServiceSettingsFlow>>;
    /**
     * This endpoint initiates a settings flow for API clients such as mobile devices, smart TVs, and so on. You must provide a valid Ory Kratos Session Token for this endpoint to respond with HTTP 200 OK.  To fetch an existing settings flow call `/self-service/settings/flows?flow=<flow_id>`.  You MUST NOT use this endpoint in client-side (Single Page Apps, ReactJS, AngularJS) nor server-side (Java Server Pages, NodeJS, PHP, Golang, ...) browser applications. Using this endpoint in these applications will make you vulnerable to a variety of CSRF attacks.  Depending on your configuration this endpoint might return a 403 error if the session has a lower Authenticator Assurance Level (AAL) than is possible for the identity. This can happen if the identity has password + webauthn credentials (which would result in AAL2) but the session has only AAL1. If this error occurs, ask the user to sign in with the second factor or change the configuration.  In the case of an error, the `error.id` of the JSON response body can be one of:  `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `session_inactive`: No Ory Session was found - sign in a user first.  This endpoint MUST ONLY be used in scenarios such as native mobile apps (React Native, Objective C, Swift, Java, ...).  More information can be found at [Ory Kratos User Settings & Profile Management Documentation](../self-service/flows/user-settings).
     * @summary Initialize Settings Flow for APIs, Services, Apps, ...
     * @param {string} [xSessionToken] The Session Token of the Identity performing the settings flow.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceSettingsFlowWithoutBrowser(xSessionToken?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SelfServiceSettingsFlow>>;
    /**
     * This endpoint initializes a browser-based account verification flow. Once initialized, the browser will be redirected to `selfservice.flows.verification.ui_url` with the flow ID set as the query parameter `?flow=`.  If this endpoint is called via an AJAX request, the response contains the recovery flow without any redirects.  This endpoint is NOT INTENDED for API clients and only works with browsers (Chrome, Firefox, ...).  More information can be found at [Ory Kratos Email and Phone Verification Documentation](https://www.ory.sh/docs/kratos/selfservice/flows/verify-email-account-activation).
     * @summary Initialize Verification Flow for Browser Clients
     * @param {string} [returnTo] The URL to return the browser to after the flow was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceVerificationFlowForBrowsers(returnTo?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SelfServiceVerificationFlow>>;
    /**
     * This endpoint initiates a verification flow for API clients such as mobile devices, smart TVs, and so on.  To fetch an existing verification flow call `/self-service/verification/flows?flow=<flow_id>`.  You MUST NOT use this endpoint in client-side (Single Page Apps, ReactJS, AngularJS) nor server-side (Java Server Pages, NodeJS, PHP, Golang, ...) browser applications. Using this endpoint in these applications will make you vulnerable to a variety of CSRF attacks.  This endpoint MUST ONLY be used in scenarios such as native mobile apps (React Native, Objective C, Swift, Java, ...).  More information can be found at [Ory Kratos Email and Phone Verification Documentation](https://www.ory.sh/docs/kratos/selfservice/flows/verify-email-account-activation).
     * @summary Initialize Verification Flow for APIs, Services, Apps, ...
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceVerificationFlowWithoutBrowser(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SelfServiceVerificationFlow>>;
    /**
     * Get all Identity Schemas
     * @param {number} [perPage] Items per Page  This is the number of items per page.
     * @param {number} [page] Pagination Page
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    listIdentitySchemas(perPage?: number, page?: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<IdentitySchema>>>;
    /**
     * Lists all projects you have access to.
     * @summary List All Projects
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    listProjects(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<ProjectMetadata>>>;
    /**
     * This endpoint is useful for:  Displaying all other sessions that belong to the logged-in user
     * @summary This endpoints returns all other active sessions that belong to the logged-in user. The current session can be retrieved by calling the `/sessions/whoami` endpoint.
     * @param {string} [xSessionToken] Set the Session Token when calling from non-browser clients. A session token has a format of &#x60;MP2YWEMeM8MxjkGKpH4dqOQ4Q4DlSPaj&#x60;.
     * @param {string} [cookie] Set the Cookie Header. This is especially useful when calling this endpoint from a server-side application. In that scenario you must include the HTTP Cookie Header which originally was included in the request to your server. An example of a session in the HTTP Cookie Header is: &#x60;ory_kratos_session&#x3D;a19iOVAbdzdgl70Rq1QZmrKmcjDtdsviCTZx7m9a9yHIUS8Wa9T7hvqyGTsLHi6Qifn2WUfpAKx9DWp0SJGleIn9vh2YF4A16id93kXFTgIgmwIOvbVAScyrx7yVl6bPZnCx27ec4WQDtaTewC1CpgudeDV2jQQnSaCP6ny3xa8qLH-QUgYqdQuoA_LF1phxgRCUfIrCLQOkolX5nv3ze_f&#x3D;&#x3D;&#x60;.  It is ok if more than one cookie are included here as all other cookies will be ignored.
     * @param {number} [perPage] Items per Page  This is the number of items per page.
     * @param {number} [page] Pagination Page
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    listSessions(xSessionToken?: string, cookie?: string, perPage?: number, page?: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<Session>>>;
    /**
     * This endpoints allows you to patch individual Ory Cloud Project configuration keys for Ory\'s services (identity, permission, ...). The configuration format is fully compatible with the open source projects for the respective services (e.g. Ory Kratos for Identity, Ory Keto for Permissions).  This endpoint expects the `version` key to be set in the payload. If it is unset, it will try to import the config as if it is from the most recent version.  If you have an older version of a configuration, you should set the version key in the payload!  While this endpoint is able to process all configuration items related to features (e.g. password reset), it does not support operational configuration items (e.g. port, tracing, logging) otherwise available in the open source.  For configuration items that can not be translated to Ory Cloud, this endpoint will return a list of warnings to help you understand which parts of your config could not be processed.
     * @summary Patch an Ory Cloud Project Configuration
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {Array<JsonPatch>} [jsonPatch]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    patchProject(projectId: string, jsonPatch?: Array<JsonPatch>, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SuccessfulProjectUpdate>>;
    /**
     * !! Use with extreme caution !!  Using this API endpoint you can purge (completely delete) a project and its data. This action can not be undone and will delete ALL your data.  !! Use with extreme caution !!
     * @summary Irrecoverably Purge a Project
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    purgeProject(projectId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>>;
    /**
     * This endpoint requires the user to be a member of the project with the role `OWNER`.
     * @summary Remove a member associated with this project. This also sets their invite status to `REMOVED`.
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {string} memberId Member ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    removeProjectMember(projectId: string, memberId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>>;
    /**
     * This endpoint is useful for:  To forcefully logout the current user from another device or session
     * @summary Calling this endpoint invalidates the specified session. The current session cannot be revoked. Session data are not deleted.
     * @param {string} id ID is the session\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    revokeSession(id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>>;
    /**
     * This endpoint is useful for:  To forcefully logout the current user from all other devices and sessions
     * @summary Calling this endpoint invalidates all except the current session that belong to the logged-in user. Session data are not deleted.
     * @param {string} [xSessionToken] Set the Session Token when calling from non-browser clients. A session token has a format of &#x60;MP2YWEMeM8MxjkGKpH4dqOQ4Q4DlSPaj&#x60;.
     * @param {string} [cookie] Set the Cookie Header. This is especially useful when calling this endpoint from a server-side application. In that scenario you must include the HTTP Cookie Header which originally was included in the request to your server. An example of a session in the HTTP Cookie Header is: &#x60;ory_kratos_session&#x3D;a19iOVAbdzdgl70Rq1QZmrKmcjDtdsviCTZx7m9a9yHIUS8Wa9T7hvqyGTsLHi6Qifn2WUfpAKx9DWp0SJGleIn9vh2YF4A16id93kXFTgIgmwIOvbVAScyrx7yVl6bPZnCx27ec4WQDtaTewC1CpgudeDV2jQQnSaCP6ny3xa8qLH-QUgYqdQuoA_LF1phxgRCUfIrCLQOkolX5nv3ze_f&#x3D;&#x3D;&#x60;.  It is ok if more than one cookie are included here as all other cookies will be ignored.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    revokeSessions(xSessionToken?: string, cookie?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<RevokedSessions>>;
    /**
     * :::info  This endpoint is EXPERIMENTAL and subject to potential breaking changes in the future.  :::  Use this endpoint to complete a login flow. This endpoint behaves differently for API and browser flows.  API flows expect `application/json` to be sent in the body and responds with HTTP 200 and a application/json body with the session token on success; HTTP 410 if the original flow expired with the appropriate error messages set and optionally a `use_flow_id` parameter in the body; HTTP 400 on form validation errors.  Browser flows expect a Content-Type of `application/x-www-form-urlencoded` or `application/json` to be sent in the body and respond with a HTTP 303 redirect to the post/after login URL or the `return_to` value if it was set and if the login succeeded; a HTTP 303 redirect to the login UI URL with the flow ID containing the validation errors otherwise.  Browser flows with an accept header of `application/json` will not redirect but instead respond with HTTP 200 and a application/json body with the signed in identity and a `Set-Cookie` header on success; HTTP 303 redirect to a fresh login flow if the original flow expired with the appropriate error messages set; HTTP 400 on form validation errors.  If this endpoint is called with `Accept: application/json` in the header, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration! `browser_location_change_required`: Usually sent when an AJAX request indicates that the browser needs to open a specific URL. Most likely used in Social Sign In flows.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Submit a Login Flow
     * @param {string} flow The Login Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/login?flow&#x3D;abcde&#x60;).
     * @param {SubmitSelfServiceLoginFlowBody} submitSelfServiceLoginFlowBody
     * @param {string} [xSessionToken] The Session Token of the Identity performing the settings flow.
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    submitSelfServiceLoginFlow(flow: string, submitSelfServiceLoginFlowBody: SubmitSelfServiceLoginFlowBody, xSessionToken?: string, cookie?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SuccessfulSelfServiceLoginWithoutBrowser>>;
    /**
     * This endpoint logs out an identity in a self-service manner.  If the `Accept` HTTP header is not set to `application/json`, the browser will be redirected (HTTP 303 See Other) to the `return_to` parameter of the initial request or fall back to `urls.default_return_to`.  If the `Accept` HTTP header is set to `application/json`, a 204 No Content response will be sent on successful logout instead.  This endpoint is NOT INTENDED for API clients and only works with browsers (Chrome, Firefox, ...). For API clients you can call the `/self-service/logout/api` URL directly with the Ory Session Token.  More information can be found at [Ory Kratos User Logout Documentation](https://www.ory.sh/docs/next/kratos/self-service/flows/user-logout).
     * @summary Complete Self-Service Logout
     * @param {string} [token] A Valid Logout Token  If you do not have a logout token because you only have a session cookie, call &#x60;/self-service/logout/urls&#x60; to generate a URL for this endpoint.
     * @param {string} [returnTo] The URL to return to after the logout was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    submitSelfServiceLogoutFlow(token?: string, returnTo?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>>;
    /**
     * Use this endpoint to log out an identity using an Ory Session Token. If the Ory Session Token was successfully revoked, the server returns a 204 No Content response. A 204 No Content response is also sent when the Ory Session Token has been revoked already before.  If the Ory Session Token is malformed or does not exist a 403 Forbidden response will be returned.  This endpoint does not remove any HTTP Cookies - use the Browser-Based Self-Service Logout Flow instead.
     * @summary Perform Logout for APIs, Services, Apps, ...
     * @param {SubmitSelfServiceLogoutFlowWithoutBrowserBody} submitSelfServiceLogoutFlowWithoutBrowserBody
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    submitSelfServiceLogoutFlowWithoutBrowser(submitSelfServiceLogoutFlowWithoutBrowserBody: SubmitSelfServiceLogoutFlowWithoutBrowserBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>>;
    /**
     * Use this endpoint to complete a recovery flow. This endpoint behaves differently for API and browser flows and has several states:  `choose_method` expects `flow` (in the URL query) and `email` (in the body) to be sent and works with API- and Browser-initiated flows. For API clients and Browser clients with HTTP Header `Accept: application/json` it either returns a HTTP 200 OK when the form is valid and HTTP 400 OK when the form is invalid. and a HTTP 303 See Other redirect with a fresh recovery flow if the flow was otherwise invalid (e.g. expired). For Browser clients without HTTP Header `Accept` or with `Accept: text/_*` it returns a HTTP 303 See Other redirect to the Recovery UI URL with the Recovery Flow ID appended. `sent_email` is the success state after `choose_method` for the `link` method and allows the user to request another recovery email. It works for both API and Browser-initiated flows and returns the same responses as the flow in `choose_method` state. `passed_challenge` expects a `token` to be sent in the URL query and given the nature of the flow (\"sending a recovery link\") does not have any API capabilities. The server responds with a HTTP 303 See Other redirect either to the Settings UI URL (if the link was valid) and instructs the user to update their password, or a redirect to the Recover UI URL with a new Recovery Flow ID which contains an error message that the recovery link was invalid.  More information can be found at [Ory Kratos Account Recovery Documentation](../self-service/flows/account-recovery).
     * @summary Complete Recovery Flow
     * @param {string} flow The Recovery Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/recovery?flow&#x3D;abcde&#x60;).
     * @param {SubmitSelfServiceRecoveryFlowBody} submitSelfServiceRecoveryFlowBody
     * @param {string} [token] Recovery Token  The recovery token which completes the recovery request. If the token is invalid (e.g. expired) an error will be shown to the end-user.  This parameter is usually set in a link and not used by any direct API call.
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    submitSelfServiceRecoveryFlow(flow: string, submitSelfServiceRecoveryFlowBody: SubmitSelfServiceRecoveryFlowBody, token?: string, cookie?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SelfServiceRecoveryFlow>>;
    /**
     * Use this endpoint to complete a registration flow by sending an identity\'s traits and password. This endpoint behaves differently for API and browser flows.  API flows expect `application/json` to be sent in the body and respond with HTTP 200 and a application/json body with the created identity success - if the session hook is configured the `session` and `session_token` will also be included; HTTP 410 if the original flow expired with the appropriate error messages set and optionally a `use_flow_id` parameter in the body; HTTP 400 on form validation errors.  Browser flows expect a Content-Type of `application/x-www-form-urlencoded` or `application/json` to be sent in the body and respond with a HTTP 303 redirect to the post/after registration URL or the `return_to` value if it was set and if the registration succeeded; a HTTP 303 redirect to the registration UI URL with the flow ID containing the validation errors otherwise.  Browser flows with an accept header of `application/json` will not redirect but instead respond with HTTP 200 and a application/json body with the signed in identity and a `Set-Cookie` header on success; HTTP 303 redirect to a fresh login flow if the original flow expired with the appropriate error messages set; HTTP 400 on form validation errors.  If this endpoint is called with `Accept: application/json` in the header, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration! `browser_location_change_required`: Usually sent when an AJAX request indicates that the browser needs to open a specific URL. Most likely used in Social Sign In flows.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Submit a Registration Flow
     * @param {string} flow The Registration Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/registration?flow&#x3D;abcde&#x60;).
     * @param {SubmitSelfServiceRegistrationFlowBody} submitSelfServiceRegistrationFlowBody
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    submitSelfServiceRegistrationFlow(flow: string, submitSelfServiceRegistrationFlowBody: SubmitSelfServiceRegistrationFlowBody, cookie?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SuccessfulSelfServiceRegistrationWithoutBrowser>>;
    /**
     * Use this endpoint to complete a settings flow by sending an identity\'s updated password. This endpoint behaves differently for API and browser flows.  API-initiated flows expect `application/json` to be sent in the body and respond with HTTP 200 and an application/json body with the session token on success; HTTP 303 redirect to a fresh settings flow if the original flow expired with the appropriate error messages set; HTTP 400 on form validation errors. HTTP 401 when the endpoint is called without a valid session token. HTTP 403 when `selfservice.flows.settings.privileged_session_max_age` was reached or the session\'s AAL is too low. Implies that the user needs to re-authenticate.  Browser flows without HTTP Header `Accept` or with `Accept: text/_*` respond with a HTTP 303 redirect to the post/after settings URL or the `return_to` value if it was set and if the flow succeeded; a HTTP 303 redirect to the Settings UI URL with the flow ID containing the validation errors otherwise. a HTTP 303 redirect to the login endpoint when `selfservice.flows.settings.privileged_session_max_age` was reached or the session\'s AAL is too low.  Browser flows with HTTP Header `Accept: application/json` respond with HTTP 200 and a application/json body with the signed in identity and a `Set-Cookie` header on success; HTTP 303 redirect to a fresh login flow if the original flow expired with the appropriate error messages set; HTTP 401 when the endpoint is called without a valid session cookie. HTTP 403 when the page is accessed without a session cookie or the session\'s AAL is too low. HTTP 400 on form validation errors.  Depending on your configuration this endpoint might return a 403 error if the session has a lower Authenticator Assurance Level (AAL) than is possible for the identity. This can happen if the identity has password + webauthn credentials (which would result in AAL2) but the session has only AAL1. If this error occurs, ask the user to sign in with the second factor (happens automatically for server-side browser flows) or change the configuration.  If this endpoint is called with a `Accept: application/json` HTTP header, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `session_refresh_required`: The identity requested to change something that needs a privileged session. Redirect the identity to the login init endpoint with query parameters `?refresh=true&return_to=<the-current-browser-url>`, or initiate a refresh login flow otherwise. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `session_inactive`: No Ory Session was found - sign in a user first. `security_identity_mismatch`: The flow was interrupted with `session_refresh_required` but apparently some other identity logged in instead. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration! `browser_location_change_required`: Usually sent when an AJAX request indicates that the browser needs to open a specific URL. Most likely used in Social Sign In flows.  More information can be found at [Ory Kratos User Settings & Profile Management Documentation](../self-service/flows/user-settings).
     * @summary Complete Settings Flow
     * @param {string} flow The Settings Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/settings?flow&#x3D;abcde&#x60;).
     * @param {SubmitSelfServiceSettingsFlowBody} submitSelfServiceSettingsFlowBody
     * @param {string} [xSessionToken] The Session Token of the Identity performing the settings flow.
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    submitSelfServiceSettingsFlow(flow: string, submitSelfServiceSettingsFlowBody: SubmitSelfServiceSettingsFlowBody, xSessionToken?: string, cookie?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SelfServiceSettingsFlow>>;
    /**
     * Use this endpoint to complete a verification flow. This endpoint behaves differently for API and browser flows and has several states:  `choose_method` expects `flow` (in the URL query) and `email` (in the body) to be sent and works with API- and Browser-initiated flows. For API clients and Browser clients with HTTP Header `Accept: application/json` it either returns a HTTP 200 OK when the form is valid and HTTP 400 OK when the form is invalid and a HTTP 303 See Other redirect with a fresh verification flow if the flow was otherwise invalid (e.g. expired). For Browser clients without HTTP Header `Accept` or with `Accept: text/_*` it returns a HTTP 303 See Other redirect to the Verification UI URL with the Verification Flow ID appended. `sent_email` is the success state after `choose_method` when using the `link` method and allows the user to request another verification email. It works for both API and Browser-initiated flows and returns the same responses as the flow in `choose_method` state. `passed_challenge` expects a `token` to be sent in the URL query and given the nature of the flow (\"sending a verification link\") does not have any API capabilities. The server responds with a HTTP 303 See Other redirect either to the Settings UI URL (if the link was valid) and instructs the user to update their password, or a redirect to the Verification UI URL with a new Verification Flow ID which contains an error message that the verification link was invalid.  More information can be found at [Ory Kratos Email and Phone Verification Documentation](https://www.ory.sh/docs/kratos/selfservice/flows/verify-email-account-activation).
     * @summary Complete Verification Flow
     * @param {string} flow The Verification Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/verification?flow&#x3D;abcde&#x60;).
     * @param {SubmitSelfServiceVerificationFlowBody} submitSelfServiceVerificationFlowBody
     * @param {string} [token] Verification Token  The verification token which completes the verification request. If the token is invalid (e.g. expired) an error will be shown to the end-user.  This parameter is usually set in a link and not used by any direct API call.
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    submitSelfServiceVerificationFlow(flow: string, submitSelfServiceVerificationFlowBody: SubmitSelfServiceVerificationFlowBody, token?: string, cookie?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SelfServiceVerificationFlow>>;
    /**
     * Uses the HTTP Headers in the GET request to determine (e.g. by using checking the cookies) who is authenticated. Returns a session object in the body or 401 if the credentials are invalid or no credentials were sent. Additionally when the request it successful it adds the user ID to the \'X-Kratos-Authenticated-Identity-Id\' header in the response.  If you call this endpoint from a server-side application, you must forward the HTTP Cookie Header to this endpoint:  ```js pseudo-code example router.get(\'/protected-endpoint\', async function (req, res) { const session = await client.toSession(undefined, req.header(\'cookie\'))  console.log(session) }) ```  When calling this endpoint from a non-browser application (e.g. mobile app) you must include the session token:  ```js pseudo-code example ... const session = await client.toSession(\"the-session-token\")  console.log(session) ```  Depending on your configuration this endpoint might return a 403 status code if the session has a lower Authenticator Assurance Level (AAL) than is possible for the identity. This can happen if the identity has password + webauthn credentials (which would result in AAL2) but the session has only AAL1. If this error occurs, ask the user to sign in with the second factor or change the configuration.  This endpoint is useful for:  AJAX calls. Remember to send credentials and set up CORS correctly! Reverse proxies and API Gateways Server-side calls - use the `X-Session-Token` header!  This endpoint authenticates users by checking  if the `Cookie` HTTP header was set containing an Ory Kratos Session Cookie; if the `Authorization: bearer <ory-session-token>` HTTP header was set with a valid Ory Kratos Session Token; if the `X-Session-Token` HTTP header was set with a valid Ory Kratos Session Token.  If none of these headers are set or the cooke or token are invalid, the endpoint returns a HTTP 401 status code.  As explained above, this request may fail due to several reasons. The `error.id` can be one of:  `session_inactive`: No active session was found in the request (e.g. no Ory Session Cookie / Ory Session Token). `session_aal2_required`: An active session was found but it does not fulfil the Authenticator Assurance Level, implying that the session must (e.g.) authenticate the second factor.
     * @summary Check Who the Current HTTP Session Belongs To
     * @param {string} [xSessionToken] Set the Session Token when calling from non-browser clients. A session token has a format of &#x60;MP2YWEMeM8MxjkGKpH4dqOQ4Q4DlSPaj&#x60;.
     * @param {string} [cookie] Set the Cookie Header. This is especially useful when calling this endpoint from a server-side application. In that scenario you must include the HTTP Cookie Header which originally was included in the request to your server. An example of a session in the HTTP Cookie Header is: &#x60;ory_kratos_session&#x3D;a19iOVAbdzdgl70Rq1QZmrKmcjDtdsviCTZx7m9a9yHIUS8Wa9T7hvqyGTsLHi6Qifn2WUfpAKx9DWp0SJGleIn9vh2YF4A16id93kXFTgIgmwIOvbVAScyrx7yVl6bPZnCx27ec4WQDtaTewC1CpgudeDV2jQQnSaCP6ny3xa8qLH-QUgYqdQuoA_LF1phxgRCUfIrCLQOkolX5nv3ze_f&#x3D;&#x3D;&#x60;.  It is ok if more than one cookie are included here as all other cookies will be ignored.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    toSession(xSessionToken?: string, cookie?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Session>>;
    /**
     * This endpoints allows you to update the Ory Cloud Project configuration for individual services (identity, permission, ...). The configuration is fully compatible with the open source projects for the respective services (e.g. Ory Kratos for Identity, Ory Keto for Permissions).  This endpoint expects the `version` key to be set in the payload. If it is unset, it will try to import the config as if it is from the most recent version.  If you have an older version of a configuration, you should set the version key in the payload!  While this endpoint is able to process all configuration items related to features (e.g. password reset), it does not support operational configuration items (e.g. port, tracing, logging) otherwise available in the open source.  For configuration items that can not be translated to Ory Cloud, this endpoint will return a list of warnings to help you understand which parts of your config could not be processed.  Be aware that updating any service\'s configuration will completely override your current configuration for that service!
     * @summary Update an Ory Cloud Project Configuration
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {UpdateProject} [updateProject]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    updateProject(projectId: string, updateProject?: UpdateProject, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SuccessfulProjectUpdate>>;
};
/**
 * V0alpha2Api - factory interface
 * @export
 */
export declare const V0alpha2ApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     * This endpoint creates an identity. Learn how identities work in [Ory Kratos\' User And Identity Model Documentation](https://www.ory.sh/docs/next/kratos/concepts/identity-user-model).
     * @summary Create an Identity
     * @param {AdminCreateIdentityBody} [adminCreateIdentityBody]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    adminCreateIdentity(adminCreateIdentityBody?: AdminCreateIdentityBody, options?: any): AxiosPromise<Identity>;
    /**
     * This endpoint creates a recovery link which should be given to the user in order for them to recover (or activate) their account.
     * @summary Create a Recovery Link
     * @param {AdminCreateSelfServiceRecoveryLinkBody} [adminCreateSelfServiceRecoveryLinkBody]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    adminCreateSelfServiceRecoveryLink(adminCreateSelfServiceRecoveryLinkBody?: AdminCreateSelfServiceRecoveryLinkBody, options?: any): AxiosPromise<SelfServiceRecoveryLink>;
    /**
     * Calling this endpoint irrecoverably and permanently deletes the identity given its ID. This action can not be undone. This endpoint returns 204 when the identity was deleted or when the identity was not found, in which case it is assumed that is has been deleted already.  Learn how identities work in [Ory Kratos\' User And Identity Model Documentation](https://www.ory.sh/docs/next/kratos/concepts/identity-user-model).
     * @summary Delete an Identity
     * @param {string} id ID is the identity\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    adminDeleteIdentity(id: string, options?: any): AxiosPromise<void>;
    /**
     * This endpoint is useful for:  To forcefully logout Identity from all devices and sessions
     * @summary Calling this endpoint irrecoverably and permanently deletes and invalidates all sessions that belong to the given Identity.
     * @param {string} id ID is the identity\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    adminDeleteIdentitySessions(id: string, options?: any): AxiosPromise<void>;
    /**
     * Retrieve the session ID from the `/sessions/whoami` endpoint / `toSession` SDK method.
     * @summary Calling this endpoint extends the given session ID. If `session.earliest_possible_extend` is set it will only extend the session after the specified time has passed.
     * @param {string} id ID is the session\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    adminExtendSession(id: string, options?: any): AxiosPromise<Session>;
    /**
     * Learn how identities work in [Ory Kratos\' User And Identity Model Documentation](https://www.ory.sh/docs/next/kratos/concepts/identity-user-model).
     * @summary Get an Identity
     * @param {string} id ID must be set to the ID of identity you want to get
     * @param {Array<string>} [includeCredential] DeclassifyCredentials will declassify one or more identity\&#39;s credentials  Currently, only &#x60;oidc&#x60; is supported. This will return the initial OAuth 2.0 Access, Refresh and (optionally) OpenID Connect ID Token.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    adminGetIdentity(id: string, includeCredential?: Array<string>, options?: any): AxiosPromise<Identity>;
    /**
     * Lists all identities. Does not support search at the moment.  Learn how identities work in [Ory Kratos\' User And Identity Model Documentation](https://www.ory.sh/docs/next/kratos/concepts/identity-user-model).
     * @summary List Identities
     * @param {number} [perPage] Items per Page  This is the number of items per page.
     * @param {number} [page] Pagination Page
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    adminListIdentities(perPage?: number, page?: number, options?: any): AxiosPromise<Array<Identity>>;
    /**
     * This endpoint is useful for:  Listing all sessions that belong to an Identity in an administrative context.
     * @summary This endpoint returns all sessions that belong to the given Identity.
     * @param {string} id ID is the identity\&#39;s ID.
     * @param {number} [perPage] Items per Page  This is the number of items per page.
     * @param {number} [page] Pagination Page
     * @param {boolean} [active] Active is a boolean flag that filters out sessions based on the state. If no value is provided, all sessions are returned.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    adminListIdentitySessions(id: string, perPage?: number, page?: number, active?: boolean, options?: any): AxiosPromise<Array<Session>>;
    /**
     * This endpoint updates an identity. The full identity payload (except credentials) is expected. This endpoint does not support patching.  Learn how identities work in [Ory Kratos\' User And Identity Model Documentation](https://www.ory.sh/docs/next/kratos/concepts/identity-user-model).
     * @summary Update an Identity
     * @param {string} id ID must be set to the ID of identity you want to update
     * @param {AdminUpdateIdentityBody} [adminUpdateIdentityBody]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    adminUpdateIdentity(id: string, adminUpdateIdentityBody?: AdminUpdateIdentityBody, options?: any): AxiosPromise<Identity>;
    /**
     * Creates a new project.
     * @summary Create a Project
     * @param {CreateProjectBody} [createProjectBody]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    createProject(createProjectBody?: CreateProjectBody, options?: any): AxiosPromise<Project>;
    /**
     * This endpoint initializes a browser-based user logout flow and a URL which can be used to log out the user.  This endpoint is NOT INTENDED for API clients and only works with browsers (Chrome, Firefox, ...). For API clients you can call the `/self-service/logout/api` URL directly with the Ory Session Token.  The URL is only valid for the currently signed in user. If no user is signed in, this endpoint returns a 401 error.  When calling this endpoint from a backend, please ensure to properly forward the HTTP cookies.
     * @summary Create a Logout URL for Browsers
     * @param {string} [cookie] HTTP Cookies  If you call this endpoint from a backend, please include the original Cookie header in the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    createSelfServiceLogoutFlowUrlForBrowsers(cookie?: string, options?: any): AxiosPromise<SelfServiceLogoutUrl>;
    /**
     * Get a JSON Schema
     * @param {string} id ID must be set to the ID of schema you want to get
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getJsonSchema(id: string, options?: any): AxiosPromise<object>;
    /**
     * Get a projects you have access to by its ID.
     * @summary Get a Project
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getProject(projectId: string, options?: any): AxiosPromise<Project>;
    /**
     * This endpoint requires the user to be a member of the project with the role `OWNER` or `DEVELOPER`.
     * @summary Get all members associated with this project.
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getProjectMembers(projectId: string, options?: any): AxiosPromise<Array<CloudAccount>>;
    /**
     * This endpoint returns the error associated with a user-facing self service errors.  This endpoint supports stub values to help you implement the error UI:  `?id=stub:500` - returns a stub 500 (Internal Server Error) error.  More information can be found at [Ory Kratos User User Facing Error Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-facing-errors).
     * @summary Get Self-Service Errors
     * @param {string} id Error is the error\&#39;s ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getSelfServiceError(id: string, options?: any): AxiosPromise<SelfServiceError>;
    /**
     * This endpoint returns a login flow\'s context with, for example, error details and other information.  Browser flows expect the anti-CSRF cookie to be included in the request\'s HTTP Cookie Header. For AJAX requests you must ensure that cookies are included in the request or requests will fail.  If you use the browser-flow for server-side apps, the services need to run on a common top-level-domain and you need to forward the incoming HTTP Cookie header to this endpoint:  ```js pseudo-code example router.get(\'/login\', async function (req, res) { const flow = await client.getSelfServiceLoginFlow(req.header(\'cookie\'), req.query[\'flow\'])  res.render(\'login\', flow) }) ```  This request may fail due to several reasons. The `error.id` can be one of:  `session_already_available`: The user is already signed in. `self_service_flow_expired`: The flow is expired and you should request a new one.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Get Login Flow
     * @param {string} id The Login Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/login?flow&#x3D;abcde&#x60;).
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getSelfServiceLoginFlow(id: string, cookie?: string, options?: any): AxiosPromise<SelfServiceLoginFlow>;
    /**
     * This endpoint returns a recovery flow\'s context with, for example, error details and other information.  Browser flows expect the anti-CSRF cookie to be included in the request\'s HTTP Cookie Header. For AJAX requests you must ensure that cookies are included in the request or requests will fail.  If you use the browser-flow for server-side apps, the services need to run on a common top-level-domain and you need to forward the incoming HTTP Cookie header to this endpoint:  ```js pseudo-code example router.get(\'/recovery\', async function (req, res) { const flow = await client.getSelfServiceRecoveryFlow(req.header(\'Cookie\'), req.query[\'flow\'])  res.render(\'recovery\', flow) }) ```  More information can be found at [Ory Kratos Account Recovery Documentation](../self-service/flows/account-recovery).
     * @summary Get Recovery Flow
     * @param {string} id The Flow ID  The value for this parameter comes from &#x60;request&#x60; URL Query parameter sent to your application (e.g. &#x60;/recovery?flow&#x3D;abcde&#x60;).
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getSelfServiceRecoveryFlow(id: string, cookie?: string, options?: any): AxiosPromise<SelfServiceRecoveryFlow>;
    /**
     * This endpoint returns a registration flow\'s context with, for example, error details and other information.  Browser flows expect the anti-CSRF cookie to be included in the request\'s HTTP Cookie Header. For AJAX requests you must ensure that cookies are included in the request or requests will fail.  If you use the browser-flow for server-side apps, the services need to run on a common top-level-domain and you need to forward the incoming HTTP Cookie header to this endpoint:  ```js pseudo-code example router.get(\'/registration\', async function (req, res) { const flow = await client.getSelfServiceRegistrationFlow(req.header(\'cookie\'), req.query[\'flow\'])  res.render(\'registration\', flow) }) ```  This request may fail due to several reasons. The `error.id` can be one of:  `session_already_available`: The user is already signed in. `self_service_flow_expired`: The flow is expired and you should request a new one.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Get Registration Flow
     * @param {string} id The Registration Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/registration?flow&#x3D;abcde&#x60;).
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getSelfServiceRegistrationFlow(id: string, cookie?: string, options?: any): AxiosPromise<SelfServiceRegistrationFlow>;
    /**
     * When accessing this endpoint through Ory Kratos\' Public API you must ensure that either the Ory Kratos Session Cookie or the Ory Kratos Session Token are set.  Depending on your configuration this endpoint might return a 403 error if the session has a lower Authenticator Assurance Level (AAL) than is possible for the identity. This can happen if the identity has password + webauthn credentials (which would result in AAL2) but the session has only AAL1. If this error occurs, ask the user to sign in with the second factor or change the configuration.  You can access this endpoint without credentials when using Ory Kratos\' Admin API.  If this endpoint is called via an AJAX request, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `session_inactive`: No Ory Session was found - sign in a user first. `security_identity_mismatch`: The flow was interrupted with `session_refresh_required` but apparently some other identity logged in instead.  More information can be found at [Ory Kratos User Settings & Profile Management Documentation](../self-service/flows/user-settings).
     * @summary Get Settings Flow
     * @param {string} id ID is the Settings Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/settings?flow&#x3D;abcde&#x60;).
     * @param {string} [xSessionToken] The Session Token  When using the SDK in an app without a browser, please include the session token here.
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getSelfServiceSettingsFlow(id: string, xSessionToken?: string, cookie?: string, options?: any): AxiosPromise<SelfServiceSettingsFlow>;
    /**
     * This endpoint returns a verification flow\'s context with, for example, error details and other information.  Browser flows expect the anti-CSRF cookie to be included in the request\'s HTTP Cookie Header. For AJAX requests you must ensure that cookies are included in the request or requests will fail.  If you use the browser-flow for server-side apps, the services need to run on a common top-level-domain and you need to forward the incoming HTTP Cookie header to this endpoint:  ```js pseudo-code example router.get(\'/recovery\', async function (req, res) { const flow = await client.getSelfServiceVerificationFlow(req.header(\'cookie\'), req.query[\'flow\'])  res.render(\'verification\', flow) })  More information can be found at [Ory Kratos Email and Phone Verification Documentation](https://www.ory.sh/docs/kratos/selfservice/flows/verify-email-account-activation).
     * @summary Get Verification Flow
     * @param {string} id The Flow ID  The value for this parameter comes from &#x60;request&#x60; URL Query parameter sent to your application (e.g. &#x60;/verification?flow&#x3D;abcde&#x60;).
     * @param {string} [cookie] HTTP Cookies  When using the SDK on the server side you must include the HTTP Cookie Header originally sent to your HTTP handler here.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getSelfServiceVerificationFlow(id: string, cookie?: string, options?: any): AxiosPromise<SelfServiceVerificationFlow>;
    /**
     * This endpoint provides JavaScript which is needed in order to perform WebAuthn login and registration.  If you are building a JavaScript Browser App (e.g. in ReactJS or AngularJS) you will need to load this file:  ```html <script src=\"https://public-kratos.example.org/.well-known/ory/webauthn.js\" type=\"script\" async /> ```  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Get WebAuthn JavaScript
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getWebAuthnJavaScript(options?: any): AxiosPromise<string>;
    /**
     * This endpoint initializes a browser-based user login flow. This endpoint will set the appropriate cookies and anti-CSRF measures required for browser-based flows.  If this endpoint is opened as a link in the browser, it will be redirected to `selfservice.flows.login.ui_url` with the flow ID set as the query parameter `?flow=`. If a valid user session exists already, the browser will be redirected to `urls.default_redirect_url` unless the query parameter `?refresh=true` was set.  If this endpoint is called via an AJAX request, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `session_aal1_required`: Multi-factor auth (e.g. 2fa) was requested but the user has no session yet. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration!  This endpoint is NOT INTENDED for clients that do not have a browser (Chrome, Firefox, ...) as cookies are needed.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Initialize Login Flow for Browsers
     * @param {boolean} [refresh] Refresh a login session  If set to true, this will refresh an existing login session by asking the user to sign in again. This will reset the authenticated_at time of the session.
     * @param {string} [aal] Request a Specific AuthenticationMethod Assurance Level  Use this parameter to upgrade an existing session\&#39;s authenticator assurance level (AAL). This allows you to ask for multi-factor authentication. When an identity sign in using e.g. username+password, the AAL is 1. If you wish to \&quot;upgrade\&quot; the session\&#39;s security by asking the user to perform TOTP / WebAuth/ ... you would set this to \&quot;aal2\&quot;.
     * @param {string} [returnTo] The URL to return the browser to after the flow was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceLoginFlowForBrowsers(refresh?: boolean, aal?: string, returnTo?: string, options?: any): AxiosPromise<SelfServiceLoginFlow>;
    /**
     * This endpoint initiates a login flow for API clients that do not use a browser, such as mobile devices, smart TVs, and so on.  If a valid provided session cookie or session token is provided, a 400 Bad Request error will be returned unless the URL query parameter `?refresh=true` is set.  To fetch an existing login flow call `/self-service/login/flows?flow=<flow_id>`.  You MUST NOT use this endpoint in client-side (Single Page Apps, ReactJS, AngularJS) nor server-side (Java Server Pages, NodeJS, PHP, Golang, ...) browser applications. Using this endpoint in these applications will make you vulnerable to a variety of CSRF attacks, including CSRF login attacks.  In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `session_aal1_required`: Multi-factor auth (e.g. 2fa) was requested but the user has no session yet. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred.  This endpoint MUST ONLY be used in scenarios such as native mobile apps (React Native, Objective C, Swift, Java, ...).  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Initialize Login Flow for APIs, Services, Apps, ...
     * @param {boolean} [refresh] Refresh a login session  If set to true, this will refresh an existing login session by asking the user to sign in again. This will reset the authenticated_at time of the session.
     * @param {string} [aal] Request a Specific AuthenticationMethod Assurance Level  Use this parameter to upgrade an existing session\&#39;s authenticator assurance level (AAL). This allows you to ask for multi-factor authentication. When an identity sign in using e.g. username+password, the AAL is 1. If you wish to \&quot;upgrade\&quot; the session\&#39;s security by asking the user to perform TOTP / WebAuth/ ... you would set this to \&quot;aal2\&quot;.
     * @param {string} [xSessionToken] The Session Token of the Identity performing the settings flow.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceLoginFlowWithoutBrowser(refresh?: boolean, aal?: string, xSessionToken?: string, options?: any): AxiosPromise<SelfServiceLoginFlow>;
    /**
     * This endpoint initializes a browser-based account recovery flow. Once initialized, the browser will be redirected to `selfservice.flows.recovery.ui_url` with the flow ID set as the query parameter `?flow=`. If a valid user session exists, the browser is returned to the configured return URL.  If this endpoint is called via an AJAX request, the response contains the recovery flow without any redirects or a 400 bad request error if the user is already authenticated.  This endpoint is NOT INTENDED for clients that do not have a browser (Chrome, Firefox, ...) as cookies are needed.  More information can be found at [Ory Kratos Account Recovery Documentation](../self-service/flows/account-recovery).
     * @summary Initialize Recovery Flow for Browsers
     * @param {string} [returnTo] The URL to return the browser to after the flow was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceRecoveryFlowForBrowsers(returnTo?: string, options?: any): AxiosPromise<SelfServiceRecoveryFlow>;
    /**
     * This endpoint initiates a recovery flow for API clients such as mobile devices, smart TVs, and so on.  If a valid provided session cookie or session token is provided, a 400 Bad Request error.  To fetch an existing recovery flow call `/self-service/recovery/flows?flow=<flow_id>`.  You MUST NOT use this endpoint in client-side (Single Page Apps, ReactJS, AngularJS) nor server-side (Java Server Pages, NodeJS, PHP, Golang, ...) browser applications. Using this endpoint in these applications will make you vulnerable to a variety of CSRF attacks.  This endpoint MUST ONLY be used in scenarios such as native mobile apps (React Native, Objective C, Swift, Java, ...).   More information can be found at [Ory Kratos Account Recovery Documentation](../self-service/flows/account-recovery).
     * @summary Initialize Recovery Flow for APIs, Services, Apps, ...
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceRecoveryFlowWithoutBrowser(options?: any): AxiosPromise<SelfServiceRecoveryFlow>;
    /**
     * This endpoint initializes a browser-based user registration flow. This endpoint will set the appropriate cookies and anti-CSRF measures required for browser-based flows.  :::info  This endpoint is EXPERIMENTAL and subject to potential breaking changes in the future.  :::  If this endpoint is opened as a link in the browser, it will be redirected to `selfservice.flows.registration.ui_url` with the flow ID set as the query parameter `?flow=`. If a valid user session exists already, the browser will be redirected to `urls.default_redirect_url`.  If this endpoint is called via an AJAX request, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration!  If this endpoint is called via an AJAX request, the response contains the registration flow without a redirect.  This endpoint is NOT INTENDED for clients that do not have a browser (Chrome, Firefox, ...) as cookies are needed.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Initialize Registration Flow for Browsers
     * @param {string} [returnTo] The URL to return the browser to after the flow was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceRegistrationFlowForBrowsers(returnTo?: string, options?: any): AxiosPromise<SelfServiceRegistrationFlow>;
    /**
     * This endpoint initiates a registration flow for API clients such as mobile devices, smart TVs, and so on.  If a valid provided session cookie or session token is provided, a 400 Bad Request error will be returned unless the URL query parameter `?refresh=true` is set.  To fetch an existing registration flow call `/self-service/registration/flows?flow=<flow_id>`.  You MUST NOT use this endpoint in client-side (Single Page Apps, ReactJS, AngularJS) nor server-side (Java Server Pages, NodeJS, PHP, Golang, ...) browser applications. Using this endpoint in these applications will make you vulnerable to a variety of CSRF attacks.  In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred.  This endpoint MUST ONLY be used in scenarios such as native mobile apps (React Native, Objective C, Swift, Java, ...).  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Initialize Registration Flow for APIs, Services, Apps, ...
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceRegistrationFlowWithoutBrowser(options?: any): AxiosPromise<SelfServiceRegistrationFlow>;
    /**
     * This endpoint initializes a browser-based user settings flow. Once initialized, the browser will be redirected to `selfservice.flows.settings.ui_url` with the flow ID set as the query parameter `?flow=`. If no valid Ory Kratos Session Cookie is included in the request, a login flow will be initialized.  If this endpoint is opened as a link in the browser, it will be redirected to `selfservice.flows.settings.ui_url` with the flow ID set as the query parameter `?flow=`. If no valid user session was set, the browser will be redirected to the login endpoint.  If this endpoint is called via an AJAX request, the response contains the settings flow without any redirects or a 401 forbidden error if no valid session was set.  Depending on your configuration this endpoint might return a 403 error if the session has a lower Authenticator Assurance Level (AAL) than is possible for the identity. This can happen if the identity has password + webauthn credentials (which would result in AAL2) but the session has only AAL1. If this error occurs, ask the user to sign in with the second factor (happens automatically for server-side browser flows) or change the configuration.  If this endpoint is called via an AJAX request, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `session_inactive`: No Ory Session was found - sign in a user first. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration!  This endpoint is NOT INTENDED for clients that do not have a browser (Chrome, Firefox, ...) as cookies are needed.  More information can be found at [Ory Kratos User Settings & Profile Management Documentation](../self-service/flows/user-settings).
     * @summary Initialize Settings Flow for Browsers
     * @param {string} [returnTo] The URL to return the browser to after the flow was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceSettingsFlowForBrowsers(returnTo?: string, options?: any): AxiosPromise<SelfServiceSettingsFlow>;
    /**
     * This endpoint initiates a settings flow for API clients such as mobile devices, smart TVs, and so on. You must provide a valid Ory Kratos Session Token for this endpoint to respond with HTTP 200 OK.  To fetch an existing settings flow call `/self-service/settings/flows?flow=<flow_id>`.  You MUST NOT use this endpoint in client-side (Single Page Apps, ReactJS, AngularJS) nor server-side (Java Server Pages, NodeJS, PHP, Golang, ...) browser applications. Using this endpoint in these applications will make you vulnerable to a variety of CSRF attacks.  Depending on your configuration this endpoint might return a 403 error if the session has a lower Authenticator Assurance Level (AAL) than is possible for the identity. This can happen if the identity has password + webauthn credentials (which would result in AAL2) but the session has only AAL1. If this error occurs, ask the user to sign in with the second factor or change the configuration.  In the case of an error, the `error.id` of the JSON response body can be one of:  `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `session_inactive`: No Ory Session was found - sign in a user first.  This endpoint MUST ONLY be used in scenarios such as native mobile apps (React Native, Objective C, Swift, Java, ...).  More information can be found at [Ory Kratos User Settings & Profile Management Documentation](../self-service/flows/user-settings).
     * @summary Initialize Settings Flow for APIs, Services, Apps, ...
     * @param {string} [xSessionToken] The Session Token of the Identity performing the settings flow.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceSettingsFlowWithoutBrowser(xSessionToken?: string, options?: any): AxiosPromise<SelfServiceSettingsFlow>;
    /**
     * This endpoint initializes a browser-based account verification flow. Once initialized, the browser will be redirected to `selfservice.flows.verification.ui_url` with the flow ID set as the query parameter `?flow=`.  If this endpoint is called via an AJAX request, the response contains the recovery flow without any redirects.  This endpoint is NOT INTENDED for API clients and only works with browsers (Chrome, Firefox, ...).  More information can be found at [Ory Kratos Email and Phone Verification Documentation](https://www.ory.sh/docs/kratos/selfservice/flows/verify-email-account-activation).
     * @summary Initialize Verification Flow for Browser Clients
     * @param {string} [returnTo] The URL to return the browser to after the flow was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceVerificationFlowForBrowsers(returnTo?: string, options?: any): AxiosPromise<SelfServiceVerificationFlow>;
    /**
     * This endpoint initiates a verification flow for API clients such as mobile devices, smart TVs, and so on.  To fetch an existing verification flow call `/self-service/verification/flows?flow=<flow_id>`.  You MUST NOT use this endpoint in client-side (Single Page Apps, ReactJS, AngularJS) nor server-side (Java Server Pages, NodeJS, PHP, Golang, ...) browser applications. Using this endpoint in these applications will make you vulnerable to a variety of CSRF attacks.  This endpoint MUST ONLY be used in scenarios such as native mobile apps (React Native, Objective C, Swift, Java, ...).  More information can be found at [Ory Kratos Email and Phone Verification Documentation](https://www.ory.sh/docs/kratos/selfservice/flows/verify-email-account-activation).
     * @summary Initialize Verification Flow for APIs, Services, Apps, ...
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    initializeSelfServiceVerificationFlowWithoutBrowser(options?: any): AxiosPromise<SelfServiceVerificationFlow>;
    /**
     * Get all Identity Schemas
     * @param {number} [perPage] Items per Page  This is the number of items per page.
     * @param {number} [page] Pagination Page
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    listIdentitySchemas(perPage?: number, page?: number, options?: any): AxiosPromise<Array<IdentitySchema>>;
    /**
     * Lists all projects you have access to.
     * @summary List All Projects
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    listProjects(options?: any): AxiosPromise<Array<ProjectMetadata>>;
    /**
     * This endpoint is useful for:  Displaying all other sessions that belong to the logged-in user
     * @summary This endpoints returns all other active sessions that belong to the logged-in user. The current session can be retrieved by calling the `/sessions/whoami` endpoint.
     * @param {string} [xSessionToken] Set the Session Token when calling from non-browser clients. A session token has a format of &#x60;MP2YWEMeM8MxjkGKpH4dqOQ4Q4DlSPaj&#x60;.
     * @param {string} [cookie] Set the Cookie Header. This is especially useful when calling this endpoint from a server-side application. In that scenario you must include the HTTP Cookie Header which originally was included in the request to your server. An example of a session in the HTTP Cookie Header is: &#x60;ory_kratos_session&#x3D;a19iOVAbdzdgl70Rq1QZmrKmcjDtdsviCTZx7m9a9yHIUS8Wa9T7hvqyGTsLHi6Qifn2WUfpAKx9DWp0SJGleIn9vh2YF4A16id93kXFTgIgmwIOvbVAScyrx7yVl6bPZnCx27ec4WQDtaTewC1CpgudeDV2jQQnSaCP6ny3xa8qLH-QUgYqdQuoA_LF1phxgRCUfIrCLQOkolX5nv3ze_f&#x3D;&#x3D;&#x60;.  It is ok if more than one cookie are included here as all other cookies will be ignored.
     * @param {number} [perPage] Items per Page  This is the number of items per page.
     * @param {number} [page] Pagination Page
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    listSessions(xSessionToken?: string, cookie?: string, perPage?: number, page?: number, options?: any): AxiosPromise<Array<Session>>;
    /**
     * This endpoints allows you to patch individual Ory Cloud Project configuration keys for Ory\'s services (identity, permission, ...). The configuration format is fully compatible with the open source projects for the respective services (e.g. Ory Kratos for Identity, Ory Keto for Permissions).  This endpoint expects the `version` key to be set in the payload. If it is unset, it will try to import the config as if it is from the most recent version.  If you have an older version of a configuration, you should set the version key in the payload!  While this endpoint is able to process all configuration items related to features (e.g. password reset), it does not support operational configuration items (e.g. port, tracing, logging) otherwise available in the open source.  For configuration items that can not be translated to Ory Cloud, this endpoint will return a list of warnings to help you understand which parts of your config could not be processed.
     * @summary Patch an Ory Cloud Project Configuration
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {Array<JsonPatch>} [jsonPatch]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    patchProject(projectId: string, jsonPatch?: Array<JsonPatch>, options?: any): AxiosPromise<SuccessfulProjectUpdate>;
    /**
     * !! Use with extreme caution !!  Using this API endpoint you can purge (completely delete) a project and its data. This action can not be undone and will delete ALL your data.  !! Use with extreme caution !!
     * @summary Irrecoverably Purge a Project
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    purgeProject(projectId: string, options?: any): AxiosPromise<void>;
    /**
     * This endpoint requires the user to be a member of the project with the role `OWNER`.
     * @summary Remove a member associated with this project. This also sets their invite status to `REMOVED`.
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {string} memberId Member ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    removeProjectMember(projectId: string, memberId: string, options?: any): AxiosPromise<void>;
    /**
     * This endpoint is useful for:  To forcefully logout the current user from another device or session
     * @summary Calling this endpoint invalidates the specified session. The current session cannot be revoked. Session data are not deleted.
     * @param {string} id ID is the session\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    revokeSession(id: string, options?: any): AxiosPromise<void>;
    /**
     * This endpoint is useful for:  To forcefully logout the current user from all other devices and sessions
     * @summary Calling this endpoint invalidates all except the current session that belong to the logged-in user. Session data are not deleted.
     * @param {string} [xSessionToken] Set the Session Token when calling from non-browser clients. A session token has a format of &#x60;MP2YWEMeM8MxjkGKpH4dqOQ4Q4DlSPaj&#x60;.
     * @param {string} [cookie] Set the Cookie Header. This is especially useful when calling this endpoint from a server-side application. In that scenario you must include the HTTP Cookie Header which originally was included in the request to your server. An example of a session in the HTTP Cookie Header is: &#x60;ory_kratos_session&#x3D;a19iOVAbdzdgl70Rq1QZmrKmcjDtdsviCTZx7m9a9yHIUS8Wa9T7hvqyGTsLHi6Qifn2WUfpAKx9DWp0SJGleIn9vh2YF4A16id93kXFTgIgmwIOvbVAScyrx7yVl6bPZnCx27ec4WQDtaTewC1CpgudeDV2jQQnSaCP6ny3xa8qLH-QUgYqdQuoA_LF1phxgRCUfIrCLQOkolX5nv3ze_f&#x3D;&#x3D;&#x60;.  It is ok if more than one cookie are included here as all other cookies will be ignored.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    revokeSessions(xSessionToken?: string, cookie?: string, options?: any): AxiosPromise<RevokedSessions>;
    /**
     * :::info  This endpoint is EXPERIMENTAL and subject to potential breaking changes in the future.  :::  Use this endpoint to complete a login flow. This endpoint behaves differently for API and browser flows.  API flows expect `application/json` to be sent in the body and responds with HTTP 200 and a application/json body with the session token on success; HTTP 410 if the original flow expired with the appropriate error messages set and optionally a `use_flow_id` parameter in the body; HTTP 400 on form validation errors.  Browser flows expect a Content-Type of `application/x-www-form-urlencoded` or `application/json` to be sent in the body and respond with a HTTP 303 redirect to the post/after login URL or the `return_to` value if it was set and if the login succeeded; a HTTP 303 redirect to the login UI URL with the flow ID containing the validation errors otherwise.  Browser flows with an accept header of `application/json` will not redirect but instead respond with HTTP 200 and a application/json body with the signed in identity and a `Set-Cookie` header on success; HTTP 303 redirect to a fresh login flow if the original flow expired with the appropriate error messages set; HTTP 400 on form validation errors.  If this endpoint is called with `Accept: application/json` in the header, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration! `browser_location_change_required`: Usually sent when an AJAX request indicates that the browser needs to open a specific URL. Most likely used in Social Sign In flows.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Submit a Login Flow
     * @param {string} flow The Login Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/login?flow&#x3D;abcde&#x60;).
     * @param {SubmitSelfServiceLoginFlowBody} submitSelfServiceLoginFlowBody
     * @param {string} [xSessionToken] The Session Token of the Identity performing the settings flow.
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    submitSelfServiceLoginFlow(flow: string, submitSelfServiceLoginFlowBody: SubmitSelfServiceLoginFlowBody, xSessionToken?: string, cookie?: string, options?: any): AxiosPromise<SuccessfulSelfServiceLoginWithoutBrowser>;
    /**
     * This endpoint logs out an identity in a self-service manner.  If the `Accept` HTTP header is not set to `application/json`, the browser will be redirected (HTTP 303 See Other) to the `return_to` parameter of the initial request or fall back to `urls.default_return_to`.  If the `Accept` HTTP header is set to `application/json`, a 204 No Content response will be sent on successful logout instead.  This endpoint is NOT INTENDED for API clients and only works with browsers (Chrome, Firefox, ...). For API clients you can call the `/self-service/logout/api` URL directly with the Ory Session Token.  More information can be found at [Ory Kratos User Logout Documentation](https://www.ory.sh/docs/next/kratos/self-service/flows/user-logout).
     * @summary Complete Self-Service Logout
     * @param {string} [token] A Valid Logout Token  If you do not have a logout token because you only have a session cookie, call &#x60;/self-service/logout/urls&#x60; to generate a URL for this endpoint.
     * @param {string} [returnTo] The URL to return to after the logout was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    submitSelfServiceLogoutFlow(token?: string, returnTo?: string, options?: any): AxiosPromise<void>;
    /**
     * Use this endpoint to log out an identity using an Ory Session Token. If the Ory Session Token was successfully revoked, the server returns a 204 No Content response. A 204 No Content response is also sent when the Ory Session Token has been revoked already before.  If the Ory Session Token is malformed or does not exist a 403 Forbidden response will be returned.  This endpoint does not remove any HTTP Cookies - use the Browser-Based Self-Service Logout Flow instead.
     * @summary Perform Logout for APIs, Services, Apps, ...
     * @param {SubmitSelfServiceLogoutFlowWithoutBrowserBody} submitSelfServiceLogoutFlowWithoutBrowserBody
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    submitSelfServiceLogoutFlowWithoutBrowser(submitSelfServiceLogoutFlowWithoutBrowserBody: SubmitSelfServiceLogoutFlowWithoutBrowserBody, options?: any): AxiosPromise<void>;
    /**
     * Use this endpoint to complete a recovery flow. This endpoint behaves differently for API and browser flows and has several states:  `choose_method` expects `flow` (in the URL query) and `email` (in the body) to be sent and works with API- and Browser-initiated flows. For API clients and Browser clients with HTTP Header `Accept: application/json` it either returns a HTTP 200 OK when the form is valid and HTTP 400 OK when the form is invalid. and a HTTP 303 See Other redirect with a fresh recovery flow if the flow was otherwise invalid (e.g. expired). For Browser clients without HTTP Header `Accept` or with `Accept: text/_*` it returns a HTTP 303 See Other redirect to the Recovery UI URL with the Recovery Flow ID appended. `sent_email` is the success state after `choose_method` for the `link` method and allows the user to request another recovery email. It works for both API and Browser-initiated flows and returns the same responses as the flow in `choose_method` state. `passed_challenge` expects a `token` to be sent in the URL query and given the nature of the flow (\"sending a recovery link\") does not have any API capabilities. The server responds with a HTTP 303 See Other redirect either to the Settings UI URL (if the link was valid) and instructs the user to update their password, or a redirect to the Recover UI URL with a new Recovery Flow ID which contains an error message that the recovery link was invalid.  More information can be found at [Ory Kratos Account Recovery Documentation](../self-service/flows/account-recovery).
     * @summary Complete Recovery Flow
     * @param {string} flow The Recovery Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/recovery?flow&#x3D;abcde&#x60;).
     * @param {SubmitSelfServiceRecoveryFlowBody} submitSelfServiceRecoveryFlowBody
     * @param {string} [token] Recovery Token  The recovery token which completes the recovery request. If the token is invalid (e.g. expired) an error will be shown to the end-user.  This parameter is usually set in a link and not used by any direct API call.
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    submitSelfServiceRecoveryFlow(flow: string, submitSelfServiceRecoveryFlowBody: SubmitSelfServiceRecoveryFlowBody, token?: string, cookie?: string, options?: any): AxiosPromise<SelfServiceRecoveryFlow>;
    /**
     * Use this endpoint to complete a registration flow by sending an identity\'s traits and password. This endpoint behaves differently for API and browser flows.  API flows expect `application/json` to be sent in the body and respond with HTTP 200 and a application/json body with the created identity success - if the session hook is configured the `session` and `session_token` will also be included; HTTP 410 if the original flow expired with the appropriate error messages set and optionally a `use_flow_id` parameter in the body; HTTP 400 on form validation errors.  Browser flows expect a Content-Type of `application/x-www-form-urlencoded` or `application/json` to be sent in the body and respond with a HTTP 303 redirect to the post/after registration URL or the `return_to` value if it was set and if the registration succeeded; a HTTP 303 redirect to the registration UI URL with the flow ID containing the validation errors otherwise.  Browser flows with an accept header of `application/json` will not redirect but instead respond with HTTP 200 and a application/json body with the signed in identity and a `Set-Cookie` header on success; HTTP 303 redirect to a fresh login flow if the original flow expired with the appropriate error messages set; HTTP 400 on form validation errors.  If this endpoint is called with `Accept: application/json` in the header, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration! `browser_location_change_required`: Usually sent when an AJAX request indicates that the browser needs to open a specific URL. Most likely used in Social Sign In flows.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Submit a Registration Flow
     * @param {string} flow The Registration Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/registration?flow&#x3D;abcde&#x60;).
     * @param {SubmitSelfServiceRegistrationFlowBody} submitSelfServiceRegistrationFlowBody
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    submitSelfServiceRegistrationFlow(flow: string, submitSelfServiceRegistrationFlowBody: SubmitSelfServiceRegistrationFlowBody, cookie?: string, options?: any): AxiosPromise<SuccessfulSelfServiceRegistrationWithoutBrowser>;
    /**
     * Use this endpoint to complete a settings flow by sending an identity\'s updated password. This endpoint behaves differently for API and browser flows.  API-initiated flows expect `application/json` to be sent in the body and respond with HTTP 200 and an application/json body with the session token on success; HTTP 303 redirect to a fresh settings flow if the original flow expired with the appropriate error messages set; HTTP 400 on form validation errors. HTTP 401 when the endpoint is called without a valid session token. HTTP 403 when `selfservice.flows.settings.privileged_session_max_age` was reached or the session\'s AAL is too low. Implies that the user needs to re-authenticate.  Browser flows without HTTP Header `Accept` or with `Accept: text/_*` respond with a HTTP 303 redirect to the post/after settings URL or the `return_to` value if it was set and if the flow succeeded; a HTTP 303 redirect to the Settings UI URL with the flow ID containing the validation errors otherwise. a HTTP 303 redirect to the login endpoint when `selfservice.flows.settings.privileged_session_max_age` was reached or the session\'s AAL is too low.  Browser flows with HTTP Header `Accept: application/json` respond with HTTP 200 and a application/json body with the signed in identity and a `Set-Cookie` header on success; HTTP 303 redirect to a fresh login flow if the original flow expired with the appropriate error messages set; HTTP 401 when the endpoint is called without a valid session cookie. HTTP 403 when the page is accessed without a session cookie or the session\'s AAL is too low. HTTP 400 on form validation errors.  Depending on your configuration this endpoint might return a 403 error if the session has a lower Authenticator Assurance Level (AAL) than is possible for the identity. This can happen if the identity has password + webauthn credentials (which would result in AAL2) but the session has only AAL1. If this error occurs, ask the user to sign in with the second factor (happens automatically for server-side browser flows) or change the configuration.  If this endpoint is called with a `Accept: application/json` HTTP header, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `session_refresh_required`: The identity requested to change something that needs a privileged session. Redirect the identity to the login init endpoint with query parameters `?refresh=true&return_to=<the-current-browser-url>`, or initiate a refresh login flow otherwise. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `session_inactive`: No Ory Session was found - sign in a user first. `security_identity_mismatch`: The flow was interrupted with `session_refresh_required` but apparently some other identity logged in instead. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration! `browser_location_change_required`: Usually sent when an AJAX request indicates that the browser needs to open a specific URL. Most likely used in Social Sign In flows.  More information can be found at [Ory Kratos User Settings & Profile Management Documentation](../self-service/flows/user-settings).
     * @summary Complete Settings Flow
     * @param {string} flow The Settings Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/settings?flow&#x3D;abcde&#x60;).
     * @param {SubmitSelfServiceSettingsFlowBody} submitSelfServiceSettingsFlowBody
     * @param {string} [xSessionToken] The Session Token of the Identity performing the settings flow.
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    submitSelfServiceSettingsFlow(flow: string, submitSelfServiceSettingsFlowBody: SubmitSelfServiceSettingsFlowBody, xSessionToken?: string, cookie?: string, options?: any): AxiosPromise<SelfServiceSettingsFlow>;
    /**
     * Use this endpoint to complete a verification flow. This endpoint behaves differently for API and browser flows and has several states:  `choose_method` expects `flow` (in the URL query) and `email` (in the body) to be sent and works with API- and Browser-initiated flows. For API clients and Browser clients with HTTP Header `Accept: application/json` it either returns a HTTP 200 OK when the form is valid and HTTP 400 OK when the form is invalid and a HTTP 303 See Other redirect with a fresh verification flow if the flow was otherwise invalid (e.g. expired). For Browser clients without HTTP Header `Accept` or with `Accept: text/_*` it returns a HTTP 303 See Other redirect to the Verification UI URL with the Verification Flow ID appended. `sent_email` is the success state after `choose_method` when using the `link` method and allows the user to request another verification email. It works for both API and Browser-initiated flows and returns the same responses as the flow in `choose_method` state. `passed_challenge` expects a `token` to be sent in the URL query and given the nature of the flow (\"sending a verification link\") does not have any API capabilities. The server responds with a HTTP 303 See Other redirect either to the Settings UI URL (if the link was valid) and instructs the user to update their password, or a redirect to the Verification UI URL with a new Verification Flow ID which contains an error message that the verification link was invalid.  More information can be found at [Ory Kratos Email and Phone Verification Documentation](https://www.ory.sh/docs/kratos/selfservice/flows/verify-email-account-activation).
     * @summary Complete Verification Flow
     * @param {string} flow The Verification Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/verification?flow&#x3D;abcde&#x60;).
     * @param {SubmitSelfServiceVerificationFlowBody} submitSelfServiceVerificationFlowBody
     * @param {string} [token] Verification Token  The verification token which completes the verification request. If the token is invalid (e.g. expired) an error will be shown to the end-user.  This parameter is usually set in a link and not used by any direct API call.
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    submitSelfServiceVerificationFlow(flow: string, submitSelfServiceVerificationFlowBody: SubmitSelfServiceVerificationFlowBody, token?: string, cookie?: string, options?: any): AxiosPromise<SelfServiceVerificationFlow>;
    /**
     * Uses the HTTP Headers in the GET request to determine (e.g. by using checking the cookies) who is authenticated. Returns a session object in the body or 401 if the credentials are invalid or no credentials were sent. Additionally when the request it successful it adds the user ID to the \'X-Kratos-Authenticated-Identity-Id\' header in the response.  If you call this endpoint from a server-side application, you must forward the HTTP Cookie Header to this endpoint:  ```js pseudo-code example router.get(\'/protected-endpoint\', async function (req, res) { const session = await client.toSession(undefined, req.header(\'cookie\'))  console.log(session) }) ```  When calling this endpoint from a non-browser application (e.g. mobile app) you must include the session token:  ```js pseudo-code example ... const session = await client.toSession(\"the-session-token\")  console.log(session) ```  Depending on your configuration this endpoint might return a 403 status code if the session has a lower Authenticator Assurance Level (AAL) than is possible for the identity. This can happen if the identity has password + webauthn credentials (which would result in AAL2) but the session has only AAL1. If this error occurs, ask the user to sign in with the second factor or change the configuration.  This endpoint is useful for:  AJAX calls. Remember to send credentials and set up CORS correctly! Reverse proxies and API Gateways Server-side calls - use the `X-Session-Token` header!  This endpoint authenticates users by checking  if the `Cookie` HTTP header was set containing an Ory Kratos Session Cookie; if the `Authorization: bearer <ory-session-token>` HTTP header was set with a valid Ory Kratos Session Token; if the `X-Session-Token` HTTP header was set with a valid Ory Kratos Session Token.  If none of these headers are set or the cooke or token are invalid, the endpoint returns a HTTP 401 status code.  As explained above, this request may fail due to several reasons. The `error.id` can be one of:  `session_inactive`: No active session was found in the request (e.g. no Ory Session Cookie / Ory Session Token). `session_aal2_required`: An active session was found but it does not fulfil the Authenticator Assurance Level, implying that the session must (e.g.) authenticate the second factor.
     * @summary Check Who the Current HTTP Session Belongs To
     * @param {string} [xSessionToken] Set the Session Token when calling from non-browser clients. A session token has a format of &#x60;MP2YWEMeM8MxjkGKpH4dqOQ4Q4DlSPaj&#x60;.
     * @param {string} [cookie] Set the Cookie Header. This is especially useful when calling this endpoint from a server-side application. In that scenario you must include the HTTP Cookie Header which originally was included in the request to your server. An example of a session in the HTTP Cookie Header is: &#x60;ory_kratos_session&#x3D;a19iOVAbdzdgl70Rq1QZmrKmcjDtdsviCTZx7m9a9yHIUS8Wa9T7hvqyGTsLHi6Qifn2WUfpAKx9DWp0SJGleIn9vh2YF4A16id93kXFTgIgmwIOvbVAScyrx7yVl6bPZnCx27ec4WQDtaTewC1CpgudeDV2jQQnSaCP6ny3xa8qLH-QUgYqdQuoA_LF1phxgRCUfIrCLQOkolX5nv3ze_f&#x3D;&#x3D;&#x60;.  It is ok if more than one cookie are included here as all other cookies will be ignored.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    toSession(xSessionToken?: string, cookie?: string, options?: any): AxiosPromise<Session>;
    /**
     * This endpoints allows you to update the Ory Cloud Project configuration for individual services (identity, permission, ...). The configuration is fully compatible with the open source projects for the respective services (e.g. Ory Kratos for Identity, Ory Keto for Permissions).  This endpoint expects the `version` key to be set in the payload. If it is unset, it will try to import the config as if it is from the most recent version.  If you have an older version of a configuration, you should set the version key in the payload!  While this endpoint is able to process all configuration items related to features (e.g. password reset), it does not support operational configuration items (e.g. port, tracing, logging) otherwise available in the open source.  For configuration items that can not be translated to Ory Cloud, this endpoint will return a list of warnings to help you understand which parts of your config could not be processed.  Be aware that updating any service\'s configuration will completely override your current configuration for that service!
     * @summary Update an Ory Cloud Project Configuration
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {UpdateProject} [updateProject]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    updateProject(projectId: string, updateProject?: UpdateProject, options?: any): AxiosPromise<SuccessfulProjectUpdate>;
};
/**
 * V0alpha2Api - interface
 * @export
 * @interface V0alpha2Api
 */
export interface V0alpha2ApiInterface {
    /**
     * This endpoint creates an identity. Learn how identities work in [Ory Kratos\' User And Identity Model Documentation](https://www.ory.sh/docs/next/kratos/concepts/identity-user-model).
     * @summary Create an Identity
     * @param {AdminCreateIdentityBody} [adminCreateIdentityBody]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    adminCreateIdentity(adminCreateIdentityBody?: AdminCreateIdentityBody, options?: AxiosRequestConfig): AxiosPromise<Identity>;
    /**
     * This endpoint creates a recovery link which should be given to the user in order for them to recover (or activate) their account.
     * @summary Create a Recovery Link
     * @param {AdminCreateSelfServiceRecoveryLinkBody} [adminCreateSelfServiceRecoveryLinkBody]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    adminCreateSelfServiceRecoveryLink(adminCreateSelfServiceRecoveryLinkBody?: AdminCreateSelfServiceRecoveryLinkBody, options?: AxiosRequestConfig): AxiosPromise<SelfServiceRecoveryLink>;
    /**
     * Calling this endpoint irrecoverably and permanently deletes the identity given its ID. This action can not be undone. This endpoint returns 204 when the identity was deleted or when the identity was not found, in which case it is assumed that is has been deleted already.  Learn how identities work in [Ory Kratos\' User And Identity Model Documentation](https://www.ory.sh/docs/next/kratos/concepts/identity-user-model).
     * @summary Delete an Identity
     * @param {string} id ID is the identity\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    adminDeleteIdentity(id: string, options?: AxiosRequestConfig): AxiosPromise<void>;
    /**
     * This endpoint is useful for:  To forcefully logout Identity from all devices and sessions
     * @summary Calling this endpoint irrecoverably and permanently deletes and invalidates all sessions that belong to the given Identity.
     * @param {string} id ID is the identity\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    adminDeleteIdentitySessions(id: string, options?: AxiosRequestConfig): AxiosPromise<void>;
    /**
     * Retrieve the session ID from the `/sessions/whoami` endpoint / `toSession` SDK method.
     * @summary Calling this endpoint extends the given session ID. If `session.earliest_possible_extend` is set it will only extend the session after the specified time has passed.
     * @param {string} id ID is the session\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    adminExtendSession(id: string, options?: AxiosRequestConfig): AxiosPromise<Session>;
    /**
     * Learn how identities work in [Ory Kratos\' User And Identity Model Documentation](https://www.ory.sh/docs/next/kratos/concepts/identity-user-model).
     * @summary Get an Identity
     * @param {string} id ID must be set to the ID of identity you want to get
     * @param {Array<string>} [includeCredential] DeclassifyCredentials will declassify one or more identity\&#39;s credentials  Currently, only &#x60;oidc&#x60; is supported. This will return the initial OAuth 2.0 Access, Refresh and (optionally) OpenID Connect ID Token.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    adminGetIdentity(id: string, includeCredential?: Array<string>, options?: AxiosRequestConfig): AxiosPromise<Identity>;
    /**
     * Lists all identities. Does not support search at the moment.  Learn how identities work in [Ory Kratos\' User And Identity Model Documentation](https://www.ory.sh/docs/next/kratos/concepts/identity-user-model).
     * @summary List Identities
     * @param {number} [perPage] Items per Page  This is the number of items per page.
     * @param {number} [page] Pagination Page
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    adminListIdentities(perPage?: number, page?: number, options?: AxiosRequestConfig): AxiosPromise<Array<Identity>>;
    /**
     * This endpoint is useful for:  Listing all sessions that belong to an Identity in an administrative context.
     * @summary This endpoint returns all sessions that belong to the given Identity.
     * @param {string} id ID is the identity\&#39;s ID.
     * @param {number} [perPage] Items per Page  This is the number of items per page.
     * @param {number} [page] Pagination Page
     * @param {boolean} [active] Active is a boolean flag that filters out sessions based on the state. If no value is provided, all sessions are returned.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    adminListIdentitySessions(id: string, perPage?: number, page?: number, active?: boolean, options?: AxiosRequestConfig): AxiosPromise<Array<Session>>;
    /**
     * This endpoint updates an identity. The full identity payload (except credentials) is expected. This endpoint does not support patching.  Learn how identities work in [Ory Kratos\' User And Identity Model Documentation](https://www.ory.sh/docs/next/kratos/concepts/identity-user-model).
     * @summary Update an Identity
     * @param {string} id ID must be set to the ID of identity you want to update
     * @param {AdminUpdateIdentityBody} [adminUpdateIdentityBody]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    adminUpdateIdentity(id: string, adminUpdateIdentityBody?: AdminUpdateIdentityBody, options?: AxiosRequestConfig): AxiosPromise<Identity>;
    /**
     * Creates a new project.
     * @summary Create a Project
     * @param {CreateProjectBody} [createProjectBody]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    createProject(createProjectBody?: CreateProjectBody, options?: AxiosRequestConfig): AxiosPromise<Project>;
    /**
     * This endpoint initializes a browser-based user logout flow and a URL which can be used to log out the user.  This endpoint is NOT INTENDED for API clients and only works with browsers (Chrome, Firefox, ...). For API clients you can call the `/self-service/logout/api` URL directly with the Ory Session Token.  The URL is only valid for the currently signed in user. If no user is signed in, this endpoint returns a 401 error.  When calling this endpoint from a backend, please ensure to properly forward the HTTP cookies.
     * @summary Create a Logout URL for Browsers
     * @param {string} [cookie] HTTP Cookies  If you call this endpoint from a backend, please include the original Cookie header in the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    createSelfServiceLogoutFlowUrlForBrowsers(cookie?: string, options?: AxiosRequestConfig): AxiosPromise<SelfServiceLogoutUrl>;
    /**
     * Get a JSON Schema
     * @param {string} id ID must be set to the ID of schema you want to get
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    getJsonSchema(id: string, options?: AxiosRequestConfig): AxiosPromise<object>;
    /**
     * Get a projects you have access to by its ID.
     * @summary Get a Project
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    getProject(projectId: string, options?: AxiosRequestConfig): AxiosPromise<Project>;
    /**
     * This endpoint requires the user to be a member of the project with the role `OWNER` or `DEVELOPER`.
     * @summary Get all members associated with this project.
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    getProjectMembers(projectId: string, options?: AxiosRequestConfig): AxiosPromise<Array<CloudAccount>>;
    /**
     * This endpoint returns the error associated with a user-facing self service errors.  This endpoint supports stub values to help you implement the error UI:  `?id=stub:500` - returns a stub 500 (Internal Server Error) error.  More information can be found at [Ory Kratos User User Facing Error Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-facing-errors).
     * @summary Get Self-Service Errors
     * @param {string} id Error is the error\&#39;s ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    getSelfServiceError(id: string, options?: AxiosRequestConfig): AxiosPromise<SelfServiceError>;
    /**
     * This endpoint returns a login flow\'s context with, for example, error details and other information.  Browser flows expect the anti-CSRF cookie to be included in the request\'s HTTP Cookie Header. For AJAX requests you must ensure that cookies are included in the request or requests will fail.  If you use the browser-flow for server-side apps, the services need to run on a common top-level-domain and you need to forward the incoming HTTP Cookie header to this endpoint:  ```js pseudo-code example router.get(\'/login\', async function (req, res) { const flow = await client.getSelfServiceLoginFlow(req.header(\'cookie\'), req.query[\'flow\'])  res.render(\'login\', flow) }) ```  This request may fail due to several reasons. The `error.id` can be one of:  `session_already_available`: The user is already signed in. `self_service_flow_expired`: The flow is expired and you should request a new one.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Get Login Flow
     * @param {string} id The Login Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/login?flow&#x3D;abcde&#x60;).
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    getSelfServiceLoginFlow(id: string, cookie?: string, options?: AxiosRequestConfig): AxiosPromise<SelfServiceLoginFlow>;
    /**
     * This endpoint returns a recovery flow\'s context with, for example, error details and other information.  Browser flows expect the anti-CSRF cookie to be included in the request\'s HTTP Cookie Header. For AJAX requests you must ensure that cookies are included in the request or requests will fail.  If you use the browser-flow for server-side apps, the services need to run on a common top-level-domain and you need to forward the incoming HTTP Cookie header to this endpoint:  ```js pseudo-code example router.get(\'/recovery\', async function (req, res) { const flow = await client.getSelfServiceRecoveryFlow(req.header(\'Cookie\'), req.query[\'flow\'])  res.render(\'recovery\', flow) }) ```  More information can be found at [Ory Kratos Account Recovery Documentation](../self-service/flows/account-recovery).
     * @summary Get Recovery Flow
     * @param {string} id The Flow ID  The value for this parameter comes from &#x60;request&#x60; URL Query parameter sent to your application (e.g. &#x60;/recovery?flow&#x3D;abcde&#x60;).
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    getSelfServiceRecoveryFlow(id: string, cookie?: string, options?: AxiosRequestConfig): AxiosPromise<SelfServiceRecoveryFlow>;
    /**
     * This endpoint returns a registration flow\'s context with, for example, error details and other information.  Browser flows expect the anti-CSRF cookie to be included in the request\'s HTTP Cookie Header. For AJAX requests you must ensure that cookies are included in the request or requests will fail.  If you use the browser-flow for server-side apps, the services need to run on a common top-level-domain and you need to forward the incoming HTTP Cookie header to this endpoint:  ```js pseudo-code example router.get(\'/registration\', async function (req, res) { const flow = await client.getSelfServiceRegistrationFlow(req.header(\'cookie\'), req.query[\'flow\'])  res.render(\'registration\', flow) }) ```  This request may fail due to several reasons. The `error.id` can be one of:  `session_already_available`: The user is already signed in. `self_service_flow_expired`: The flow is expired and you should request a new one.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Get Registration Flow
     * @param {string} id The Registration Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/registration?flow&#x3D;abcde&#x60;).
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    getSelfServiceRegistrationFlow(id: string, cookie?: string, options?: AxiosRequestConfig): AxiosPromise<SelfServiceRegistrationFlow>;
    /**
     * When accessing this endpoint through Ory Kratos\' Public API you must ensure that either the Ory Kratos Session Cookie or the Ory Kratos Session Token are set.  Depending on your configuration this endpoint might return a 403 error if the session has a lower Authenticator Assurance Level (AAL) than is possible for the identity. This can happen if the identity has password + webauthn credentials (which would result in AAL2) but the session has only AAL1. If this error occurs, ask the user to sign in with the second factor or change the configuration.  You can access this endpoint without credentials when using Ory Kratos\' Admin API.  If this endpoint is called via an AJAX request, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `session_inactive`: No Ory Session was found - sign in a user first. `security_identity_mismatch`: The flow was interrupted with `session_refresh_required` but apparently some other identity logged in instead.  More information can be found at [Ory Kratos User Settings & Profile Management Documentation](../self-service/flows/user-settings).
     * @summary Get Settings Flow
     * @param {string} id ID is the Settings Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/settings?flow&#x3D;abcde&#x60;).
     * @param {string} [xSessionToken] The Session Token  When using the SDK in an app without a browser, please include the session token here.
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    getSelfServiceSettingsFlow(id: string, xSessionToken?: string, cookie?: string, options?: AxiosRequestConfig): AxiosPromise<SelfServiceSettingsFlow>;
    /**
     * This endpoint returns a verification flow\'s context with, for example, error details and other information.  Browser flows expect the anti-CSRF cookie to be included in the request\'s HTTP Cookie Header. For AJAX requests you must ensure that cookies are included in the request or requests will fail.  If you use the browser-flow for server-side apps, the services need to run on a common top-level-domain and you need to forward the incoming HTTP Cookie header to this endpoint:  ```js pseudo-code example router.get(\'/recovery\', async function (req, res) { const flow = await client.getSelfServiceVerificationFlow(req.header(\'cookie\'), req.query[\'flow\'])  res.render(\'verification\', flow) })  More information can be found at [Ory Kratos Email and Phone Verification Documentation](https://www.ory.sh/docs/kratos/selfservice/flows/verify-email-account-activation).
     * @summary Get Verification Flow
     * @param {string} id The Flow ID  The value for this parameter comes from &#x60;request&#x60; URL Query parameter sent to your application (e.g. &#x60;/verification?flow&#x3D;abcde&#x60;).
     * @param {string} [cookie] HTTP Cookies  When using the SDK on the server side you must include the HTTP Cookie Header originally sent to your HTTP handler here.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    getSelfServiceVerificationFlow(id: string, cookie?: string, options?: AxiosRequestConfig): AxiosPromise<SelfServiceVerificationFlow>;
    /**
     * This endpoint provides JavaScript which is needed in order to perform WebAuthn login and registration.  If you are building a JavaScript Browser App (e.g. in ReactJS or AngularJS) you will need to load this file:  ```html <script src=\"https://public-kratos.example.org/.well-known/ory/webauthn.js\" type=\"script\" async /> ```  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Get WebAuthn JavaScript
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    getWebAuthnJavaScript(options?: AxiosRequestConfig): AxiosPromise<string>;
    /**
     * This endpoint initializes a browser-based user login flow. This endpoint will set the appropriate cookies and anti-CSRF measures required for browser-based flows.  If this endpoint is opened as a link in the browser, it will be redirected to `selfservice.flows.login.ui_url` with the flow ID set as the query parameter `?flow=`. If a valid user session exists already, the browser will be redirected to `urls.default_redirect_url` unless the query parameter `?refresh=true` was set.  If this endpoint is called via an AJAX request, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `session_aal1_required`: Multi-factor auth (e.g. 2fa) was requested but the user has no session yet. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration!  This endpoint is NOT INTENDED for clients that do not have a browser (Chrome, Firefox, ...) as cookies are needed.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Initialize Login Flow for Browsers
     * @param {boolean} [refresh] Refresh a login session  If set to true, this will refresh an existing login session by asking the user to sign in again. This will reset the authenticated_at time of the session.
     * @param {string} [aal] Request a Specific AuthenticationMethod Assurance Level  Use this parameter to upgrade an existing session\&#39;s authenticator assurance level (AAL). This allows you to ask for multi-factor authentication. When an identity sign in using e.g. username+password, the AAL is 1. If you wish to \&quot;upgrade\&quot; the session\&#39;s security by asking the user to perform TOTP / WebAuth/ ... you would set this to \&quot;aal2\&quot;.
     * @param {string} [returnTo] The URL to return the browser to after the flow was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    initializeSelfServiceLoginFlowForBrowsers(refresh?: boolean, aal?: string, returnTo?: string, options?: AxiosRequestConfig): AxiosPromise<SelfServiceLoginFlow>;
    /**
     * This endpoint initiates a login flow for API clients that do not use a browser, such as mobile devices, smart TVs, and so on.  If a valid provided session cookie or session token is provided, a 400 Bad Request error will be returned unless the URL query parameter `?refresh=true` is set.  To fetch an existing login flow call `/self-service/login/flows?flow=<flow_id>`.  You MUST NOT use this endpoint in client-side (Single Page Apps, ReactJS, AngularJS) nor server-side (Java Server Pages, NodeJS, PHP, Golang, ...) browser applications. Using this endpoint in these applications will make you vulnerable to a variety of CSRF attacks, including CSRF login attacks.  In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `session_aal1_required`: Multi-factor auth (e.g. 2fa) was requested but the user has no session yet. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred.  This endpoint MUST ONLY be used in scenarios such as native mobile apps (React Native, Objective C, Swift, Java, ...).  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Initialize Login Flow for APIs, Services, Apps, ...
     * @param {boolean} [refresh] Refresh a login session  If set to true, this will refresh an existing login session by asking the user to sign in again. This will reset the authenticated_at time of the session.
     * @param {string} [aal] Request a Specific AuthenticationMethod Assurance Level  Use this parameter to upgrade an existing session\&#39;s authenticator assurance level (AAL). This allows you to ask for multi-factor authentication. When an identity sign in using e.g. username+password, the AAL is 1. If you wish to \&quot;upgrade\&quot; the session\&#39;s security by asking the user to perform TOTP / WebAuth/ ... you would set this to \&quot;aal2\&quot;.
     * @param {string} [xSessionToken] The Session Token of the Identity performing the settings flow.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    initializeSelfServiceLoginFlowWithoutBrowser(refresh?: boolean, aal?: string, xSessionToken?: string, options?: AxiosRequestConfig): AxiosPromise<SelfServiceLoginFlow>;
    /**
     * This endpoint initializes a browser-based account recovery flow. Once initialized, the browser will be redirected to `selfservice.flows.recovery.ui_url` with the flow ID set as the query parameter `?flow=`. If a valid user session exists, the browser is returned to the configured return URL.  If this endpoint is called via an AJAX request, the response contains the recovery flow without any redirects or a 400 bad request error if the user is already authenticated.  This endpoint is NOT INTENDED for clients that do not have a browser (Chrome, Firefox, ...) as cookies are needed.  More information can be found at [Ory Kratos Account Recovery Documentation](../self-service/flows/account-recovery).
     * @summary Initialize Recovery Flow for Browsers
     * @param {string} [returnTo] The URL to return the browser to after the flow was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    initializeSelfServiceRecoveryFlowForBrowsers(returnTo?: string, options?: AxiosRequestConfig): AxiosPromise<SelfServiceRecoveryFlow>;
    /**
     * This endpoint initiates a recovery flow for API clients such as mobile devices, smart TVs, and so on.  If a valid provided session cookie or session token is provided, a 400 Bad Request error.  To fetch an existing recovery flow call `/self-service/recovery/flows?flow=<flow_id>`.  You MUST NOT use this endpoint in client-side (Single Page Apps, ReactJS, AngularJS) nor server-side (Java Server Pages, NodeJS, PHP, Golang, ...) browser applications. Using this endpoint in these applications will make you vulnerable to a variety of CSRF attacks.  This endpoint MUST ONLY be used in scenarios such as native mobile apps (React Native, Objective C, Swift, Java, ...).   More information can be found at [Ory Kratos Account Recovery Documentation](../self-service/flows/account-recovery).
     * @summary Initialize Recovery Flow for APIs, Services, Apps, ...
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    initializeSelfServiceRecoveryFlowWithoutBrowser(options?: AxiosRequestConfig): AxiosPromise<SelfServiceRecoveryFlow>;
    /**
     * This endpoint initializes a browser-based user registration flow. This endpoint will set the appropriate cookies and anti-CSRF measures required for browser-based flows.  :::info  This endpoint is EXPERIMENTAL and subject to potential breaking changes in the future.  :::  If this endpoint is opened as a link in the browser, it will be redirected to `selfservice.flows.registration.ui_url` with the flow ID set as the query parameter `?flow=`. If a valid user session exists already, the browser will be redirected to `urls.default_redirect_url`.  If this endpoint is called via an AJAX request, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration!  If this endpoint is called via an AJAX request, the response contains the registration flow without a redirect.  This endpoint is NOT INTENDED for clients that do not have a browser (Chrome, Firefox, ...) as cookies are needed.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Initialize Registration Flow for Browsers
     * @param {string} [returnTo] The URL to return the browser to after the flow was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    initializeSelfServiceRegistrationFlowForBrowsers(returnTo?: string, options?: AxiosRequestConfig): AxiosPromise<SelfServiceRegistrationFlow>;
    /**
     * This endpoint initiates a registration flow for API clients such as mobile devices, smart TVs, and so on.  If a valid provided session cookie or session token is provided, a 400 Bad Request error will be returned unless the URL query parameter `?refresh=true` is set.  To fetch an existing registration flow call `/self-service/registration/flows?flow=<flow_id>`.  You MUST NOT use this endpoint in client-side (Single Page Apps, ReactJS, AngularJS) nor server-side (Java Server Pages, NodeJS, PHP, Golang, ...) browser applications. Using this endpoint in these applications will make you vulnerable to a variety of CSRF attacks.  In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred.  This endpoint MUST ONLY be used in scenarios such as native mobile apps (React Native, Objective C, Swift, Java, ...).  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Initialize Registration Flow for APIs, Services, Apps, ...
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    initializeSelfServiceRegistrationFlowWithoutBrowser(options?: AxiosRequestConfig): AxiosPromise<SelfServiceRegistrationFlow>;
    /**
     * This endpoint initializes a browser-based user settings flow. Once initialized, the browser will be redirected to `selfservice.flows.settings.ui_url` with the flow ID set as the query parameter `?flow=`. If no valid Ory Kratos Session Cookie is included in the request, a login flow will be initialized.  If this endpoint is opened as a link in the browser, it will be redirected to `selfservice.flows.settings.ui_url` with the flow ID set as the query parameter `?flow=`. If no valid user session was set, the browser will be redirected to the login endpoint.  If this endpoint is called via an AJAX request, the response contains the settings flow without any redirects or a 401 forbidden error if no valid session was set.  Depending on your configuration this endpoint might return a 403 error if the session has a lower Authenticator Assurance Level (AAL) than is possible for the identity. This can happen if the identity has password + webauthn credentials (which would result in AAL2) but the session has only AAL1. If this error occurs, ask the user to sign in with the second factor (happens automatically for server-side browser flows) or change the configuration.  If this endpoint is called via an AJAX request, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `session_inactive`: No Ory Session was found - sign in a user first. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration!  This endpoint is NOT INTENDED for clients that do not have a browser (Chrome, Firefox, ...) as cookies are needed.  More information can be found at [Ory Kratos User Settings & Profile Management Documentation](../self-service/flows/user-settings).
     * @summary Initialize Settings Flow for Browsers
     * @param {string} [returnTo] The URL to return the browser to after the flow was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    initializeSelfServiceSettingsFlowForBrowsers(returnTo?: string, options?: AxiosRequestConfig): AxiosPromise<SelfServiceSettingsFlow>;
    /**
     * This endpoint initiates a settings flow for API clients such as mobile devices, smart TVs, and so on. You must provide a valid Ory Kratos Session Token for this endpoint to respond with HTTP 200 OK.  To fetch an existing settings flow call `/self-service/settings/flows?flow=<flow_id>`.  You MUST NOT use this endpoint in client-side (Single Page Apps, ReactJS, AngularJS) nor server-side (Java Server Pages, NodeJS, PHP, Golang, ...) browser applications. Using this endpoint in these applications will make you vulnerable to a variety of CSRF attacks.  Depending on your configuration this endpoint might return a 403 error if the session has a lower Authenticator Assurance Level (AAL) than is possible for the identity. This can happen if the identity has password + webauthn credentials (which would result in AAL2) but the session has only AAL1. If this error occurs, ask the user to sign in with the second factor or change the configuration.  In the case of an error, the `error.id` of the JSON response body can be one of:  `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `session_inactive`: No Ory Session was found - sign in a user first.  This endpoint MUST ONLY be used in scenarios such as native mobile apps (React Native, Objective C, Swift, Java, ...).  More information can be found at [Ory Kratos User Settings & Profile Management Documentation](../self-service/flows/user-settings).
     * @summary Initialize Settings Flow for APIs, Services, Apps, ...
     * @param {string} [xSessionToken] The Session Token of the Identity performing the settings flow.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    initializeSelfServiceSettingsFlowWithoutBrowser(xSessionToken?: string, options?: AxiosRequestConfig): AxiosPromise<SelfServiceSettingsFlow>;
    /**
     * This endpoint initializes a browser-based account verification flow. Once initialized, the browser will be redirected to `selfservice.flows.verification.ui_url` with the flow ID set as the query parameter `?flow=`.  If this endpoint is called via an AJAX request, the response contains the recovery flow without any redirects.  This endpoint is NOT INTENDED for API clients and only works with browsers (Chrome, Firefox, ...).  More information can be found at [Ory Kratos Email and Phone Verification Documentation](https://www.ory.sh/docs/kratos/selfservice/flows/verify-email-account-activation).
     * @summary Initialize Verification Flow for Browser Clients
     * @param {string} [returnTo] The URL to return the browser to after the flow was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    initializeSelfServiceVerificationFlowForBrowsers(returnTo?: string, options?: AxiosRequestConfig): AxiosPromise<SelfServiceVerificationFlow>;
    /**
     * This endpoint initiates a verification flow for API clients such as mobile devices, smart TVs, and so on.  To fetch an existing verification flow call `/self-service/verification/flows?flow=<flow_id>`.  You MUST NOT use this endpoint in client-side (Single Page Apps, ReactJS, AngularJS) nor server-side (Java Server Pages, NodeJS, PHP, Golang, ...) browser applications. Using this endpoint in these applications will make you vulnerable to a variety of CSRF attacks.  This endpoint MUST ONLY be used in scenarios such as native mobile apps (React Native, Objective C, Swift, Java, ...).  More information can be found at [Ory Kratos Email and Phone Verification Documentation](https://www.ory.sh/docs/kratos/selfservice/flows/verify-email-account-activation).
     * @summary Initialize Verification Flow for APIs, Services, Apps, ...
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    initializeSelfServiceVerificationFlowWithoutBrowser(options?: AxiosRequestConfig): AxiosPromise<SelfServiceVerificationFlow>;
    /**
     * Get all Identity Schemas
     * @param {number} [perPage] Items per Page  This is the number of items per page.
     * @param {number} [page] Pagination Page
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    listIdentitySchemas(perPage?: number, page?: number, options?: AxiosRequestConfig): AxiosPromise<Array<IdentitySchema>>;
    /**
     * Lists all projects you have access to.
     * @summary List All Projects
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    listProjects(options?: AxiosRequestConfig): AxiosPromise<Array<ProjectMetadata>>;
    /**
     * This endpoint is useful for:  Displaying all other sessions that belong to the logged-in user
     * @summary This endpoints returns all other active sessions that belong to the logged-in user. The current session can be retrieved by calling the `/sessions/whoami` endpoint.
     * @param {string} [xSessionToken] Set the Session Token when calling from non-browser clients. A session token has a format of &#x60;MP2YWEMeM8MxjkGKpH4dqOQ4Q4DlSPaj&#x60;.
     * @param {string} [cookie] Set the Cookie Header. This is especially useful when calling this endpoint from a server-side application. In that scenario you must include the HTTP Cookie Header which originally was included in the request to your server. An example of a session in the HTTP Cookie Header is: &#x60;ory_kratos_session&#x3D;a19iOVAbdzdgl70Rq1QZmrKmcjDtdsviCTZx7m9a9yHIUS8Wa9T7hvqyGTsLHi6Qifn2WUfpAKx9DWp0SJGleIn9vh2YF4A16id93kXFTgIgmwIOvbVAScyrx7yVl6bPZnCx27ec4WQDtaTewC1CpgudeDV2jQQnSaCP6ny3xa8qLH-QUgYqdQuoA_LF1phxgRCUfIrCLQOkolX5nv3ze_f&#x3D;&#x3D;&#x60;.  It is ok if more than one cookie are included here as all other cookies will be ignored.
     * @param {number} [perPage] Items per Page  This is the number of items per page.
     * @param {number} [page] Pagination Page
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    listSessions(xSessionToken?: string, cookie?: string, perPage?: number, page?: number, options?: AxiosRequestConfig): AxiosPromise<Array<Session>>;
    /**
     * This endpoints allows you to patch individual Ory Cloud Project configuration keys for Ory\'s services (identity, permission, ...). The configuration format is fully compatible with the open source projects for the respective services (e.g. Ory Kratos for Identity, Ory Keto for Permissions).  This endpoint expects the `version` key to be set in the payload. If it is unset, it will try to import the config as if it is from the most recent version.  If you have an older version of a configuration, you should set the version key in the payload!  While this endpoint is able to process all configuration items related to features (e.g. password reset), it does not support operational configuration items (e.g. port, tracing, logging) otherwise available in the open source.  For configuration items that can not be translated to Ory Cloud, this endpoint will return a list of warnings to help you understand which parts of your config could not be processed.
     * @summary Patch an Ory Cloud Project Configuration
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {Array<JsonPatch>} [jsonPatch]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    patchProject(projectId: string, jsonPatch?: Array<JsonPatch>, options?: AxiosRequestConfig): AxiosPromise<SuccessfulProjectUpdate>;
    /**
     * !! Use with extreme caution !!  Using this API endpoint you can purge (completely delete) a project and its data. This action can not be undone and will delete ALL your data.  !! Use with extreme caution !!
     * @summary Irrecoverably Purge a Project
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    purgeProject(projectId: string, options?: AxiosRequestConfig): AxiosPromise<void>;
    /**
     * This endpoint requires the user to be a member of the project with the role `OWNER`.
     * @summary Remove a member associated with this project. This also sets their invite status to `REMOVED`.
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {string} memberId Member ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    removeProjectMember(projectId: string, memberId: string, options?: AxiosRequestConfig): AxiosPromise<void>;
    /**
     * This endpoint is useful for:  To forcefully logout the current user from another device or session
     * @summary Calling this endpoint invalidates the specified session. The current session cannot be revoked. Session data are not deleted.
     * @param {string} id ID is the session\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    revokeSession(id: string, options?: AxiosRequestConfig): AxiosPromise<void>;
    /**
     * This endpoint is useful for:  To forcefully logout the current user from all other devices and sessions
     * @summary Calling this endpoint invalidates all except the current session that belong to the logged-in user. Session data are not deleted.
     * @param {string} [xSessionToken] Set the Session Token when calling from non-browser clients. A session token has a format of &#x60;MP2YWEMeM8MxjkGKpH4dqOQ4Q4DlSPaj&#x60;.
     * @param {string} [cookie] Set the Cookie Header. This is especially useful when calling this endpoint from a server-side application. In that scenario you must include the HTTP Cookie Header which originally was included in the request to your server. An example of a session in the HTTP Cookie Header is: &#x60;ory_kratos_session&#x3D;a19iOVAbdzdgl70Rq1QZmrKmcjDtdsviCTZx7m9a9yHIUS8Wa9T7hvqyGTsLHi6Qifn2WUfpAKx9DWp0SJGleIn9vh2YF4A16id93kXFTgIgmwIOvbVAScyrx7yVl6bPZnCx27ec4WQDtaTewC1CpgudeDV2jQQnSaCP6ny3xa8qLH-QUgYqdQuoA_LF1phxgRCUfIrCLQOkolX5nv3ze_f&#x3D;&#x3D;&#x60;.  It is ok if more than one cookie are included here as all other cookies will be ignored.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    revokeSessions(xSessionToken?: string, cookie?: string, options?: AxiosRequestConfig): AxiosPromise<RevokedSessions>;
    /**
     * :::info  This endpoint is EXPERIMENTAL and subject to potential breaking changes in the future.  :::  Use this endpoint to complete a login flow. This endpoint behaves differently for API and browser flows.  API flows expect `application/json` to be sent in the body and responds with HTTP 200 and a application/json body with the session token on success; HTTP 410 if the original flow expired with the appropriate error messages set and optionally a `use_flow_id` parameter in the body; HTTP 400 on form validation errors.  Browser flows expect a Content-Type of `application/x-www-form-urlencoded` or `application/json` to be sent in the body and respond with a HTTP 303 redirect to the post/after login URL or the `return_to` value if it was set and if the login succeeded; a HTTP 303 redirect to the login UI URL with the flow ID containing the validation errors otherwise.  Browser flows with an accept header of `application/json` will not redirect but instead respond with HTTP 200 and a application/json body with the signed in identity and a `Set-Cookie` header on success; HTTP 303 redirect to a fresh login flow if the original flow expired with the appropriate error messages set; HTTP 400 on form validation errors.  If this endpoint is called with `Accept: application/json` in the header, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration! `browser_location_change_required`: Usually sent when an AJAX request indicates that the browser needs to open a specific URL. Most likely used in Social Sign In flows.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Submit a Login Flow
     * @param {string} flow The Login Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/login?flow&#x3D;abcde&#x60;).
     * @param {SubmitSelfServiceLoginFlowBody} submitSelfServiceLoginFlowBody
     * @param {string} [xSessionToken] The Session Token of the Identity performing the settings flow.
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    submitSelfServiceLoginFlow(flow: string, submitSelfServiceLoginFlowBody: SubmitSelfServiceLoginFlowBody, xSessionToken?: string, cookie?: string, options?: AxiosRequestConfig): AxiosPromise<SuccessfulSelfServiceLoginWithoutBrowser>;
    /**
     * This endpoint logs out an identity in a self-service manner.  If the `Accept` HTTP header is not set to `application/json`, the browser will be redirected (HTTP 303 See Other) to the `return_to` parameter of the initial request or fall back to `urls.default_return_to`.  If the `Accept` HTTP header is set to `application/json`, a 204 No Content response will be sent on successful logout instead.  This endpoint is NOT INTENDED for API clients and only works with browsers (Chrome, Firefox, ...). For API clients you can call the `/self-service/logout/api` URL directly with the Ory Session Token.  More information can be found at [Ory Kratos User Logout Documentation](https://www.ory.sh/docs/next/kratos/self-service/flows/user-logout).
     * @summary Complete Self-Service Logout
     * @param {string} [token] A Valid Logout Token  If you do not have a logout token because you only have a session cookie, call &#x60;/self-service/logout/urls&#x60; to generate a URL for this endpoint.
     * @param {string} [returnTo] The URL to return to after the logout was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    submitSelfServiceLogoutFlow(token?: string, returnTo?: string, options?: AxiosRequestConfig): AxiosPromise<void>;
    /**
     * Use this endpoint to log out an identity using an Ory Session Token. If the Ory Session Token was successfully revoked, the server returns a 204 No Content response. A 204 No Content response is also sent when the Ory Session Token has been revoked already before.  If the Ory Session Token is malformed or does not exist a 403 Forbidden response will be returned.  This endpoint does not remove any HTTP Cookies - use the Browser-Based Self-Service Logout Flow instead.
     * @summary Perform Logout for APIs, Services, Apps, ...
     * @param {SubmitSelfServiceLogoutFlowWithoutBrowserBody} submitSelfServiceLogoutFlowWithoutBrowserBody
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    submitSelfServiceLogoutFlowWithoutBrowser(submitSelfServiceLogoutFlowWithoutBrowserBody: SubmitSelfServiceLogoutFlowWithoutBrowserBody, options?: AxiosRequestConfig): AxiosPromise<void>;
    /**
     * Use this endpoint to complete a recovery flow. This endpoint behaves differently for API and browser flows and has several states:  `choose_method` expects `flow` (in the URL query) and `email` (in the body) to be sent and works with API- and Browser-initiated flows. For API clients and Browser clients with HTTP Header `Accept: application/json` it either returns a HTTP 200 OK when the form is valid and HTTP 400 OK when the form is invalid. and a HTTP 303 See Other redirect with a fresh recovery flow if the flow was otherwise invalid (e.g. expired). For Browser clients without HTTP Header `Accept` or with `Accept: text/_*` it returns a HTTP 303 See Other redirect to the Recovery UI URL with the Recovery Flow ID appended. `sent_email` is the success state after `choose_method` for the `link` method and allows the user to request another recovery email. It works for both API and Browser-initiated flows and returns the same responses as the flow in `choose_method` state. `passed_challenge` expects a `token` to be sent in the URL query and given the nature of the flow (\"sending a recovery link\") does not have any API capabilities. The server responds with a HTTP 303 See Other redirect either to the Settings UI URL (if the link was valid) and instructs the user to update their password, or a redirect to the Recover UI URL with a new Recovery Flow ID which contains an error message that the recovery link was invalid.  More information can be found at [Ory Kratos Account Recovery Documentation](../self-service/flows/account-recovery).
     * @summary Complete Recovery Flow
     * @param {string} flow The Recovery Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/recovery?flow&#x3D;abcde&#x60;).
     * @param {SubmitSelfServiceRecoveryFlowBody} submitSelfServiceRecoveryFlowBody
     * @param {string} [token] Recovery Token  The recovery token which completes the recovery request. If the token is invalid (e.g. expired) an error will be shown to the end-user.  This parameter is usually set in a link and not used by any direct API call.
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    submitSelfServiceRecoveryFlow(flow: string, submitSelfServiceRecoveryFlowBody: SubmitSelfServiceRecoveryFlowBody, token?: string, cookie?: string, options?: AxiosRequestConfig): AxiosPromise<SelfServiceRecoveryFlow>;
    /**
     * Use this endpoint to complete a registration flow by sending an identity\'s traits and password. This endpoint behaves differently for API and browser flows.  API flows expect `application/json` to be sent in the body and respond with HTTP 200 and a application/json body with the created identity success - if the session hook is configured the `session` and `session_token` will also be included; HTTP 410 if the original flow expired with the appropriate error messages set and optionally a `use_flow_id` parameter in the body; HTTP 400 on form validation errors.  Browser flows expect a Content-Type of `application/x-www-form-urlencoded` or `application/json` to be sent in the body and respond with a HTTP 303 redirect to the post/after registration URL or the `return_to` value if it was set and if the registration succeeded; a HTTP 303 redirect to the registration UI URL with the flow ID containing the validation errors otherwise.  Browser flows with an accept header of `application/json` will not redirect but instead respond with HTTP 200 and a application/json body with the signed in identity and a `Set-Cookie` header on success; HTTP 303 redirect to a fresh login flow if the original flow expired with the appropriate error messages set; HTTP 400 on form validation errors.  If this endpoint is called with `Accept: application/json` in the header, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration! `browser_location_change_required`: Usually sent when an AJAX request indicates that the browser needs to open a specific URL. Most likely used in Social Sign In flows.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Submit a Registration Flow
     * @param {string} flow The Registration Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/registration?flow&#x3D;abcde&#x60;).
     * @param {SubmitSelfServiceRegistrationFlowBody} submitSelfServiceRegistrationFlowBody
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    submitSelfServiceRegistrationFlow(flow: string, submitSelfServiceRegistrationFlowBody: SubmitSelfServiceRegistrationFlowBody, cookie?: string, options?: AxiosRequestConfig): AxiosPromise<SuccessfulSelfServiceRegistrationWithoutBrowser>;
    /**
     * Use this endpoint to complete a settings flow by sending an identity\'s updated password. This endpoint behaves differently for API and browser flows.  API-initiated flows expect `application/json` to be sent in the body and respond with HTTP 200 and an application/json body with the session token on success; HTTP 303 redirect to a fresh settings flow if the original flow expired with the appropriate error messages set; HTTP 400 on form validation errors. HTTP 401 when the endpoint is called without a valid session token. HTTP 403 when `selfservice.flows.settings.privileged_session_max_age` was reached or the session\'s AAL is too low. Implies that the user needs to re-authenticate.  Browser flows without HTTP Header `Accept` or with `Accept: text/_*` respond with a HTTP 303 redirect to the post/after settings URL or the `return_to` value if it was set and if the flow succeeded; a HTTP 303 redirect to the Settings UI URL with the flow ID containing the validation errors otherwise. a HTTP 303 redirect to the login endpoint when `selfservice.flows.settings.privileged_session_max_age` was reached or the session\'s AAL is too low.  Browser flows with HTTP Header `Accept: application/json` respond with HTTP 200 and a application/json body with the signed in identity and a `Set-Cookie` header on success; HTTP 303 redirect to a fresh login flow if the original flow expired with the appropriate error messages set; HTTP 401 when the endpoint is called without a valid session cookie. HTTP 403 when the page is accessed without a session cookie or the session\'s AAL is too low. HTTP 400 on form validation errors.  Depending on your configuration this endpoint might return a 403 error if the session has a lower Authenticator Assurance Level (AAL) than is possible for the identity. This can happen if the identity has password + webauthn credentials (which would result in AAL2) but the session has only AAL1. If this error occurs, ask the user to sign in with the second factor (happens automatically for server-side browser flows) or change the configuration.  If this endpoint is called with a `Accept: application/json` HTTP header, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `session_refresh_required`: The identity requested to change something that needs a privileged session. Redirect the identity to the login init endpoint with query parameters `?refresh=true&return_to=<the-current-browser-url>`, or initiate a refresh login flow otherwise. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `session_inactive`: No Ory Session was found - sign in a user first. `security_identity_mismatch`: The flow was interrupted with `session_refresh_required` but apparently some other identity logged in instead. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration! `browser_location_change_required`: Usually sent when an AJAX request indicates that the browser needs to open a specific URL. Most likely used in Social Sign In flows.  More information can be found at [Ory Kratos User Settings & Profile Management Documentation](../self-service/flows/user-settings).
     * @summary Complete Settings Flow
     * @param {string} flow The Settings Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/settings?flow&#x3D;abcde&#x60;).
     * @param {SubmitSelfServiceSettingsFlowBody} submitSelfServiceSettingsFlowBody
     * @param {string} [xSessionToken] The Session Token of the Identity performing the settings flow.
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    submitSelfServiceSettingsFlow(flow: string, submitSelfServiceSettingsFlowBody: SubmitSelfServiceSettingsFlowBody, xSessionToken?: string, cookie?: string, options?: AxiosRequestConfig): AxiosPromise<SelfServiceSettingsFlow>;
    /**
     * Use this endpoint to complete a verification flow. This endpoint behaves differently for API and browser flows and has several states:  `choose_method` expects `flow` (in the URL query) and `email` (in the body) to be sent and works with API- and Browser-initiated flows. For API clients and Browser clients with HTTP Header `Accept: application/json` it either returns a HTTP 200 OK when the form is valid and HTTP 400 OK when the form is invalid and a HTTP 303 See Other redirect with a fresh verification flow if the flow was otherwise invalid (e.g. expired). For Browser clients without HTTP Header `Accept` or with `Accept: text/_*` it returns a HTTP 303 See Other redirect to the Verification UI URL with the Verification Flow ID appended. `sent_email` is the success state after `choose_method` when using the `link` method and allows the user to request another verification email. It works for both API and Browser-initiated flows and returns the same responses as the flow in `choose_method` state. `passed_challenge` expects a `token` to be sent in the URL query and given the nature of the flow (\"sending a verification link\") does not have any API capabilities. The server responds with a HTTP 303 See Other redirect either to the Settings UI URL (if the link was valid) and instructs the user to update their password, or a redirect to the Verification UI URL with a new Verification Flow ID which contains an error message that the verification link was invalid.  More information can be found at [Ory Kratos Email and Phone Verification Documentation](https://www.ory.sh/docs/kratos/selfservice/flows/verify-email-account-activation).
     * @summary Complete Verification Flow
     * @param {string} flow The Verification Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/verification?flow&#x3D;abcde&#x60;).
     * @param {SubmitSelfServiceVerificationFlowBody} submitSelfServiceVerificationFlowBody
     * @param {string} [token] Verification Token  The verification token which completes the verification request. If the token is invalid (e.g. expired) an error will be shown to the end-user.  This parameter is usually set in a link and not used by any direct API call.
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    submitSelfServiceVerificationFlow(flow: string, submitSelfServiceVerificationFlowBody: SubmitSelfServiceVerificationFlowBody, token?: string, cookie?: string, options?: AxiosRequestConfig): AxiosPromise<SelfServiceVerificationFlow>;
    /**
     * Uses the HTTP Headers in the GET request to determine (e.g. by using checking the cookies) who is authenticated. Returns a session object in the body or 401 if the credentials are invalid or no credentials were sent. Additionally when the request it successful it adds the user ID to the \'X-Kratos-Authenticated-Identity-Id\' header in the response.  If you call this endpoint from a server-side application, you must forward the HTTP Cookie Header to this endpoint:  ```js pseudo-code example router.get(\'/protected-endpoint\', async function (req, res) { const session = await client.toSession(undefined, req.header(\'cookie\'))  console.log(session) }) ```  When calling this endpoint from a non-browser application (e.g. mobile app) you must include the session token:  ```js pseudo-code example ... const session = await client.toSession(\"the-session-token\")  console.log(session) ```  Depending on your configuration this endpoint might return a 403 status code if the session has a lower Authenticator Assurance Level (AAL) than is possible for the identity. This can happen if the identity has password + webauthn credentials (which would result in AAL2) but the session has only AAL1. If this error occurs, ask the user to sign in with the second factor or change the configuration.  This endpoint is useful for:  AJAX calls. Remember to send credentials and set up CORS correctly! Reverse proxies and API Gateways Server-side calls - use the `X-Session-Token` header!  This endpoint authenticates users by checking  if the `Cookie` HTTP header was set containing an Ory Kratos Session Cookie; if the `Authorization: bearer <ory-session-token>` HTTP header was set with a valid Ory Kratos Session Token; if the `X-Session-Token` HTTP header was set with a valid Ory Kratos Session Token.  If none of these headers are set or the cooke or token are invalid, the endpoint returns a HTTP 401 status code.  As explained above, this request may fail due to several reasons. The `error.id` can be one of:  `session_inactive`: No active session was found in the request (e.g. no Ory Session Cookie / Ory Session Token). `session_aal2_required`: An active session was found but it does not fulfil the Authenticator Assurance Level, implying that the session must (e.g.) authenticate the second factor.
     * @summary Check Who the Current HTTP Session Belongs To
     * @param {string} [xSessionToken] Set the Session Token when calling from non-browser clients. A session token has a format of &#x60;MP2YWEMeM8MxjkGKpH4dqOQ4Q4DlSPaj&#x60;.
     * @param {string} [cookie] Set the Cookie Header. This is especially useful when calling this endpoint from a server-side application. In that scenario you must include the HTTP Cookie Header which originally was included in the request to your server. An example of a session in the HTTP Cookie Header is: &#x60;ory_kratos_session&#x3D;a19iOVAbdzdgl70Rq1QZmrKmcjDtdsviCTZx7m9a9yHIUS8Wa9T7hvqyGTsLHi6Qifn2WUfpAKx9DWp0SJGleIn9vh2YF4A16id93kXFTgIgmwIOvbVAScyrx7yVl6bPZnCx27ec4WQDtaTewC1CpgudeDV2jQQnSaCP6ny3xa8qLH-QUgYqdQuoA_LF1phxgRCUfIrCLQOkolX5nv3ze_f&#x3D;&#x3D;&#x60;.  It is ok if more than one cookie are included here as all other cookies will be ignored.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    toSession(xSessionToken?: string, cookie?: string, options?: AxiosRequestConfig): AxiosPromise<Session>;
    /**
     * This endpoints allows you to update the Ory Cloud Project configuration for individual services (identity, permission, ...). The configuration is fully compatible with the open source projects for the respective services (e.g. Ory Kratos for Identity, Ory Keto for Permissions).  This endpoint expects the `version` key to be set in the payload. If it is unset, it will try to import the config as if it is from the most recent version.  If you have an older version of a configuration, you should set the version key in the payload!  While this endpoint is able to process all configuration items related to features (e.g. password reset), it does not support operational configuration items (e.g. port, tracing, logging) otherwise available in the open source.  For configuration items that can not be translated to Ory Cloud, this endpoint will return a list of warnings to help you understand which parts of your config could not be processed.  Be aware that updating any service\'s configuration will completely override your current configuration for that service!
     * @summary Update an Ory Cloud Project Configuration
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {UpdateProject} [updateProject]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2ApiInterface
     */
    updateProject(projectId: string, updateProject?: UpdateProject, options?: AxiosRequestConfig): AxiosPromise<SuccessfulProjectUpdate>;
}
/**
 * V0alpha2Api - object-oriented interface
 * @export
 * @class V0alpha2Api
 * @extends {BaseAPI}
 */
export declare class V0alpha2Api extends BaseAPI implements V0alpha2ApiInterface {
    /**
     * This endpoint creates an identity. Learn how identities work in [Ory Kratos\' User And Identity Model Documentation](https://www.ory.sh/docs/next/kratos/concepts/identity-user-model).
     * @summary Create an Identity
     * @param {AdminCreateIdentityBody} [adminCreateIdentityBody]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    adminCreateIdentity(adminCreateIdentityBody?: AdminCreateIdentityBody, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<Identity>>;
    /**
     * This endpoint creates a recovery link which should be given to the user in order for them to recover (or activate) their account.
     * @summary Create a Recovery Link
     * @param {AdminCreateSelfServiceRecoveryLinkBody} [adminCreateSelfServiceRecoveryLinkBody]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    adminCreateSelfServiceRecoveryLink(adminCreateSelfServiceRecoveryLinkBody?: AdminCreateSelfServiceRecoveryLinkBody, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SelfServiceRecoveryLink>>;
    /**
     * Calling this endpoint irrecoverably and permanently deletes the identity given its ID. This action can not be undone. This endpoint returns 204 when the identity was deleted or when the identity was not found, in which case it is assumed that is has been deleted already.  Learn how identities work in [Ory Kratos\' User And Identity Model Documentation](https://www.ory.sh/docs/next/kratos/concepts/identity-user-model).
     * @summary Delete an Identity
     * @param {string} id ID is the identity\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    adminDeleteIdentity(id: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<void>>;
    /**
     * This endpoint is useful for:  To forcefully logout Identity from all devices and sessions
     * @summary Calling this endpoint irrecoverably and permanently deletes and invalidates all sessions that belong to the given Identity.
     * @param {string} id ID is the identity\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    adminDeleteIdentitySessions(id: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<void>>;
    /**
     * Retrieve the session ID from the `/sessions/whoami` endpoint / `toSession` SDK method.
     * @summary Calling this endpoint extends the given session ID. If `session.earliest_possible_extend` is set it will only extend the session after the specified time has passed.
     * @param {string} id ID is the session\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    adminExtendSession(id: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<Session>>;
    /**
     * Learn how identities work in [Ory Kratos\' User And Identity Model Documentation](https://www.ory.sh/docs/next/kratos/concepts/identity-user-model).
     * @summary Get an Identity
     * @param {string} id ID must be set to the ID of identity you want to get
     * @param {Array<string>} [includeCredential] DeclassifyCredentials will declassify one or more identity\&#39;s credentials  Currently, only &#x60;oidc&#x60; is supported. This will return the initial OAuth 2.0 Access, Refresh and (optionally) OpenID Connect ID Token.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    adminGetIdentity(id: string, includeCredential?: Array<string>, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<Identity>>;
    /**
     * Lists all identities. Does not support search at the moment.  Learn how identities work in [Ory Kratos\' User And Identity Model Documentation](https://www.ory.sh/docs/next/kratos/concepts/identity-user-model).
     * @summary List Identities
     * @param {number} [perPage] Items per Page  This is the number of items per page.
     * @param {number} [page] Pagination Page
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    adminListIdentities(perPage?: number, page?: number, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<Identity[]>>;
    /**
     * This endpoint is useful for:  Listing all sessions that belong to an Identity in an administrative context.
     * @summary This endpoint returns all sessions that belong to the given Identity.
     * @param {string} id ID is the identity\&#39;s ID.
     * @param {number} [perPage] Items per Page  This is the number of items per page.
     * @param {number} [page] Pagination Page
     * @param {boolean} [active] Active is a boolean flag that filters out sessions based on the state. If no value is provided, all sessions are returned.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    adminListIdentitySessions(id: string, perPage?: number, page?: number, active?: boolean, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<Session[]>>;
    /**
     * This endpoint updates an identity. The full identity payload (except credentials) is expected. This endpoint does not support patching.  Learn how identities work in [Ory Kratos\' User And Identity Model Documentation](https://www.ory.sh/docs/next/kratos/concepts/identity-user-model).
     * @summary Update an Identity
     * @param {string} id ID must be set to the ID of identity you want to update
     * @param {AdminUpdateIdentityBody} [adminUpdateIdentityBody]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    adminUpdateIdentity(id: string, adminUpdateIdentityBody?: AdminUpdateIdentityBody, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<Identity>>;
    /**
     * Creates a new project.
     * @summary Create a Project
     * @param {CreateProjectBody} [createProjectBody]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    createProject(createProjectBody?: CreateProjectBody, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<Project>>;
    /**
     * This endpoint initializes a browser-based user logout flow and a URL which can be used to log out the user.  This endpoint is NOT INTENDED for API clients and only works with browsers (Chrome, Firefox, ...). For API clients you can call the `/self-service/logout/api` URL directly with the Ory Session Token.  The URL is only valid for the currently signed in user. If no user is signed in, this endpoint returns a 401 error.  When calling this endpoint from a backend, please ensure to properly forward the HTTP cookies.
     * @summary Create a Logout URL for Browsers
     * @param {string} [cookie] HTTP Cookies  If you call this endpoint from a backend, please include the original Cookie header in the request.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    createSelfServiceLogoutFlowUrlForBrowsers(cookie?: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SelfServiceLogoutUrl>>;
    /**
     * Get a JSON Schema
     * @param {string} id ID must be set to the ID of schema you want to get
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    getJsonSchema(id: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<object>>;
    /**
     * Get a projects you have access to by its ID.
     * @summary Get a Project
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    getProject(projectId: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<Project>>;
    /**
     * This endpoint requires the user to be a member of the project with the role `OWNER` or `DEVELOPER`.
     * @summary Get all members associated with this project.
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    getProjectMembers(projectId: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<CloudAccount[]>>;
    /**
     * This endpoint returns the error associated with a user-facing self service errors.  This endpoint supports stub values to help you implement the error UI:  `?id=stub:500` - returns a stub 500 (Internal Server Error) error.  More information can be found at [Ory Kratos User User Facing Error Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-facing-errors).
     * @summary Get Self-Service Errors
     * @param {string} id Error is the error\&#39;s ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    getSelfServiceError(id: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SelfServiceError>>;
    /**
     * This endpoint returns a login flow\'s context with, for example, error details and other information.  Browser flows expect the anti-CSRF cookie to be included in the request\'s HTTP Cookie Header. For AJAX requests you must ensure that cookies are included in the request or requests will fail.  If you use the browser-flow for server-side apps, the services need to run on a common top-level-domain and you need to forward the incoming HTTP Cookie header to this endpoint:  ```js pseudo-code example router.get(\'/login\', async function (req, res) { const flow = await client.getSelfServiceLoginFlow(req.header(\'cookie\'), req.query[\'flow\'])  res.render(\'login\', flow) }) ```  This request may fail due to several reasons. The `error.id` can be one of:  `session_already_available`: The user is already signed in. `self_service_flow_expired`: The flow is expired and you should request a new one.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Get Login Flow
     * @param {string} id The Login Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/login?flow&#x3D;abcde&#x60;).
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    getSelfServiceLoginFlow(id: string, cookie?: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SelfServiceLoginFlow>>;
    /**
     * This endpoint returns a recovery flow\'s context with, for example, error details and other information.  Browser flows expect the anti-CSRF cookie to be included in the request\'s HTTP Cookie Header. For AJAX requests you must ensure that cookies are included in the request or requests will fail.  If you use the browser-flow for server-side apps, the services need to run on a common top-level-domain and you need to forward the incoming HTTP Cookie header to this endpoint:  ```js pseudo-code example router.get(\'/recovery\', async function (req, res) { const flow = await client.getSelfServiceRecoveryFlow(req.header(\'Cookie\'), req.query[\'flow\'])  res.render(\'recovery\', flow) }) ```  More information can be found at [Ory Kratos Account Recovery Documentation](../self-service/flows/account-recovery).
     * @summary Get Recovery Flow
     * @param {string} id The Flow ID  The value for this parameter comes from &#x60;request&#x60; URL Query parameter sent to your application (e.g. &#x60;/recovery?flow&#x3D;abcde&#x60;).
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    getSelfServiceRecoveryFlow(id: string, cookie?: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SelfServiceRecoveryFlow>>;
    /**
     * This endpoint returns a registration flow\'s context with, for example, error details and other information.  Browser flows expect the anti-CSRF cookie to be included in the request\'s HTTP Cookie Header. For AJAX requests you must ensure that cookies are included in the request or requests will fail.  If you use the browser-flow for server-side apps, the services need to run on a common top-level-domain and you need to forward the incoming HTTP Cookie header to this endpoint:  ```js pseudo-code example router.get(\'/registration\', async function (req, res) { const flow = await client.getSelfServiceRegistrationFlow(req.header(\'cookie\'), req.query[\'flow\'])  res.render(\'registration\', flow) }) ```  This request may fail due to several reasons. The `error.id` can be one of:  `session_already_available`: The user is already signed in. `self_service_flow_expired`: The flow is expired and you should request a new one.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Get Registration Flow
     * @param {string} id The Registration Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/registration?flow&#x3D;abcde&#x60;).
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    getSelfServiceRegistrationFlow(id: string, cookie?: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SelfServiceRegistrationFlow>>;
    /**
     * When accessing this endpoint through Ory Kratos\' Public API you must ensure that either the Ory Kratos Session Cookie or the Ory Kratos Session Token are set.  Depending on your configuration this endpoint might return a 403 error if the session has a lower Authenticator Assurance Level (AAL) than is possible for the identity. This can happen if the identity has password + webauthn credentials (which would result in AAL2) but the session has only AAL1. If this error occurs, ask the user to sign in with the second factor or change the configuration.  You can access this endpoint without credentials when using Ory Kratos\' Admin API.  If this endpoint is called via an AJAX request, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `session_inactive`: No Ory Session was found - sign in a user first. `security_identity_mismatch`: The flow was interrupted with `session_refresh_required` but apparently some other identity logged in instead.  More information can be found at [Ory Kratos User Settings & Profile Management Documentation](../self-service/flows/user-settings).
     * @summary Get Settings Flow
     * @param {string} id ID is the Settings Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/settings?flow&#x3D;abcde&#x60;).
     * @param {string} [xSessionToken] The Session Token  When using the SDK in an app without a browser, please include the session token here.
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    getSelfServiceSettingsFlow(id: string, xSessionToken?: string, cookie?: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SelfServiceSettingsFlow>>;
    /**
     * This endpoint returns a verification flow\'s context with, for example, error details and other information.  Browser flows expect the anti-CSRF cookie to be included in the request\'s HTTP Cookie Header. For AJAX requests you must ensure that cookies are included in the request or requests will fail.  If you use the browser-flow for server-side apps, the services need to run on a common top-level-domain and you need to forward the incoming HTTP Cookie header to this endpoint:  ```js pseudo-code example router.get(\'/recovery\', async function (req, res) { const flow = await client.getSelfServiceVerificationFlow(req.header(\'cookie\'), req.query[\'flow\'])  res.render(\'verification\', flow) })  More information can be found at [Ory Kratos Email and Phone Verification Documentation](https://www.ory.sh/docs/kratos/selfservice/flows/verify-email-account-activation).
     * @summary Get Verification Flow
     * @param {string} id The Flow ID  The value for this parameter comes from &#x60;request&#x60; URL Query parameter sent to your application (e.g. &#x60;/verification?flow&#x3D;abcde&#x60;).
     * @param {string} [cookie] HTTP Cookies  When using the SDK on the server side you must include the HTTP Cookie Header originally sent to your HTTP handler here.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    getSelfServiceVerificationFlow(id: string, cookie?: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SelfServiceVerificationFlow>>;
    /**
     * This endpoint provides JavaScript which is needed in order to perform WebAuthn login and registration.  If you are building a JavaScript Browser App (e.g. in ReactJS or AngularJS) you will need to load this file:  ```html <script src=\"https://public-kratos.example.org/.well-known/ory/webauthn.js\" type=\"script\" async /> ```  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Get WebAuthn JavaScript
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    getWebAuthnJavaScript(options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<string>>;
    /**
     * This endpoint initializes a browser-based user login flow. This endpoint will set the appropriate cookies and anti-CSRF measures required for browser-based flows.  If this endpoint is opened as a link in the browser, it will be redirected to `selfservice.flows.login.ui_url` with the flow ID set as the query parameter `?flow=`. If a valid user session exists already, the browser will be redirected to `urls.default_redirect_url` unless the query parameter `?refresh=true` was set.  If this endpoint is called via an AJAX request, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `session_aal1_required`: Multi-factor auth (e.g. 2fa) was requested but the user has no session yet. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration!  This endpoint is NOT INTENDED for clients that do not have a browser (Chrome, Firefox, ...) as cookies are needed.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Initialize Login Flow for Browsers
     * @param {boolean} [refresh] Refresh a login session  If set to true, this will refresh an existing login session by asking the user to sign in again. This will reset the authenticated_at time of the session.
     * @param {string} [aal] Request a Specific AuthenticationMethod Assurance Level  Use this parameter to upgrade an existing session\&#39;s authenticator assurance level (AAL). This allows you to ask for multi-factor authentication. When an identity sign in using e.g. username+password, the AAL is 1. If you wish to \&quot;upgrade\&quot; the session\&#39;s security by asking the user to perform TOTP / WebAuth/ ... you would set this to \&quot;aal2\&quot;.
     * @param {string} [returnTo] The URL to return the browser to after the flow was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    initializeSelfServiceLoginFlowForBrowsers(refresh?: boolean, aal?: string, returnTo?: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SelfServiceLoginFlow>>;
    /**
     * This endpoint initiates a login flow for API clients that do not use a browser, such as mobile devices, smart TVs, and so on.  If a valid provided session cookie or session token is provided, a 400 Bad Request error will be returned unless the URL query parameter `?refresh=true` is set.  To fetch an existing login flow call `/self-service/login/flows?flow=<flow_id>`.  You MUST NOT use this endpoint in client-side (Single Page Apps, ReactJS, AngularJS) nor server-side (Java Server Pages, NodeJS, PHP, Golang, ...) browser applications. Using this endpoint in these applications will make you vulnerable to a variety of CSRF attacks, including CSRF login attacks.  In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `session_aal1_required`: Multi-factor auth (e.g. 2fa) was requested but the user has no session yet. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred.  This endpoint MUST ONLY be used in scenarios such as native mobile apps (React Native, Objective C, Swift, Java, ...).  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Initialize Login Flow for APIs, Services, Apps, ...
     * @param {boolean} [refresh] Refresh a login session  If set to true, this will refresh an existing login session by asking the user to sign in again. This will reset the authenticated_at time of the session.
     * @param {string} [aal] Request a Specific AuthenticationMethod Assurance Level  Use this parameter to upgrade an existing session\&#39;s authenticator assurance level (AAL). This allows you to ask for multi-factor authentication. When an identity sign in using e.g. username+password, the AAL is 1. If you wish to \&quot;upgrade\&quot; the session\&#39;s security by asking the user to perform TOTP / WebAuth/ ... you would set this to \&quot;aal2\&quot;.
     * @param {string} [xSessionToken] The Session Token of the Identity performing the settings flow.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    initializeSelfServiceLoginFlowWithoutBrowser(refresh?: boolean, aal?: string, xSessionToken?: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SelfServiceLoginFlow>>;
    /**
     * This endpoint initializes a browser-based account recovery flow. Once initialized, the browser will be redirected to `selfservice.flows.recovery.ui_url` with the flow ID set as the query parameter `?flow=`. If a valid user session exists, the browser is returned to the configured return URL.  If this endpoint is called via an AJAX request, the response contains the recovery flow without any redirects or a 400 bad request error if the user is already authenticated.  This endpoint is NOT INTENDED for clients that do not have a browser (Chrome, Firefox, ...) as cookies are needed.  More information can be found at [Ory Kratos Account Recovery Documentation](../self-service/flows/account-recovery).
     * @summary Initialize Recovery Flow for Browsers
     * @param {string} [returnTo] The URL to return the browser to after the flow was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    initializeSelfServiceRecoveryFlowForBrowsers(returnTo?: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SelfServiceRecoveryFlow>>;
    /**
     * This endpoint initiates a recovery flow for API clients such as mobile devices, smart TVs, and so on.  If a valid provided session cookie or session token is provided, a 400 Bad Request error.  To fetch an existing recovery flow call `/self-service/recovery/flows?flow=<flow_id>`.  You MUST NOT use this endpoint in client-side (Single Page Apps, ReactJS, AngularJS) nor server-side (Java Server Pages, NodeJS, PHP, Golang, ...) browser applications. Using this endpoint in these applications will make you vulnerable to a variety of CSRF attacks.  This endpoint MUST ONLY be used in scenarios such as native mobile apps (React Native, Objective C, Swift, Java, ...).   More information can be found at [Ory Kratos Account Recovery Documentation](../self-service/flows/account-recovery).
     * @summary Initialize Recovery Flow for APIs, Services, Apps, ...
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    initializeSelfServiceRecoveryFlowWithoutBrowser(options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SelfServiceRecoveryFlow>>;
    /**
     * This endpoint initializes a browser-based user registration flow. This endpoint will set the appropriate cookies and anti-CSRF measures required for browser-based flows.  :::info  This endpoint is EXPERIMENTAL and subject to potential breaking changes in the future.  :::  If this endpoint is opened as a link in the browser, it will be redirected to `selfservice.flows.registration.ui_url` with the flow ID set as the query parameter `?flow=`. If a valid user session exists already, the browser will be redirected to `urls.default_redirect_url`.  If this endpoint is called via an AJAX request, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration!  If this endpoint is called via an AJAX request, the response contains the registration flow without a redirect.  This endpoint is NOT INTENDED for clients that do not have a browser (Chrome, Firefox, ...) as cookies are needed.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Initialize Registration Flow for Browsers
     * @param {string} [returnTo] The URL to return the browser to after the flow was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    initializeSelfServiceRegistrationFlowForBrowsers(returnTo?: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SelfServiceRegistrationFlow>>;
    /**
     * This endpoint initiates a registration flow for API clients such as mobile devices, smart TVs, and so on.  If a valid provided session cookie or session token is provided, a 400 Bad Request error will be returned unless the URL query parameter `?refresh=true` is set.  To fetch an existing registration flow call `/self-service/registration/flows?flow=<flow_id>`.  You MUST NOT use this endpoint in client-side (Single Page Apps, ReactJS, AngularJS) nor server-side (Java Server Pages, NodeJS, PHP, Golang, ...) browser applications. Using this endpoint in these applications will make you vulnerable to a variety of CSRF attacks.  In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred.  This endpoint MUST ONLY be used in scenarios such as native mobile apps (React Native, Objective C, Swift, Java, ...).  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Initialize Registration Flow for APIs, Services, Apps, ...
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    initializeSelfServiceRegistrationFlowWithoutBrowser(options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SelfServiceRegistrationFlow>>;
    /**
     * This endpoint initializes a browser-based user settings flow. Once initialized, the browser will be redirected to `selfservice.flows.settings.ui_url` with the flow ID set as the query parameter `?flow=`. If no valid Ory Kratos Session Cookie is included in the request, a login flow will be initialized.  If this endpoint is opened as a link in the browser, it will be redirected to `selfservice.flows.settings.ui_url` with the flow ID set as the query parameter `?flow=`. If no valid user session was set, the browser will be redirected to the login endpoint.  If this endpoint is called via an AJAX request, the response contains the settings flow without any redirects or a 401 forbidden error if no valid session was set.  Depending on your configuration this endpoint might return a 403 error if the session has a lower Authenticator Assurance Level (AAL) than is possible for the identity. This can happen if the identity has password + webauthn credentials (which would result in AAL2) but the session has only AAL1. If this error occurs, ask the user to sign in with the second factor (happens automatically for server-side browser flows) or change the configuration.  If this endpoint is called via an AJAX request, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `session_inactive`: No Ory Session was found - sign in a user first. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration!  This endpoint is NOT INTENDED for clients that do not have a browser (Chrome, Firefox, ...) as cookies are needed.  More information can be found at [Ory Kratos User Settings & Profile Management Documentation](../self-service/flows/user-settings).
     * @summary Initialize Settings Flow for Browsers
     * @param {string} [returnTo] The URL to return the browser to after the flow was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    initializeSelfServiceSettingsFlowForBrowsers(returnTo?: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SelfServiceSettingsFlow>>;
    /**
     * This endpoint initiates a settings flow for API clients such as mobile devices, smart TVs, and so on. You must provide a valid Ory Kratos Session Token for this endpoint to respond with HTTP 200 OK.  To fetch an existing settings flow call `/self-service/settings/flows?flow=<flow_id>`.  You MUST NOT use this endpoint in client-side (Single Page Apps, ReactJS, AngularJS) nor server-side (Java Server Pages, NodeJS, PHP, Golang, ...) browser applications. Using this endpoint in these applications will make you vulnerable to a variety of CSRF attacks.  Depending on your configuration this endpoint might return a 403 error if the session has a lower Authenticator Assurance Level (AAL) than is possible for the identity. This can happen if the identity has password + webauthn credentials (which would result in AAL2) but the session has only AAL1. If this error occurs, ask the user to sign in with the second factor or change the configuration.  In the case of an error, the `error.id` of the JSON response body can be one of:  `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `session_inactive`: No Ory Session was found - sign in a user first.  This endpoint MUST ONLY be used in scenarios such as native mobile apps (React Native, Objective C, Swift, Java, ...).  More information can be found at [Ory Kratos User Settings & Profile Management Documentation](../self-service/flows/user-settings).
     * @summary Initialize Settings Flow for APIs, Services, Apps, ...
     * @param {string} [xSessionToken] The Session Token of the Identity performing the settings flow.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    initializeSelfServiceSettingsFlowWithoutBrowser(xSessionToken?: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SelfServiceSettingsFlow>>;
    /**
     * This endpoint initializes a browser-based account verification flow. Once initialized, the browser will be redirected to `selfservice.flows.verification.ui_url` with the flow ID set as the query parameter `?flow=`.  If this endpoint is called via an AJAX request, the response contains the recovery flow without any redirects.  This endpoint is NOT INTENDED for API clients and only works with browsers (Chrome, Firefox, ...).  More information can be found at [Ory Kratos Email and Phone Verification Documentation](https://www.ory.sh/docs/kratos/selfservice/flows/verify-email-account-activation).
     * @summary Initialize Verification Flow for Browser Clients
     * @param {string} [returnTo] The URL to return the browser to after the flow was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    initializeSelfServiceVerificationFlowForBrowsers(returnTo?: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SelfServiceVerificationFlow>>;
    /**
     * This endpoint initiates a verification flow for API clients such as mobile devices, smart TVs, and so on.  To fetch an existing verification flow call `/self-service/verification/flows?flow=<flow_id>`.  You MUST NOT use this endpoint in client-side (Single Page Apps, ReactJS, AngularJS) nor server-side (Java Server Pages, NodeJS, PHP, Golang, ...) browser applications. Using this endpoint in these applications will make you vulnerable to a variety of CSRF attacks.  This endpoint MUST ONLY be used in scenarios such as native mobile apps (React Native, Objective C, Swift, Java, ...).  More information can be found at [Ory Kratos Email and Phone Verification Documentation](https://www.ory.sh/docs/kratos/selfservice/flows/verify-email-account-activation).
     * @summary Initialize Verification Flow for APIs, Services, Apps, ...
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    initializeSelfServiceVerificationFlowWithoutBrowser(options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SelfServiceVerificationFlow>>;
    /**
     * Get all Identity Schemas
     * @param {number} [perPage] Items per Page  This is the number of items per page.
     * @param {number} [page] Pagination Page
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    listIdentitySchemas(perPage?: number, page?: number, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<IdentitySchema[]>>;
    /**
     * Lists all projects you have access to.
     * @summary List All Projects
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    listProjects(options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<ProjectMetadata[]>>;
    /**
     * This endpoint is useful for:  Displaying all other sessions that belong to the logged-in user
     * @summary This endpoints returns all other active sessions that belong to the logged-in user. The current session can be retrieved by calling the `/sessions/whoami` endpoint.
     * @param {string} [xSessionToken] Set the Session Token when calling from non-browser clients. A session token has a format of &#x60;MP2YWEMeM8MxjkGKpH4dqOQ4Q4DlSPaj&#x60;.
     * @param {string} [cookie] Set the Cookie Header. This is especially useful when calling this endpoint from a server-side application. In that scenario you must include the HTTP Cookie Header which originally was included in the request to your server. An example of a session in the HTTP Cookie Header is: &#x60;ory_kratos_session&#x3D;a19iOVAbdzdgl70Rq1QZmrKmcjDtdsviCTZx7m9a9yHIUS8Wa9T7hvqyGTsLHi6Qifn2WUfpAKx9DWp0SJGleIn9vh2YF4A16id93kXFTgIgmwIOvbVAScyrx7yVl6bPZnCx27ec4WQDtaTewC1CpgudeDV2jQQnSaCP6ny3xa8qLH-QUgYqdQuoA_LF1phxgRCUfIrCLQOkolX5nv3ze_f&#x3D;&#x3D;&#x60;.  It is ok if more than one cookie are included here as all other cookies will be ignored.
     * @param {number} [perPage] Items per Page  This is the number of items per page.
     * @param {number} [page] Pagination Page
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    listSessions(xSessionToken?: string, cookie?: string, perPage?: number, page?: number, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<Session[]>>;
    /**
     * This endpoints allows you to patch individual Ory Cloud Project configuration keys for Ory\'s services (identity, permission, ...). The configuration format is fully compatible with the open source projects for the respective services (e.g. Ory Kratos for Identity, Ory Keto for Permissions).  This endpoint expects the `version` key to be set in the payload. If it is unset, it will try to import the config as if it is from the most recent version.  If you have an older version of a configuration, you should set the version key in the payload!  While this endpoint is able to process all configuration items related to features (e.g. password reset), it does not support operational configuration items (e.g. port, tracing, logging) otherwise available in the open source.  For configuration items that can not be translated to Ory Cloud, this endpoint will return a list of warnings to help you understand which parts of your config could not be processed.
     * @summary Patch an Ory Cloud Project Configuration
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {Array<JsonPatch>} [jsonPatch]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    patchProject(projectId: string, jsonPatch?: Array<JsonPatch>, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SuccessfulProjectUpdate>>;
    /**
     * !! Use with extreme caution !!  Using this API endpoint you can purge (completely delete) a project and its data. This action can not be undone and will delete ALL your data.  !! Use with extreme caution !!
     * @summary Irrecoverably Purge a Project
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    purgeProject(projectId: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<void>>;
    /**
     * This endpoint requires the user to be a member of the project with the role `OWNER`.
     * @summary Remove a member associated with this project. This also sets their invite status to `REMOVED`.
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {string} memberId Member ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    removeProjectMember(projectId: string, memberId: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<void>>;
    /**
     * This endpoint is useful for:  To forcefully logout the current user from another device or session
     * @summary Calling this endpoint invalidates the specified session. The current session cannot be revoked. Session data are not deleted.
     * @param {string} id ID is the session\&#39;s ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    revokeSession(id: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<void>>;
    /**
     * This endpoint is useful for:  To forcefully logout the current user from all other devices and sessions
     * @summary Calling this endpoint invalidates all except the current session that belong to the logged-in user. Session data are not deleted.
     * @param {string} [xSessionToken] Set the Session Token when calling from non-browser clients. A session token has a format of &#x60;MP2YWEMeM8MxjkGKpH4dqOQ4Q4DlSPaj&#x60;.
     * @param {string} [cookie] Set the Cookie Header. This is especially useful when calling this endpoint from a server-side application. In that scenario you must include the HTTP Cookie Header which originally was included in the request to your server. An example of a session in the HTTP Cookie Header is: &#x60;ory_kratos_session&#x3D;a19iOVAbdzdgl70Rq1QZmrKmcjDtdsviCTZx7m9a9yHIUS8Wa9T7hvqyGTsLHi6Qifn2WUfpAKx9DWp0SJGleIn9vh2YF4A16id93kXFTgIgmwIOvbVAScyrx7yVl6bPZnCx27ec4WQDtaTewC1CpgudeDV2jQQnSaCP6ny3xa8qLH-QUgYqdQuoA_LF1phxgRCUfIrCLQOkolX5nv3ze_f&#x3D;&#x3D;&#x60;.  It is ok if more than one cookie are included here as all other cookies will be ignored.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    revokeSessions(xSessionToken?: string, cookie?: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<RevokedSessions>>;
    /**
     * :::info  This endpoint is EXPERIMENTAL and subject to potential breaking changes in the future.  :::  Use this endpoint to complete a login flow. This endpoint behaves differently for API and browser flows.  API flows expect `application/json` to be sent in the body and responds with HTTP 200 and a application/json body with the session token on success; HTTP 410 if the original flow expired with the appropriate error messages set and optionally a `use_flow_id` parameter in the body; HTTP 400 on form validation errors.  Browser flows expect a Content-Type of `application/x-www-form-urlencoded` or `application/json` to be sent in the body and respond with a HTTP 303 redirect to the post/after login URL or the `return_to` value if it was set and if the login succeeded; a HTTP 303 redirect to the login UI URL with the flow ID containing the validation errors otherwise.  Browser flows with an accept header of `application/json` will not redirect but instead respond with HTTP 200 and a application/json body with the signed in identity and a `Set-Cookie` header on success; HTTP 303 redirect to a fresh login flow if the original flow expired with the appropriate error messages set; HTTP 400 on form validation errors.  If this endpoint is called with `Accept: application/json` in the header, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration! `browser_location_change_required`: Usually sent when an AJAX request indicates that the browser needs to open a specific URL. Most likely used in Social Sign In flows.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Submit a Login Flow
     * @param {string} flow The Login Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/login?flow&#x3D;abcde&#x60;).
     * @param {SubmitSelfServiceLoginFlowBody} submitSelfServiceLoginFlowBody
     * @param {string} [xSessionToken] The Session Token of the Identity performing the settings flow.
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    submitSelfServiceLoginFlow(flow: string, submitSelfServiceLoginFlowBody: SubmitSelfServiceLoginFlowBody, xSessionToken?: string, cookie?: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SuccessfulSelfServiceLoginWithoutBrowser>>;
    /**
     * This endpoint logs out an identity in a self-service manner.  If the `Accept` HTTP header is not set to `application/json`, the browser will be redirected (HTTP 303 See Other) to the `return_to` parameter of the initial request or fall back to `urls.default_return_to`.  If the `Accept` HTTP header is set to `application/json`, a 204 No Content response will be sent on successful logout instead.  This endpoint is NOT INTENDED for API clients and only works with browsers (Chrome, Firefox, ...). For API clients you can call the `/self-service/logout/api` URL directly with the Ory Session Token.  More information can be found at [Ory Kratos User Logout Documentation](https://www.ory.sh/docs/next/kratos/self-service/flows/user-logout).
     * @summary Complete Self-Service Logout
     * @param {string} [token] A Valid Logout Token  If you do not have a logout token because you only have a session cookie, call &#x60;/self-service/logout/urls&#x60; to generate a URL for this endpoint.
     * @param {string} [returnTo] The URL to return to after the logout was completed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    submitSelfServiceLogoutFlow(token?: string, returnTo?: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<void>>;
    /**
     * Use this endpoint to log out an identity using an Ory Session Token. If the Ory Session Token was successfully revoked, the server returns a 204 No Content response. A 204 No Content response is also sent when the Ory Session Token has been revoked already before.  If the Ory Session Token is malformed or does not exist a 403 Forbidden response will be returned.  This endpoint does not remove any HTTP Cookies - use the Browser-Based Self-Service Logout Flow instead.
     * @summary Perform Logout for APIs, Services, Apps, ...
     * @param {SubmitSelfServiceLogoutFlowWithoutBrowserBody} submitSelfServiceLogoutFlowWithoutBrowserBody
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    submitSelfServiceLogoutFlowWithoutBrowser(submitSelfServiceLogoutFlowWithoutBrowserBody: SubmitSelfServiceLogoutFlowWithoutBrowserBody, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<void>>;
    /**
     * Use this endpoint to complete a recovery flow. This endpoint behaves differently for API and browser flows and has several states:  `choose_method` expects `flow` (in the URL query) and `email` (in the body) to be sent and works with API- and Browser-initiated flows. For API clients and Browser clients with HTTP Header `Accept: application/json` it either returns a HTTP 200 OK when the form is valid and HTTP 400 OK when the form is invalid. and a HTTP 303 See Other redirect with a fresh recovery flow if the flow was otherwise invalid (e.g. expired). For Browser clients without HTTP Header `Accept` or with `Accept: text/_*` it returns a HTTP 303 See Other redirect to the Recovery UI URL with the Recovery Flow ID appended. `sent_email` is the success state after `choose_method` for the `link` method and allows the user to request another recovery email. It works for both API and Browser-initiated flows and returns the same responses as the flow in `choose_method` state. `passed_challenge` expects a `token` to be sent in the URL query and given the nature of the flow (\"sending a recovery link\") does not have any API capabilities. The server responds with a HTTP 303 See Other redirect either to the Settings UI URL (if the link was valid) and instructs the user to update their password, or a redirect to the Recover UI URL with a new Recovery Flow ID which contains an error message that the recovery link was invalid.  More information can be found at [Ory Kratos Account Recovery Documentation](../self-service/flows/account-recovery).
     * @summary Complete Recovery Flow
     * @param {string} flow The Recovery Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/recovery?flow&#x3D;abcde&#x60;).
     * @param {SubmitSelfServiceRecoveryFlowBody} submitSelfServiceRecoveryFlowBody
     * @param {string} [token] Recovery Token  The recovery token which completes the recovery request. If the token is invalid (e.g. expired) an error will be shown to the end-user.  This parameter is usually set in a link and not used by any direct API call.
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    submitSelfServiceRecoveryFlow(flow: string, submitSelfServiceRecoveryFlowBody: SubmitSelfServiceRecoveryFlowBody, token?: string, cookie?: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SelfServiceRecoveryFlow>>;
    /**
     * Use this endpoint to complete a registration flow by sending an identity\'s traits and password. This endpoint behaves differently for API and browser flows.  API flows expect `application/json` to be sent in the body and respond with HTTP 200 and a application/json body with the created identity success - if the session hook is configured the `session` and `session_token` will also be included; HTTP 410 if the original flow expired with the appropriate error messages set and optionally a `use_flow_id` parameter in the body; HTTP 400 on form validation errors.  Browser flows expect a Content-Type of `application/x-www-form-urlencoded` or `application/json` to be sent in the body and respond with a HTTP 303 redirect to the post/after registration URL or the `return_to` value if it was set and if the registration succeeded; a HTTP 303 redirect to the registration UI URL with the flow ID containing the validation errors otherwise.  Browser flows with an accept header of `application/json` will not redirect but instead respond with HTTP 200 and a application/json body with the signed in identity and a `Set-Cookie` header on success; HTTP 303 redirect to a fresh login flow if the original flow expired with the appropriate error messages set; HTTP 400 on form validation errors.  If this endpoint is called with `Accept: application/json` in the header, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `session_already_available`: The user is already signed in. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration! `browser_location_change_required`: Usually sent when an AJAX request indicates that the browser needs to open a specific URL. Most likely used in Social Sign In flows.  More information can be found at [Ory Kratos User Login](https://www.ory.sh/docs/kratos/self-service/flows/user-login) and [User Registration Documentation](https://www.ory.sh/docs/kratos/self-service/flows/user-registration).
     * @summary Submit a Registration Flow
     * @param {string} flow The Registration Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/registration?flow&#x3D;abcde&#x60;).
     * @param {SubmitSelfServiceRegistrationFlowBody} submitSelfServiceRegistrationFlowBody
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    submitSelfServiceRegistrationFlow(flow: string, submitSelfServiceRegistrationFlowBody: SubmitSelfServiceRegistrationFlowBody, cookie?: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SuccessfulSelfServiceRegistrationWithoutBrowser>>;
    /**
     * Use this endpoint to complete a settings flow by sending an identity\'s updated password. This endpoint behaves differently for API and browser flows.  API-initiated flows expect `application/json` to be sent in the body and respond with HTTP 200 and an application/json body with the session token on success; HTTP 303 redirect to a fresh settings flow if the original flow expired with the appropriate error messages set; HTTP 400 on form validation errors. HTTP 401 when the endpoint is called without a valid session token. HTTP 403 when `selfservice.flows.settings.privileged_session_max_age` was reached or the session\'s AAL is too low. Implies that the user needs to re-authenticate.  Browser flows without HTTP Header `Accept` or with `Accept: text/_*` respond with a HTTP 303 redirect to the post/after settings URL or the `return_to` value if it was set and if the flow succeeded; a HTTP 303 redirect to the Settings UI URL with the flow ID containing the validation errors otherwise. a HTTP 303 redirect to the login endpoint when `selfservice.flows.settings.privileged_session_max_age` was reached or the session\'s AAL is too low.  Browser flows with HTTP Header `Accept: application/json` respond with HTTP 200 and a application/json body with the signed in identity and a `Set-Cookie` header on success; HTTP 303 redirect to a fresh login flow if the original flow expired with the appropriate error messages set; HTTP 401 when the endpoint is called without a valid session cookie. HTTP 403 when the page is accessed without a session cookie or the session\'s AAL is too low. HTTP 400 on form validation errors.  Depending on your configuration this endpoint might return a 403 error if the session has a lower Authenticator Assurance Level (AAL) than is possible for the identity. This can happen if the identity has password + webauthn credentials (which would result in AAL2) but the session has only AAL1. If this error occurs, ask the user to sign in with the second factor (happens automatically for server-side browser flows) or change the configuration.  If this endpoint is called with a `Accept: application/json` HTTP header, the response contains the flow without a redirect. In the case of an error, the `error.id` of the JSON response body can be one of:  `session_refresh_required`: The identity requested to change something that needs a privileged session. Redirect the identity to the login init endpoint with query parameters `?refresh=true&return_to=<the-current-browser-url>`, or initiate a refresh login flow otherwise. `security_csrf_violation`: Unable to fetch the flow because a CSRF violation occurred. `session_inactive`: No Ory Session was found - sign in a user first. `security_identity_mismatch`: The flow was interrupted with `session_refresh_required` but apparently some other identity logged in instead. `security_identity_mismatch`: The requested `?return_to` address is not allowed to be used. Adjust this in the configuration! `browser_location_change_required`: Usually sent when an AJAX request indicates that the browser needs to open a specific URL. Most likely used in Social Sign In flows.  More information can be found at [Ory Kratos User Settings & Profile Management Documentation](../self-service/flows/user-settings).
     * @summary Complete Settings Flow
     * @param {string} flow The Settings Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/settings?flow&#x3D;abcde&#x60;).
     * @param {SubmitSelfServiceSettingsFlowBody} submitSelfServiceSettingsFlowBody
     * @param {string} [xSessionToken] The Session Token of the Identity performing the settings flow.
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    submitSelfServiceSettingsFlow(flow: string, submitSelfServiceSettingsFlowBody: SubmitSelfServiceSettingsFlowBody, xSessionToken?: string, cookie?: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SelfServiceSettingsFlow>>;
    /**
     * Use this endpoint to complete a verification flow. This endpoint behaves differently for API and browser flows and has several states:  `choose_method` expects `flow` (in the URL query) and `email` (in the body) to be sent and works with API- and Browser-initiated flows. For API clients and Browser clients with HTTP Header `Accept: application/json` it either returns a HTTP 200 OK when the form is valid and HTTP 400 OK when the form is invalid and a HTTP 303 See Other redirect with a fresh verification flow if the flow was otherwise invalid (e.g. expired). For Browser clients without HTTP Header `Accept` or with `Accept: text/_*` it returns a HTTP 303 See Other redirect to the Verification UI URL with the Verification Flow ID appended. `sent_email` is the success state after `choose_method` when using the `link` method and allows the user to request another verification email. It works for both API and Browser-initiated flows and returns the same responses as the flow in `choose_method` state. `passed_challenge` expects a `token` to be sent in the URL query and given the nature of the flow (\"sending a verification link\") does not have any API capabilities. The server responds with a HTTP 303 See Other redirect either to the Settings UI URL (if the link was valid) and instructs the user to update their password, or a redirect to the Verification UI URL with a new Verification Flow ID which contains an error message that the verification link was invalid.  More information can be found at [Ory Kratos Email and Phone Verification Documentation](https://www.ory.sh/docs/kratos/selfservice/flows/verify-email-account-activation).
     * @summary Complete Verification Flow
     * @param {string} flow The Verification Flow ID  The value for this parameter comes from &#x60;flow&#x60; URL Query parameter sent to your application (e.g. &#x60;/verification?flow&#x3D;abcde&#x60;).
     * @param {SubmitSelfServiceVerificationFlowBody} submitSelfServiceVerificationFlowBody
     * @param {string} [token] Verification Token  The verification token which completes the verification request. If the token is invalid (e.g. expired) an error will be shown to the end-user.  This parameter is usually set in a link and not used by any direct API call.
     * @param {string} [cookie] HTTP Cookies  When using the SDK in a browser app, on the server side you must include the HTTP Cookie Header sent by the client to your server here. This ensures that CSRF and session cookies are respected.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    submitSelfServiceVerificationFlow(flow: string, submitSelfServiceVerificationFlowBody: SubmitSelfServiceVerificationFlowBody, token?: string, cookie?: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SelfServiceVerificationFlow>>;
    /**
     * Uses the HTTP Headers in the GET request to determine (e.g. by using checking the cookies) who is authenticated. Returns a session object in the body or 401 if the credentials are invalid or no credentials were sent. Additionally when the request it successful it adds the user ID to the \'X-Kratos-Authenticated-Identity-Id\' header in the response.  If you call this endpoint from a server-side application, you must forward the HTTP Cookie Header to this endpoint:  ```js pseudo-code example router.get(\'/protected-endpoint\', async function (req, res) { const session = await client.toSession(undefined, req.header(\'cookie\'))  console.log(session) }) ```  When calling this endpoint from a non-browser application (e.g. mobile app) you must include the session token:  ```js pseudo-code example ... const session = await client.toSession(\"the-session-token\")  console.log(session) ```  Depending on your configuration this endpoint might return a 403 status code if the session has a lower Authenticator Assurance Level (AAL) than is possible for the identity. This can happen if the identity has password + webauthn credentials (which would result in AAL2) but the session has only AAL1. If this error occurs, ask the user to sign in with the second factor or change the configuration.  This endpoint is useful for:  AJAX calls. Remember to send credentials and set up CORS correctly! Reverse proxies and API Gateways Server-side calls - use the `X-Session-Token` header!  This endpoint authenticates users by checking  if the `Cookie` HTTP header was set containing an Ory Kratos Session Cookie; if the `Authorization: bearer <ory-session-token>` HTTP header was set with a valid Ory Kratos Session Token; if the `X-Session-Token` HTTP header was set with a valid Ory Kratos Session Token.  If none of these headers are set or the cooke or token are invalid, the endpoint returns a HTTP 401 status code.  As explained above, this request may fail due to several reasons. The `error.id` can be one of:  `session_inactive`: No active session was found in the request (e.g. no Ory Session Cookie / Ory Session Token). `session_aal2_required`: An active session was found but it does not fulfil the Authenticator Assurance Level, implying that the session must (e.g.) authenticate the second factor.
     * @summary Check Who the Current HTTP Session Belongs To
     * @param {string} [xSessionToken] Set the Session Token when calling from non-browser clients. A session token has a format of &#x60;MP2YWEMeM8MxjkGKpH4dqOQ4Q4DlSPaj&#x60;.
     * @param {string} [cookie] Set the Cookie Header. This is especially useful when calling this endpoint from a server-side application. In that scenario you must include the HTTP Cookie Header which originally was included in the request to your server. An example of a session in the HTTP Cookie Header is: &#x60;ory_kratos_session&#x3D;a19iOVAbdzdgl70Rq1QZmrKmcjDtdsviCTZx7m9a9yHIUS8Wa9T7hvqyGTsLHi6Qifn2WUfpAKx9DWp0SJGleIn9vh2YF4A16id93kXFTgIgmwIOvbVAScyrx7yVl6bPZnCx27ec4WQDtaTewC1CpgudeDV2jQQnSaCP6ny3xa8qLH-QUgYqdQuoA_LF1phxgRCUfIrCLQOkolX5nv3ze_f&#x3D;&#x3D;&#x60;.  It is ok if more than one cookie are included here as all other cookies will be ignored.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    toSession(xSessionToken?: string, cookie?: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<Session>>;
    /**
     * This endpoints allows you to update the Ory Cloud Project configuration for individual services (identity, permission, ...). The configuration is fully compatible with the open source projects for the respective services (e.g. Ory Kratos for Identity, Ory Keto for Permissions).  This endpoint expects the `version` key to be set in the payload. If it is unset, it will try to import the config as if it is from the most recent version.  If you have an older version of a configuration, you should set the version key in the payload!  While this endpoint is able to process all configuration items related to features (e.g. password reset), it does not support operational configuration items (e.g. port, tracing, logging) otherwise available in the open source.  For configuration items that can not be translated to Ory Cloud, this endpoint will return a list of warnings to help you understand which parts of your config could not be processed.  Be aware that updating any service\'s configuration will completely override your current configuration for that service!
     * @summary Update an Ory Cloud Project Configuration
     * @param {string} projectId Project ID  The project\&#39;s ID.
     * @param {UpdateProject} [updateProject]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V0alpha2Api
     */
    updateProject(projectId: string, updateProject?: UpdateProject, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SuccessfulProjectUpdate>>;
}
/**
 * WriteApi - axios parameter creator
 * @export
 */
export declare const WriteApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     * Use this endpoint to create a relation tuple.
     * @summary Create a Relation Tuple
     * @param {RelationQuery} [relationQuery]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    createRelationTuple: (relationQuery?: RelationQuery, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * Use this endpoint to delete relation tuples
     * @summary Delete Relation Tuples
     * @param {string} [namespace] Namespace of the Relation Tuple
     * @param {string} [object] Object of the Relation Tuple
     * @param {string} [relation] Relation of the Relation Tuple
     * @param {string} [subjectId] SubjectID of the Relation Tuple
     * @param {string} [subjectSetNamespace] Namespace of the Subject Set
     * @param {string} [subjectSetObject] Object of the Subject Set
     * @param {string} [subjectSetRelation] Relation of the Subject Set
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    deleteRelationTuples: (namespace?: string, object?: string, relation?: string, subjectId?: string, subjectSetNamespace?: string, subjectSetObject?: string, subjectSetRelation?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     * Use this endpoint to patch one or more relation tuples.
     * @summary Patch Multiple Relation Tuples
     * @param {Array<PatchDelta>} [patchDelta]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    patchRelationTuples: (patchDelta?: Array<PatchDelta>, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * WriteApi - functional programming interface
 * @export
 */
export declare const WriteApiFp: (configuration?: Configuration) => {
    /**
     * Use this endpoint to create a relation tuple.
     * @summary Create a Relation Tuple
     * @param {RelationQuery} [relationQuery]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    createRelationTuple(relationQuery?: RelationQuery, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<RelationQuery>>;
    /**
     * Use this endpoint to delete relation tuples
     * @summary Delete Relation Tuples
     * @param {string} [namespace] Namespace of the Relation Tuple
     * @param {string} [object] Object of the Relation Tuple
     * @param {string} [relation] Relation of the Relation Tuple
     * @param {string} [subjectId] SubjectID of the Relation Tuple
     * @param {string} [subjectSetNamespace] Namespace of the Subject Set
     * @param {string} [subjectSetObject] Object of the Subject Set
     * @param {string} [subjectSetRelation] Relation of the Subject Set
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    deleteRelationTuples(namespace?: string, object?: string, relation?: string, subjectId?: string, subjectSetNamespace?: string, subjectSetObject?: string, subjectSetRelation?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>>;
    /**
     * Use this endpoint to patch one or more relation tuples.
     * @summary Patch Multiple Relation Tuples
     * @param {Array<PatchDelta>} [patchDelta]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    patchRelationTuples(patchDelta?: Array<PatchDelta>, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>>;
};
/**
 * WriteApi - factory interface
 * @export
 */
export declare const WriteApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     * Use this endpoint to create a relation tuple.
     * @summary Create a Relation Tuple
     * @param {RelationQuery} [relationQuery]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    createRelationTuple(relationQuery?: RelationQuery, options?: any): AxiosPromise<RelationQuery>;
    /**
     * Use this endpoint to delete relation tuples
     * @summary Delete Relation Tuples
     * @param {string} [namespace] Namespace of the Relation Tuple
     * @param {string} [object] Object of the Relation Tuple
     * @param {string} [relation] Relation of the Relation Tuple
     * @param {string} [subjectId] SubjectID of the Relation Tuple
     * @param {string} [subjectSetNamespace] Namespace of the Subject Set
     * @param {string} [subjectSetObject] Object of the Subject Set
     * @param {string} [subjectSetRelation] Relation of the Subject Set
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    deleteRelationTuples(namespace?: string, object?: string, relation?: string, subjectId?: string, subjectSetNamespace?: string, subjectSetObject?: string, subjectSetRelation?: string, options?: any): AxiosPromise<void>;
    /**
     * Use this endpoint to patch one or more relation tuples.
     * @summary Patch Multiple Relation Tuples
     * @param {Array<PatchDelta>} [patchDelta]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    patchRelationTuples(patchDelta?: Array<PatchDelta>, options?: any): AxiosPromise<void>;
};
/**
 * WriteApi - interface
 * @export
 * @interface WriteApi
 */
export interface WriteApiInterface {
    /**
     * Use this endpoint to create a relation tuple.
     * @summary Create a Relation Tuple
     * @param {RelationQuery} [relationQuery]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WriteApiInterface
     */
    createRelationTuple(relationQuery?: RelationQuery, options?: AxiosRequestConfig): AxiosPromise<RelationQuery>;
    /**
     * Use this endpoint to delete relation tuples
     * @summary Delete Relation Tuples
     * @param {string} [namespace] Namespace of the Relation Tuple
     * @param {string} [object] Object of the Relation Tuple
     * @param {string} [relation] Relation of the Relation Tuple
     * @param {string} [subjectId] SubjectID of the Relation Tuple
     * @param {string} [subjectSetNamespace] Namespace of the Subject Set
     * @param {string} [subjectSetObject] Object of the Subject Set
     * @param {string} [subjectSetRelation] Relation of the Subject Set
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WriteApiInterface
     */
    deleteRelationTuples(namespace?: string, object?: string, relation?: string, subjectId?: string, subjectSetNamespace?: string, subjectSetObject?: string, subjectSetRelation?: string, options?: AxiosRequestConfig): AxiosPromise<void>;
    /**
     * Use this endpoint to patch one or more relation tuples.
     * @summary Patch Multiple Relation Tuples
     * @param {Array<PatchDelta>} [patchDelta]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WriteApiInterface
     */
    patchRelationTuples(patchDelta?: Array<PatchDelta>, options?: AxiosRequestConfig): AxiosPromise<void>;
}
/**
 * WriteApi - object-oriented interface
 * @export
 * @class WriteApi
 * @extends {BaseAPI}
 */
export declare class WriteApi extends BaseAPI implements WriteApiInterface {
    /**
     * Use this endpoint to create a relation tuple.
     * @summary Create a Relation Tuple
     * @param {RelationQuery} [relationQuery]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WriteApi
     */
    createRelationTuple(relationQuery?: RelationQuery, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<RelationQuery>>;
    /**
     * Use this endpoint to delete relation tuples
     * @summary Delete Relation Tuples
     * @param {string} [namespace] Namespace of the Relation Tuple
     * @param {string} [object] Object of the Relation Tuple
     * @param {string} [relation] Relation of the Relation Tuple
     * @param {string} [subjectId] SubjectID of the Relation Tuple
     * @param {string} [subjectSetNamespace] Namespace of the Subject Set
     * @param {string} [subjectSetObject] Object of the Subject Set
     * @param {string} [subjectSetRelation] Relation of the Subject Set
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WriteApi
     */
    deleteRelationTuples(namespace?: string, object?: string, relation?: string, subjectId?: string, subjectSetNamespace?: string, subjectSetObject?: string, subjectSetRelation?: string, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<void>>;
    /**
     * Use this endpoint to patch one or more relation tuples.
     * @summary Patch Multiple Relation Tuples
     * @param {Array<PatchDelta>} [patchDelta]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WriteApi
     */
    patchRelationTuples(patchDelta?: Array<PatchDelta>, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<void>>;
}
